function tcjsSyntaxCheck(checker, source) {
    try {
        let syntax = esprima.parse(source, { tolerant: true });
        if (syntax.errors) {
            for (let index = 0; index < syntax.errors.length; ++index) {
                let e = syntax.errors[index];
                let message = e.message.replace(/^Line\ [0-9]*\:\ /, '')
                checker.onError(e.lineNumber, message);
            }
        }
    } catch (e) {
        let message = e.message.replace(/^Line\ [0-9]*\:\ /, '');
        checker.onError(e.lineNumber, message);
        return false;
    }
    return true;
}

function tcjsGetTokens(container, source) {
    try {
        let tokens = esprima.tokenize(source, { range: true, comment: true });
        for (let i = 0; i < tokens.length; ++i) {
            let token = tokens[i];
            container.addToken(token.type, token.value, token.range[0], token.range[1]);
        }
    } catch (e) {
        return null;
    }
}