#! perl -w

# Licensed Materials - Property of HCL and/or IBM
# Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
# Copyright IBM Corporation 1999, 2016. All Rights Reserved.
#
# U.S. Government Users Restricted Rights -  Use, duplication or 
# disclosure restricted by GSA ADP Schedule.



# Intended usage: perl chdir_run.pl directory command ...
#
# A platform independent way of running a double command on one Makefile line.
# eg:
#    cd $DIR ; $CMD   (Unix)
#    cd $DIR & $CMD   (Win NT)

# Unbuffer stdout
$| = 1;

if( scalar( @ARGV ) < 2 )
{
    print STDERR "Usage: ${0} directory command ...\n";
    exit 1;
}

$dir = shift @ARGV;

chdir $dir or die "chdir [$dir] failed: $!\n";

$status = system( "@ARGV" );

exit $status if( $status & 0xFF );
exit $status >> 8;
