# Licensed Materials - Property of HCL and/or IBM
# Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
# Copyright IBM Corporation 1999, 2016. All Rights Reserved.
#
# U.S. Government Users Restricted Rights -  Use, duplication or 
# disclosure restricted by GSA ADP Schedule.



require 'tools/registry.pl';

$commonKey = 'HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\VisualStudio\\SxS\\VS7';
$commonSub = '15.0';

$vcKey     = "$commonKey\\Setup\\VC";
$vcSub     = 'ProductDir';

unless( $commonRoot = &ReadRegEntry( $commonKey, $commonSub, '' ) )
{
    print STDERR "Can't find registry VC location '$commonSub' at\n"
	       . "$commonKey\n\n";
    exit 1;
}

$vcRoot = "$commonRoot" . "VC\\Tools\\MSVC\\14.13.26128\\bin\\Hostx64\\x64";

$platformSDKKey = 'HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\Windows Kits\\Installed Roots';
$sdkSub10		= 'KitsRoot10';
$sdkSub81		= 'KitsRoot81';


unless( $sdkRoot10 = &ReadRegEntry( $platformSDKKey, $sdkSub10, '' ) )
{
    print STDERR ">> Can't find registry VC location '$sdkSub10' at\n$platformSDKKey\n\n";
    exit 1;
}


#$ENV{'INCLUDE'} =  "$vcRoot\\INCLUDE"
#		. ";$vcRoot\\ATLMFC\\INCLUDE"
#		. ";$sdkRoot\\INCLUDE\\um"
#		. ";$sdkRoot\\INCLUDE\\shared";

#$ENV{'LIB'}     =  "$vcRoot\\LIB"
#		. ";$vcRoot\\ATLMFC\\LIB"
#		. ";$sdkRoot\\LIB\\win8\\um\\x86";

#$ENV{'PATH'}    = "$commonRoot"
#		. ";$vcRoot\\BIN"
#		. ";$sdkRoot\\BIN"
#		. ";$ENV{'PATH'}";


$include_opt  = '/I';
@make_args    = ( '/nologo', '/f', '../src/main.nmk' );
$object_ext   = '.OBJ';
$preprocessor = "cl /nologo /EP /P";
$target_base  = 'win';




$supported    = 'Yes';