/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTActiveConnector_h__
#define __RTActiveConnector_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTLayerConnector_h__
#include <RTLayerConnector.h>
#endif

class RTConnector_Actor;

class RTActiveConnector : public RTLayerConnector
{
public:
    explicit              RTActiveConnector( RTConnector_Actor * );
    virtual               ~RTActiveConnector( void );

    virtual RTLayerData * _registerSAP( RTController *,
					RTProtocol   *,
					const char   * ) override;

    virtual RTLayerData * _registerSPP( RTController *,
					RTProtocol   *,
					const char   * ) override;

    virtual void          _enumerate( void ) const override;

private:
    RTConnector_Actor * connector;

    // unavailable methods
    RTActiveConnector( const RTActiveConnector & );
    RTActiveConnector & operator=( const RTActiveConnector & );
}; //lint !e1712

#endif // __RTActiveConnector_h__
