/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTByteBlock_h__
#define __RTByteBlock_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTDataObject_h__
#include <RTDataObject.h>
#endif

class RTByteBlock : public RTDataObject
{
public:
    int                     length;
    char *                  Contents;

			    RTByteBlock( void );
			    RTByteBlock( int          size,
					 const void * contents );
			    RTByteBlock( const RTByteBlock & );
    virtual                 ~RTByteBlock( void );

    RTByteBlock           & operator=( const RTByteBlock & );

    RTS_INLINE operator void       * ( void );
    RTS_INLINE operator const void * ( void ) const;

    virtual int             operator==( const RTDataObject & ) const override;

    virtual const RTObject_class * getClassData( void ) const override;
    static  const RTObject_class   classData;

#define RTType_RTByteBlock ( RTByteBlock::classData )
};

struct RTTypedValue_RTByteBlock
{
    const void           * data;
    const RTObject_class * type;

    RTS_INLINE RTTypedValue_RTByteBlock( const RTByteBlock    & ); //lint !e1931
    RTS_INLINE RTTypedValue_RTByteBlock( const RTByteBlock    &,
					 const RTObject_class * );
}; //lint !e1712

#if RTS_INLINES
#include <RTByteBlock.inl>
#endif

#endif // __RTByteBlock_h__
