/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTByteBlock_inl__
#define __RTByteBlock_inl__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTByteBlock_h__
#include <RTByteBlock.h>
#endif

RTS_INLINE RTByteBlock::operator void * ( void )
{
    return Contents;
}

RTS_INLINE RTByteBlock::operator const void * ( void ) const
{
    return Contents;
}

RTS_INLINE
RTTypedValue_RTByteBlock::
RTTypedValue_RTByteBlock( const RTByteBlock & _value )
    : data( &_value )
    , type( _value.getClassData() )
{
}

RTS_INLINE
RTTypedValue_RTByteBlock::
RTTypedValue_RTByteBlock( const RTByteBlock    & _value,
			  const RTObject_class * _type )
    : data( &_value )
    , type( _type   )
{
}

#endif // __RTByteBlock_inl__
