/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTCachedString_inl__
#define __RTCachedString_inl__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTCachedString_h__
#include <RTCachedString.h>
#endif

#ifndef __RTMemoryUtil_h__
#include <RTMemoryUtil.h>
#endif

RTS_INLINE RTCachedString::RTCachedString( void )
    : _entry( nullptr )
{
}

RTS_INLINE RTCachedString::operator const char *( void ) const
{
    return ( _entry != nullptr ) ? _entry->value
				    : nullptr;
}

RTS_INLINE int RTCachedString::operator==( const char * string ) const
{
    return string != nullptr
	&& _entry != nullptr
	&& RTMemoryUtil::strcmp( _entry->value, string ) == 0;
}

RTS_INLINE int RTCachedString::operator!=( const char * string ) const
{
    return operator==( string ) == 0;
}

RTS_INLINE int RTCachedString::operator==( const RTCachedString & rhs ) const
{
    return operator==( rhs.operator const char *() );
}

RTS_INLINE int RTCachedString::operator!=( const RTCachedString & rhs ) const
{
    return operator!=( rhs.operator const char *() );
}

#endif // __RTCachedString_inl__
