/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTDataObject_inl__
#define __RTDataObject_inl__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTDataObject_h__
#include <RTDataObject.h>
#endif

RTS_INLINE int RTDataObject::operator!=( const RTDataObject & o ) const
{
    return operator==( o ) == 0;
}

RTS_INLINE
RTTypedValue_RTDataObject::
RTTypedValue_RTDataObject( const RTDataObject & _value )
    : data( &_value )
    , type( _value.getClassData() )
{
}

RTS_INLINE
RTTypedValue_RTDataObject::
RTTypedValue_RTDataObject( const RTDataObject   & _value,
			   const RTObject_class * _type )
    : data( &_value )
    , type( _type   )
{
}

#endif // __RTDataObject_inl__
