/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTDictionary_inl__
#define __RTDictionary_inl__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTDictionary_h__
#include <RTDictionary.h>
#endif

RTS_INLINE unsigned RTDictionary::size( void ) const
{
    return _used;
}

RTS_INLINE int RTDictionary::add( const RTAssociation & assoc )
{
    return atPut( assoc.key, assoc.value );
}

RTS_INLINE RTDictionary::Iterator::Iterator( void )
    : _index( 0 )
{
}

RTS_INLINE RTDictionary::Iterator::~Iterator( void )
{
}

RTS_INLINE void RTDictionary::Iterator::reset( void )
{
    _index = 0;
}

#endif // __RTDictionary_inl__
