/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTDynamicStringOutBuffer_h__
#define __RTDynamicStringOutBuffer_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTOBuffer_h__
#include <RTOBuffer.h>
#endif

#ifndef RTUseSTL
#error RTDynamicStringOutBuffer requires STL support, but RTUseSTL is not defined.
#endif // RTUseSTL

#include <string>

/** A dynamic string buffer. */
class RTDynamicStringOutBuffer : public RTOBuffer
{
public:
	RTDynamicStringOutBuffer( );
    virtual ~RTDynamicStringOutBuffer( void );

    virtual int write( const char * data, int size ) override;
    virtual int flush( void ) override;

    /** Get a pointer to the buffer string (owned by this buffer).
	 @return Pointer to the buffer string
	 */
    const char* getString();

private:
    std::string buffer;

private:
    // unavailable methods
    RTDynamicStringOutBuffer( const RTDynamicStringOutBuffer & );
    RTDynamicStringOutBuffer & operator=( const RTDynamicStringOutBuffer & );
}; //lint !e1712

#endif // __RTDynamicStringOutBuffer_h__
