/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTExceptionSignal_inl__
#define __RTExceptionSignal_inl__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTExceptionSignal_h__
#include <RTExceptionSignal.h>
#endif

#ifndef __RTProtocol_h__
#include <RTProtocol.h>
#endif

#ifndef __RTTypedValue_h__
#include <RTTypedValue.h>
#endif

RTS_INLINE RTExceptionSignal::RTExceptionSignal( RTProtocol * port, int signal )
    : _port  ( port                      )
    , _signal( signal                    )
    , _data  ( nullptr                   )
    , _type  ( nullptr                   )
{
}

RTS_INLINE RTExceptionSignal::RTExceptionSignal( RTProtocol         * port,
						 int                  signal,
						 const RTTypedValue & value )
    : _port  ( port       )
    , _signal( signal     )
    , _data  ( value.data )
    , _type  ( value.type )
{
}

RTS_INLINE RTExceptionSignal::~RTExceptionSignal( void )
{
#ifdef _lint
    _port = nullptr;
    _data = nullptr;
    _type = nullptr;
#endif
}

RTS_INLINE int RTExceptionSignal::raise( void )
{
    return _port->raise( _signal, _data, _type );
}

#endif // __RTExceptionSignal_inl__
