/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTFieldOffset_h__
#define __RTFieldOffset_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTConfig_h__
#include <RTConfig.h>
#endif

#include <stddef.h>

typedef size_t RTFieldOffset; // Used for storing byte offset for a field, and byte size of types

#define RTOffsetOf( type, field ) \
	( ( reinterpret_cast<RTFieldOffset>(reinterpret_cast<char *>(&( (reinterpret_cast<type *>(sizeof( type )))->field ) )) \
			- sizeof( type )) )

#define RTObjectOf( type, offset, object ) \
    ( reinterpret_cast<type *>( (reinterpret_cast<char *>(object)) + (offset) ) )

#define RTConstObjectOf( type, offset, object ) \
    ( reinterpret_cast<const type *>( (reinterpret_cast<const char *>(object)) + (offset) ) )

#endif // __RTFieldOffset_h__
