/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTInSignal_inl__
#define __RTInSignal_inl__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTInSignal_h__
#include <RTInSignal.h>
#endif

#ifndef __RTProtocol_h__
#include <RTProtocol.h>
#endif

RTS_INLINE RTInSignal::RTInSignal( RTProtocol * port, int signal )
    : _port  ( port   )
    , _signal( signal )
{
}

RTS_INLINE RTInSignal::~RTInSignal( void )
{
#ifdef _lint
    _port = nullptr;
#endif
}

RTS_INLINE int RTInSignal::purge( void )
{
    return _port->purge( _signal );
}

RTS_INLINE int RTInSignal::purgeAt( int index )
{
    return _port->purgeAt( _signal, index );
}

RTS_INLINE int RTInSignal::recall( int front )
{
    return _port->recall( _signal, front );
}

RTS_INLINE int RTInSignal::recallAt( int index, int front )
{
    return _port->recallAt( _signal, index, front );
}

RTS_INLINE int RTInSignal::recallAll( int front )
{
    return _port->recallAll( _signal, front );
}

RTS_INLINE int RTInSignal::recallAllAt( int index, int front )
{
    return _port->recallAllAt( _signal, index, front );
}

#endif // __RTInSignal_inl__
