/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTJsonEncoding_h__
#define __RTJsonEncoding_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#include <RTAsciiEncoding.h>

#if OBJECT_ENCODE

class RTOBuffer;
class RTMessage;

class RTJsonEncoding : public RTAsciiEncoding
{
public:
    explicit    RTJsonEncoding( RTOBuffer * );
    virtual     ~RTJsonEncoding( void );

    virtual int put( const void *, const RTObject_class * ) override;

    virtual int put_char( char ) override;

    virtual int put_msg( const RTMessage*);

    virtual int put_array( const void *, int, const RTObject_class * ) override;

protected:
    int putFields( const void *, const RTObject_class *, int & first ) override;

private:
    // unavailable methods
    RTJsonEncoding( const RTJsonEncoding & );
    RTJsonEncoding & operator=( const RTJsonEncoding & );
}; //lint !e1712

#endif // OBJECT_ENCODE

#endif // __RTJsonEncoding_h__
