/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTLog_inl__
#define __RTLog_inl__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTLog_h__
#include <RTLog.h>
#endif

#ifndef __RTTypedValue_h__
#include <RTTypedValue.h>
#endif

RTS_INLINE Log::Base::Base( void )
    : RTProtocol()
    , file( 1 )
{
}

RTS_INLINE Log::Base::~Base( void )
{
}

RTS_INLINE void Log::Base::cr( void )
{
    crtab( 0 );
}

#if OBJECT_ENCODE

RTS_INLINE void Log::Base::log( const RTTypedValue & info )
{
    log( info.data, info.type );
}

RTS_INLINE void Log::Base::show( const RTTypedValue & info )
{
    show( info.data, info.type );
}

#endif

#endif // __RTLog_inl__
