/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTMain_inl__
#define __RTMain_inl__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTActorRef_h__
#include <RTActorRef.h>
#endif

#ifndef __RTMain_h__
#include <RTMain.h>
#endif

#ifndef __RTSystemDescriptor_h__
#include <RTSystemDescriptor.h>
#endif

RTS_INLINE const RTSystemDescriptor * RTMain::systemInfo( void )
{
    return _system;
}

RTS_INLINE int RTMain::argCount( void )
{
    return _argc;
}

RTS_INLINE const char * const * RTMain::argStrings( void )
{
    return _argv;
}

#if ! USE_THREADS
RTS_INLINE void RTMain::lock( void )
{
}

RTS_INLINE void RTMain::unlock( void )
{
}
#endif // ! USE_THREADS

RTS_INLINE RTController * RTMain::controller( void )
{
    return _controller;
}

RTS_INLINE RTActor * RTMain::topActor( void )
{
    return _topReference != nullptr
	? (*_topReference)[ 0 ]
	: nullptr;
}

RTS_INLINE RTActorRef * RTMain::topReference( void )
{
    return _topReference;
}

#endif // __RTMain_inl__
