/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTMemoryInBuffer_h__
#define __RTMemoryInBuffer_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTIBuffer_h__
#include <RTIBuffer.h>
#endif

class RTMemoryInBuffer : public RTIBuffer
{
public:
		RTMemoryInBuffer( const char *, int size );
    virtual     ~RTMemoryInBuffer( void );

    virtual int get( char & ) override;

private:
    const char * memory;
    int          size;

private:
    // unavailable methods
    RTMemoryInBuffer( const RTMemoryInBuffer & );
    RTMemoryInBuffer & operator=( const RTMemoryInBuffer & );
}; //lint !e1712

#endif // __RTMemoryInBuffer_h__
