/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTMemoryOutBuffer_h__
#define __RTMemoryOutBuffer_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTOBuffer_h__
#include <RTOBuffer.h>
#endif

class RTMemoryOutBuffer : public RTOBuffer
{
public:
		RTMemoryOutBuffer( char *, int size );
    virtual     ~RTMemoryOutBuffer( void );

    virtual int write( const char * data, int size ) override;
    virtual int flush( void ) override;

private:
    char * memory;
    int    size;

private:
    // unavailable methods
    RTMemoryOutBuffer( const RTMemoryOutBuffer & );
    RTMemoryOutBuffer & operator=( const RTMemoryOutBuffer & );
}; //lint !e1712

#endif // __RTMemoryOutBuffer_h__
