/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTMemoryUtil_h__
#define __RTMemoryUtil_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTConfig_h__
#include <RTConfig.h>
#endif

class RTMemoryUtil
{
public:
    static int          memcmp( const void *, const void *, int );
    static void         memcpy( void *, const void *, int );
    static void       * memdup( const void *, int );
    static void         memset( void *, int val, int len );

    static int          atoi( const char * );
    static const char * strchr( const char *, char );
    static int          strcmp( const char *, const char *, int len = -1 );
    static void         strcpy( char *, const char *, int len = -1 );
    static char       * strdup( const char *, int len = -1 );
    static int          strlen( const char * );

    static const char * _getenv( const char * );
};

#endif // __RTMemoryUtil_h__
