/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTMessageQ_inl__
#define __RTMessageQ_inl__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTMessage_h__
#include <RTMessage.h>
#endif

#ifndef __RTMessageQ_h__
#include <RTMessageQ.h>
#endif

RTS_INLINE void RTMessageQ::appendFrom( RTMessageQ & other )
{
    if( head == nullptr ) // queue is empty
	head = other.head;
    else
	tail->next = other.head;

    tail = other.tail;

    other.head = nullptr;
    other.tail = nullptr;
}

RTS_INLINE int RTMessageQ::isEmpty( void ) const
{
    return head == nullptr;
}

RTS_INLINE void RTMessageQ::nqTail( RTMessage * msg )
{
    if( tail == nullptr ) // queue is empty
	head = msg;
    else
	tail->next = msg; // add to end

    tail = msg;
    msg->next = nullptr;
}

RTS_INLINE RTMessage * RTMessageQ::dqHead( void )
{
    RTMessage * msg = head;

    if( msg != nullptr ) // queue is not empty
    {
	if( (head = msg->next) == nullptr )
	    tail = nullptr;
	msg->next = nullptr;
    }

    return msg;
}

RTS_INLINE RTMessage * RTMessageQ::dqAll( void )
{
    RTMessage * msg = head;

    head = tail = nullptr;

    return msg;
}

#endif // __RTMessageQ_inl__
