/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTPeerController_h__
#define __RTPeerController_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTController_h__
#include <RTController.h>
#endif

/** A controller that acts as an interface to a physical thread which runs a group of capsule
 instances in a multi-threaded RT application. This is the default controller used for implementing
 a physical thread in an RT application. It implements a main loop for the thread in which messages
 are dispatched to managed capsule instances.
 */
class RTPeerController : public RTController
{
public:
		    		RTPeerController( RTDebugger *, const char * name );
    virtual         ~RTPeerController( void );

    virtual void    mainLoop( void ) override;

protected:
    virtual void    startup( void );
    virtual void    waitForEvents( void ) override;
    virtual void    shutdown( void );

private:
    // unavailable methods
    RTPeerController( const RTPeerController & );
    RTPeerController & operator=( const RTPeerController & );
}; //lint !e1712

#endif // __RTPeerController_h__
