/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTPriority_inl__
#define __RTPriority_inl__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTPriority_h__
#include <RTPriority.h>
#endif

RTS_INLINE int RTPriority::isValid( int i )
{
    return System < i && i <= Background;
}

RTS_INLINE const char * RTPriority::name( void ) const
{
    return name( value );
}

RTS_INLINE
RTTypedValue_RTPriority::
RTTypedValue_RTPriority( const RTPriority & _value )
    : data( &_value )
    , type( _value.getClassData() )
{
}

RTS_INLINE
RTTypedValue_RTPriority::
RTTypedValue_RTPriority( const RTPriority     & _value,
			 const RTObject_class * _type )
    : data( &_value )
    , type( _type   )
{
}

#endif // __RTPriority_inl__
