/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTProtocolDescriptor_inl__
#define __RTProtocolDescriptor_inl__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTProtocolDescriptor_h__
#include <RTProtocolDescriptor.h>
#endif

RTS_INLINE
const char *
RTProtocolDescriptor::outSignalName( int signal ) const
{
    return conjugate->inSignalName( signal );
}

RTS_INLINE
int
RTProtocolDescriptor::outSignalNamed( const char * signalName ) const
{
    return conjugate->inSignalNamed( signalName );
}

RTS_INLINE
int
RTProtocolDescriptor::compatibleWith( const RTProtocolDescriptor * other ) const
{
    return compare( other ) == ok;
}

RTS_INLINE
RTProtocolDescriptor::Status
RTProtocolDescriptor::canSend( int                    signal,
			       const RTObject_class * type ) const
{
    return conjugate->canReceive( signal, type );
}

#endif // __RTProtocolDescriptor_inl__
