/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTRelayDescriptor_h__
#define __RTRelayDescriptor_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTConfig_h__
#include <RTConfig.h>
#endif

struct RTProtocolDescriptor;

// This structure describes a relay (interface) port of an actor class.
//
// Field            Meaning
// -----            -------
// name             The name of the relay (interface) port.
// protocol         The protocol of the port.
// replication      The replication factor of the port.

struct RTRelayDescriptor
{
    const char                 * name;
    const RTProtocolDescriptor * protocol;
    int                          replication;
};

#endif // __RTRelayDescriptor_h__
