/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTResourceMgr_h__
#define __RTResourceMgr_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTConfig_h__
#include <RTConfig.h>
#endif

class  RTMessage;
struct RTMessageBlock;
#if USE_THREADS
class  RTMutex;
#endif

class RTResourceMgr
{
protected:
    RTMessage         * messages;
    RTMessageBlock    * blocks;
#if USE_THREADS
    RTMutex           * access;
#endif

public:
		RTResourceMgr( void );
		~RTResourceMgr( void );

    unsigned    msgAlloc( RTMessage * &, unsigned howMany = 50U );
    void        msgFree ( RTMessage * &, unsigned howMany =  0U );

private:
    // unavailable methods
    RTResourceMgr( const RTResourceMgr & );
    RTResourceMgr & operator=( const RTResourceMgr & );
};

#endif // __RTResourceMgr_h__
