/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTSequence_h__
#define __RTSequence_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTDataObject_h__
#include <RTDataObject.h>
#endif

class RTSequence : public RTDataObject
{
public:
			    RTSequence( void );
			    RTSequence( const RTSequence & );
    virtual                 ~RTSequence( void );

    RTSequence            & operator=( const RTSequence & );

    virtual const RTObject_class * getClassData( void ) const override;
    static  const RTObject_class   classData;

#define RTType_RTSequence ( RTSequence::classData )
};

struct RTTypedValue_RTSequence
{
    const void           * data;
    const RTObject_class * type;

    RTS_INLINE RTTypedValue_RTSequence( const RTSequence     & ); //lint !e1931
    RTS_INLINE RTTypedValue_RTSequence( const RTSequence     &,
					const RTObject_class * );
}; //lint !e1712

#if RTS_INLINES
#include <RTSequence.inl>
#endif

#endif // __RTSequence_h__
