/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTSignal_inl__
#define __RTSignal_inl__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTSignal_h__
#include <RTSignal.h>
#endif

RTS_INLINE RTSignal & RTSignal::operator=( int rhs )
{
    value = rhs;
    return *this;
}

RTS_INLINE RTSignal & RTSignal::operator=( const RTSignal & rhs )
{
    value = rhs.value;
    return *this;
} //lint !e1529

RTS_INLINE
RTTypedValue_RTSignal::
RTTypedValue_RTSignal( const RTSignal & _value )
    : data( &_value )
    , type( _value.getClassData() )
{
}

RTS_INLINE
RTTypedValue_RTSignal::
RTTypedValue_RTSignal( const RTSignal       & _value,
		       const RTObject_class * _type )
    : data( &_value )
    , type( _type   )
{
}

#endif // __RTSignal_inl__
