/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTSoleController_h__
#define __RTSoleController_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTController_h__
#include <RTController.h>
#endif

/** A controller that acts as an interface to a physical thread which runs a group of capsule
 instances in a single-threaded RT application.
 */
class RTSoleController : public RTController
{
public:
	RTSoleController( RTDebugger *, const char * name );
    virtual         ~RTSoleController( void );

    virtual void    mainLoop( void ) override;

    void            timer_interrupt( void );

    virtual void    printStats( void ) const override;

protected:
    virtual void    waitForEvents( void ) override;

private:
    int             timer_interrupts;

    // unavailable methods
    RTSoleController( const RTSoleController & );
    RTSoleController & operator=( const RTSoleController & );
}; //lint !e1712

#endif // __RTSoleController_h__
