/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTString_h__
#define __RTString_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTDataObject_h__
#include <RTDataObject.h>
#endif

/** A C-style string wrapped in a data object.
 */
class RTString : public RTDataObject
{
public:
    char                  * Contents;

			    			RTString( const char * = nullptr ); //lint !e1931
			    			RTString( const RTString  & );
			    			RTString( RTString  && );
    virtual                 ~RTString( void );

    RTString              & operator=( const char     * );
    RTS_INLINE RTString   & operator=( const RTString & );
    RTS_INLINE RTString   & operator=( RTString && );

    virtual int             operator==( const RTDataObject & ) const override;
    int                     operator==( const char         * ) const;
    RTS_INLINE int          operator==( const RTString     & ) const;

    RTS_INLINE int          operator!=( const RTDataObject & ) const;
    RTS_INLINE int          operator!=( const char         * ) const;
    RTS_INLINE int          operator!=( const RTString     & ) const;

    RTS_INLINE operator char       * ( void );
    RTS_INLINE operator const char * ( void ) const;
    RTS_INLINE operator void       * ( void );
    char                  & operator[]( int );
    const char            & operator[]( int ) const;

    virtual const RTObject_class * getClassData( void ) const override;
    static  const RTObject_class   classData;

#define RTType_RTString ( RTString::classData )
};

RTS_INLINE int operator==( const char *, const RTString & );
RTS_INLINE int operator!=( const char *, const RTString & );

struct RTTypedValue_RTString
{
    const void           * data;
    const RTObject_class * type;
    const bool rValueRef = false;

    RTS_INLINE RTTypedValue_RTString( const RTString       	& ); //lint !e1931
    RTS_INLINE RTTypedValue_RTString( const RTString       	&& );
    RTS_INLINE RTTypedValue_RTString( const RTString       	&,
				      const RTObject_class * );
}; //lint !e1712

#if RTS_INLINES
#include <RTString.inl>
#endif

#endif // __RTString_h__
