/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTThread_h__
#define __RTThread_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTConfig_h__
#include <RTConfig.h>
#endif

class  RTJob;
struct RTThreadInfo;

/** Represents a thread in the operating system. */
class RTThread
{
public:
	/** Create a new thread.
	 @param job The job object which implements the behavior of the thread and captures thread data.
	 @param stackSize Size of the thread (in bytes)
	 @param prio Thread priority
	 */
    RTThread( RTJob * job, int stackSize, int prio = 0 );

    ~RTThread( void );

protected:
    RTJob         * _job;
    RTThreadInfo  * _info;

private:
    // unavailable methods
    RTThread( const RTThread & );
    RTThread & operator=( const RTThread & );
}; //lint !e1712

#endif // __RTThread_h__
