/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTTime_inl__
#define __RTTime_inl__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTTime_h__
#include <RTTime.h>
#endif

RTS_INLINE int operator>( const RTTime & lhs, const RTTime & rhs )
{
    return rhs < lhs;
}

RTS_INLINE int operator<=( const RTTime & lhs, const RTTime & rhs )
{
    return ( rhs < lhs ) == 0;
}

RTS_INLINE int operator>=( const RTTime & lhs, const RTTime & rhs )
{
    return ( lhs < rhs ) == 0;
}

RTS_INLINE
RTTypedValue_RTTime::
RTTypedValue_RTTime( const RTTime & _value )
    : data( &_value )
    , type( _value.getClassData() )
{
}

RTS_INLINE
RTTypedValue_RTTime::
RTTypedValue_RTTime( const RTTime         & _value,
		     const RTObject_class * _type )
    : data( &_value )
    , type( _type   )
{
}

#endif // __RTTime_inl__
