/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTTimerId_inl__
#define __RTTimerId_inl__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTTimerId_h__
#include <RTTimerId.h>
#endif

RTS_INLINE RTTimerId::Ring::Ring( void )
#ifdef _lint
    : prev( nullptr )
    , next( nullptr )
#endif
{
    prev = this;
    next = this;
}

RTS_INLINE RTTimerId::RTTimerId( void )
    : ring(                  )
    , node( nullptr )
{
}

RTS_INLINE RTTimerId::RTTimerId( const RTTimerId & id )
    : ring(                  )
    , node( nullptr )
{
    *this = id;
}

RTS_INLINE RTTimerId::RTTimerId( RTTimerNode * n )
    : ring(                  )
    , node( nullptr )
{
    if( n != nullptr )
	*this = n;
}

RTS_INLINE int RTTimerId::operator==( const RTTimerId & rhs ) const
{
    return rhs.node == node;
}

RTS_INLINE int RTTimerId::operator!=( const RTTimerId & rhs ) const
{
    return rhs.node != node;
}

RTS_INLINE int RTTimerId::isValid( void ) const
{
    return node != nullptr;
}

RTS_INLINE
RTTypedValue_RTTimerId::
RTTypedValue_RTTimerId( const RTTimerId & _value )
    : data( &_value )
    , type( &RTType_RTTimerId )
{
}

RTS_INLINE
RTTypedValue_RTTimerId::
RTTypedValue_RTTimerId( const RTTimerId      & _value,
			const RTObject_class * _type )
    : data( &_value )
    , type( _type   )
{
}

#endif // __RTTimerId_inl__
