/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTTypedValue_inl__
#define __RTTypedValue_inl__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTDataObject_h__
#include <RTDataObject.h>
#endif

#ifndef __RTObject_class_h__
#include <RTObject_class.h>
#endif

#ifndef __RTTypedValue_h__
#include <RTTypedValue.h>
#endif

RTS_INLINE RTTypedValue::RTTypedValue( const void           * _data,
				       const RTObject_class * _type )
    : data( _data )
    , type( _type )
{
}

RTS_INLINE RTTypedValue::RTTypedValue( const RTTypedValue & other )
    : data( other.data )
    , type( other.type )
{
}

RTS_INLINE RTTypedValue::RTTypedValue( const RTDataObject & object )
    : data( &object )
    , type( object.getClassData() )
{
}

#endif // __RTTypedValue_inl__
