/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTWrapper_h__
#define __RTWrapper_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTObject_class_h__
#include <RTObject_class.h>
#endif

class RTWrapper
{
public:
				RTWrapper( const void           * data
						= nullptr,
					   const RTObject_class * type
						= nullptr
					 ); //lint !e1931
				RTWrapper( const RTWrapper & );
				~RTWrapper( void );

    RTS_INLINE operator const void    * ( void ) const;
    RTS_INLINE const void             * data( void ) const;
    RTS_INLINE const RTObject_class   * type( void ) const;

    RTS_INLINE int              operator==( const RTWrapper & ) const;
    RTS_INLINE int              operator!=( const RTWrapper & ) const;

    RTWrapper                 & operator=( const RTWrapper & );

    static const RTObject_class classData;

#define RTType_RTWrapper ( RTWrapper::classData )

private:
    struct Handle
    {
	int                    ref_count;
	const RTObject_class * type;
	RTAlignment            data[ 1 /* or more */ ];
    };

    Handle * handle;
};

struct RTTypedValue_RTWrapper
{
    const void           * data;
    const RTObject_class * type;

    RTS_INLINE RTTypedValue_RTWrapper( const RTWrapper      & ); //lint !e1931
    RTS_INLINE RTTypedValue_RTWrapper( const RTWrapper      &,
				       const RTObject_class * );
}; //lint !e1712

#if RTS_INLINES
#include <RTWrapper.inl>
#endif

#endif // __RTWrapper_h__
