/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTWrapper_inl__
#define __RTWrapper_inl__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTWrapper_h__
#include <RTWrapper.h>
#endif

RTS_INLINE const void * RTWrapper::data( void ) const
{
    return handle->data;
}

RTS_INLINE const RTObject_class * RTWrapper::type( void ) const
{
    return handle->type;
}

RTS_INLINE RTWrapper::operator const void * ( void ) const
{
    return data();
}

RTS_INLINE int RTWrapper::operator==( const RTWrapper & rhs ) const
{
    return handle == rhs.handle;
}

RTS_INLINE int RTWrapper::operator!=( const RTWrapper & rhs ) const
{
    return handle != rhs.handle;
}

RTS_INLINE
RTTypedValue_RTWrapper::
RTTypedValue_RTWrapper( const RTWrapper & _value )
    : data( &_value )
    , type( &RTType_RTWrapper )
{
}

RTS_INLINE
RTTypedValue_RTWrapper::
RTTypedValue_RTWrapper( const RTWrapper      & _value,
			const RTObject_class * _type )
    : data( &_value )
    , type( _type   )
{
}

#endif // __RTWrapper_inl__
