/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTProtocolDescriptor.h>
#include <RTSignalDescriptor.h>
#include <RTSpecialSignals.h>

static const RTSignalDescriptor RTControl_Signals[] =
{
    { "ack", nullptr, RTAckSignal }
  , { "destroy", nullptr, RTDestroySignal }
  , { "initialize", nullptr, RTInitSignal }
  , { "interrupt", nullptr, RTInterruptSignal }
  , { "pendingTimeout", nullptr, RTPendingTimeoutSignal }
#if OBSERVABLE
  , { "probe", nullptr, RTProbeSignal }
#endif
  , { "start", nullptr, RTStartSignal }
  , { "stop", nullptr, RTStopSignal }
  , { "timeout", nullptr, RTTimeoutSignal }
  , { "wakeup", nullptr, RTWakeupSignal }
};

const RTProtocolDescriptor RTControl_Conjugate_Class =
{
	nullptr,
    &RTControl_Protocol_Class,
    "RTControl",
    0 /* RTVersionId */,
    0, nullptr
};

const RTProtocolDescriptor RTControl_Protocol_Class =
{
	nullptr,
    &RTControl_Conjugate_Class,
    "RTControl",
    0 /* RTVersionId */,
    sizeof( RTControl_Signals ) / sizeof( RTControl_Signals[ 0 ] ),
	RTControl_Signals
};
