/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActor.h>
#include <RTActorRef.h>
#include <RTActor_class.h>
#include <RTComponentDescriptor.h>

const RTActorClass * RTActor::defaultClass( RTActorRef & component, int /*repIndex*/ )
{
    const RTActor_class * info     = getActorData();
    int                   refIndex = component.getId() - 1;

    if( refIndex < 0 || refIndex >= info->numComponents )
    	return nullptr;

    return info->components[ refIndex ].defaultClass;
}
