/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifdef PRAGMA
#pragma implementation "RTActor.h"
#pragma implementation "RTActor.inl"
#endif

#include <RTActor.h>
#include <RTDiag.h>
#include <RTRelayPort.h>

RTActor::~RTActor( void )
{
	delete [] state;
	delete [] relays;

	// removeAllImports should have been called,
	// so we should not have to do anything now
	if( importList != nullptr )
		RTDiag::panic( "~RTActor: importList not empty" );

	context()->countActorDestroy();

#ifdef _lint
	rts           = nullptr;
	homeReference = nullptr;
#if SUSPEND
	suspendMsgs   = nullptr;
#endif
	importList    = nullptr;
	msg           = nullptr;
#if OBSERVABLE
	probe         = nullptr;
#endif
#endif // _lint
}
