/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActor.h>
#include <RTDiag.h>

#if OBSERVABLE
#include <RTActorProbe.h>
#endif

void RTActor::enterState( int s )
{
	int c = getCurrentState();

	RTAssert( s != c );

#if RTStateId_MaxSize == 1
	state->history.s1[ c - 1 ] = static_cast<unsigned char>(s);
#else
	switch( state->idShift )
	{
	default:
#if RTStateId_MaxSize > 2
		state->history.s4[ c - 1 ] = static_cast<unsigned>(s);
		break;
	case 1:
#endif
		state->history.s2[ c - 1 ] = static_cast<unsigned short>(s);
		break;
	case 0:
		state->history.s1[ c - 1 ] = static_cast<unsigned char>(s);
		break;
	}
#endif

	setCurrentState( s );

	rtgStateEntry(); //class-scoped state entry operation
	enterStateV();

#if OBSERVABLE
	if( probe != nullptr )
		probe->evtChain( 0 );
#endif
}
