/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActor.h>
#include <RTActorClass.h>
#include <RTActor_class.h>
#include <RTBindingEnd.h>
#include <RTRelayDescriptor.h>
#include <RTRelayPort.h>

int RTActor::_followOut( RTBindingEnd & end, int relayId, int repIndex )
{
    if( relayId < 0 )
	return 0;

    const RTActor_class * info = getActorData();
    const RTActorClass  * type = info->type;

    if( relayId >= type->numRelays )
	return 0;

    RTRelayPort * relay = &     relays[ relayId ];
    int           size  = type->relays[ relayId ].replication;

    return relay->followOut( end, this, relayId, repIndex, size );
}
