/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActor.h>
#include <RTActor_class.h>

const char * RTActor::getStateString( int s ) const
{
	const RTActor_class * info = getActorData();

	if( s <= 0 || s > info->numStates )
		return "no such state";
	else
	{
		const char * const * names = info->names;

		if( names == nullptr )
			return "unknown";
		else
			return names[ s - 1 ];
	}
}
