/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActor.h>
#include <RTActorRef.h>
#include <RTActor_class.h>
#include <RTComponentDescriptor.h>

void RTActor::_incarnateAllFixed( void )
{
    const RTActor_class         * info      = getActorData();
    const RTComponentDescriptor * component = info->components;

    for( int i = info->numComponents; --i >= 0; ++component )
    {
	RTActorRef * ref = RTObjectOf( RTActorRef, component->offset, this );

	if( ref->isFixed() != 0 )
	    ref->incarnateAll();
    }
}
