/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActor.h>

#include <RTActorProbe.h>
#include <RTSpecialPorts.h>
#include <RTSpecialSignals.h>

void RTActor::processHistory( void )
{
	for(;;)
	{
		int s = getCurrentState();
		int h = getHistory( s );

		if( h == s ) // state was already initialized
			break;

		if( h != 0 )
			enterState( h );
		else
		{
#if RTStateId_MaxSize == 1
			state->history.s1[ s - 1 ] = static_cast<unsigned char>(s);
#else
			switch( state->idShift )
			{
			default:
#if RTStateId_MaxSize > 2
				state->history.s4[ s - 1 ] = static_cast<unsigned>(s);
				break;
			case 1:
#endif
				state->history.s2[ s - 1 ] = static_cast<unsigned short>(s);
				break;
			case 0:
				state->history.s1[ s - 1 ] = static_cast<unsigned char>(s);
				break;
			}
#endif

			// initialize state s
			rtsBehavior( RTInitSignal, RTControlPort );

#if OBSERVABLE
			if( probe )
				probe->reportFieldValues( );
#endif
		}
	}
}
