/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActor.h>
#include <RTActorRef.h>
#include <RTImportList.h>

void RTActor::removeAllImports( RTController * initiator )
{
	


#if USE_THREADS
    RTActorRef::lock();
#endif

    RTImportList * list;
    for( list = importList; list != nullptr; list = list->used.next )
	_unbind( list->used.reference ,initiator);
    list = importList;

    importList = nullptr;

#if USE_THREADS
    RTActorRef::unlock();
#endif

    while( list != nullptr )
    {
	RTImportList * next = list->used.next;

	(void)list->used.reference->deport( this, list,initiator );

	list = next;
    }
}
