/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActor.h>
#include <RTActorRef.h>
#include <RTImportList.h>

int RTActor::removeImport( RTActorRef * ref ,RTController * initiator )
{

#if USE_THREADS
    RTActorRef::lock();
#endif

    RTImportList  * list = importList;
    RTImportList ** link = &importList;

    while( list != nullptr )
    {
	if( list->used.reference == ref )
	{
	    _unbind( ref ,initiator);
	    *link = list->used.next;

#if USE_THREADS
	    RTActorRef::unlock();
#endif
	    (void)ref->deport( this, list,initiator);

	    return 1;
	}
	link = &list->used.next;
	list = list->used.next;
    }

#if USE_THREADS
    RTActorRef::unlock();
#endif

    return 0;
}
