/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActor.h>
#include <RTActorClass.h>
#include <RTActor_class.h>
#include <RTPortDescriptor.h>
#include <RTRelayDescriptor.h>
#include <RTRelayPort.h>

void RTActor::_unbind( RTActorRef * importer ,RTController* initiator)
{
    const RTActor_class * info = getActorData();
    const RTActorClass  * type = info->type;

    for( int relayId = type->numRelays; --relayId >= 0; )
    {
	RTRelayPort * relay = &     relays[ relayId ];
	int           size  = type->relays[ relayId ].replication;
	relay->unreserve( this, relayId, size, importer, initiator);
    }
}
