/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActor.h>
#include <RTDiag.h>

RTActor::RTActor( const RTActor & )
    : rts          ( nullptr              )
    , homeReference( nullptr              )
    , homeIndex    (                    0 )
    , relays       ( nullptr              )
#if DEFER_IN_ACTOR
    , deferredQ    (                      )
#endif
#if SUSPEND
    , suspendMsgs  ( nullptr              )
#endif
    , importList   ( nullptr              )
    , state        ( nullptr              )
    , msg          ( nullptr              )
#if OBSERVABLE
    , probe        ( nullptr              )
#endif
{
    RTDiag::panic( "Unavailable method called:\n"
		   "    'RTActor( const RTActor & )'" );
}

RTActor & RTActor::operator=( const RTActor & )
{
    RTDiag::panic( "Unavailable method called:\n"
		   "    'RTActor::operator=( const RTActor & )'" );

    //lint -unreachable
    return *this;
} //lint !e1529
