/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifdef PRAGMA
#pragma implementation "RTActorClass.h"
#endif

#include <RTActorClass.h>

int RTActorClass::isKindOf( const RTActorClass * superclass ) const
{
    const RTActorClass * _class_ = this;

    for(;;)
    {
		if( _class_ == superclass )
			break;

		if( _class_ == nullptr )
			return 0;

		_class_ = _class_->super;
    }

    return 1;
}
