/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActorProbe.h>
#include <RTMain.h>
#include <RTMemoryUtil.h>
#include <RTString.h>

RTActorProbe::RTActorProbe( RTDebugger * debugger,
			    int          id,
			    const char * strPath,
			    int          actorIndex )
    : RTProbe     ( debugger, id, strPath, actorIndex )
    , _chainOrigin(                    0 )
    , _chainTrans ( nullptr )
    , _chainMsg   ( nullptr )
    , _chainParent(                    0 )
    , _chainState (                    0 )
    , _fieldList  ( nullptr )
    , _fieldMonList( nullptr )
{
}

RTActorProbe::FieldEntry::FieldEntry( const char * aName, const char * aValue )
    : varName ( RTMemoryUtil::strdup( aName ) )
    , varValue( nullptr )
    , next    ( nullptr )
{
    if( aValue != nullptr )
	varValue = RTMemoryUtil::strdup( aValue );
}
