/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActor.h>
#include <RTActorProbe.h>
#include <RTDebugger.h>

void RTActorProbe::evtHistory( int state )
{
    int histHist = 0;
    int histCurr = 0;

    if( _actor != nullptr && state > 0 )
    {
	histHist = _actor->getHistory( state );
	histCurr = _actor->getCurrentState();
    }

    (void)_debugger->evtHistory( _id, _actorIndex, _actor,
				 state, histHist, histCurr );
}
