/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActorProbe.h>
#include <RTDebugger.h>
#include <RTMessage.h>

void RTActorProbe::evtMessageOut( const RTMessage         * msg,
				  RTEventInfo::SendMethod   sendMethod )
{
    RTEventInfo * eventInfo = new RTEventInfo( RTEventInfo::EventMsgOut,
					       _id,
					       _actorIndex );

    _debugger->getTimestamp( eventInfo->timestamp );
    eventInfo->message    = new RTMessage( *msg );
    eventInfo->sendMethod = sendMethod;

    context()->breakPoint( _actor, eventInfo );
}
