/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2019, 2020.All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActorProbe.h>

#include <RTMemoryUtil.h>


void RTActorProbe::addFieldMonitor( const char* variable )
{
    FieldEntry * entry = new FieldEntry( variable, nullptr );
    entry->next = _fieldMonList;
    _fieldMonList = entry;
}


void RTActorProbe::delFieldMonitor( const char* variable )
{
    for( FieldEntry * entry = _fieldMonList, * prev = nullptr; entry; )
    {
        if( !RTMemoryUtil::strcmp( variable, entry->varName ) )
        {
            if( prev )
                prev->next = entry->next;
            else
                _fieldMonList = entry->next;
            delete entry;
            entry = prev ? prev->next : _fieldMonList;
        }
        else
        {
            prev = entry;
            entry = prev->next;
        }
    }
}
