/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActor.h>
#include <RTActorRef.h>
#include <RTComponentDescriptor.h>
#include <RTDebugger.h>

int RTActorRef::deport( RTActor * a )
{   
	// This is the initiator context
    RTController * controller = context();

    controller->trace( RTController::FrameDeport, this, nullptr );

    if( a == nullptr )
    {
	controller->setError( RTController::badActor,
			      RTController::FrameDeport,
			      this, nullptr );
	return 0;
    }

    if( _info->kind != RTComponentDescriptor::Imported )
    {
	controller->setError( RTController::notImported,
			      RTController::FrameDeport,
			      this, nullptr );
	return 0;
    }

    return a->removeImport( this ,controller);
}
