/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifdef PRAGMA
#pragma implementation "RTActorRef.h"
#pragma implementation "RTActorRef.inl"
#pragma implementation "RTActorSlot.h"
#pragma implementation "RTActorSlot.inl"
#pragma implementation "RTImportList.h"
#endif

#include <RTActorRef.h>
#include <RTActorSlot.h>
#include <RTComponentDescriptor.h>
#include <RTImportList.h>

RTActorRef::~RTActorRef( void )
{
	if( _info->replication  > 1 ||
			_info->kind        == RTComponentDescriptor::Imported )
	{
		delete [] static_cast<void **>(_contents);
	}

#ifdef _lint
	_info     = nullptr;
	_contents = nullptr;
#if OBSERVABLE
	probe     = nullptr;
#endif
#endif
}
