/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActor.h>
#include <RTActorRef.h>
#include <RTComponentDescriptor.h>
#include <RTInterfaceDescriptor.h>

int RTActorRef::_followIn( RTBindingEnd & end, int portId, int portIndex )
{
    if( portId < 0 || _info->numInterfaces <= portId )
	return 0;

    int portSize = _info->interfaces[ portId ].replication;

    if( portSize == 0 )
	return 0;

    int actorIndex = portIndex / portSize;

    if( actorIndex >= size() )
	return 0;

    RTActor * member = (*this)[ actorIndex ];

    if( member == nullptr ) // not incarnated
	return 0;

    return member->_followIn( end, portId, portIndex % portSize,
			      ( _info->kind == RTComponentDescriptor::Imported )
				      ? this
				      : nullptr );
}
