/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActor.h>
#include <RTActorRef.h>
#include <RTComponentDescriptor.h>
#include <RTInterfaceDescriptor.h>

int RTActorRef::_followOut( RTBindingEnd & end,
			    RTActor      * mem,
			    int            portId,
			    int            portIndex )
{
    if( portId < 0 || _info->numInterfaces <= portId )
	return 0;

    int memberIndex = indexOf( mem );

    if( memberIndex < 0 )
	return 0;

    portIndex += _info->interfaces[ portId ].replication * memberIndex;

    return getOwner()->_followOutV( end, getId(), portId, portIndex );
}
