/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActor.h>
#include <RTActorFactory.h>
#include <RTActorRef.h>

RTActor * RTActorRef::incarnate( const RTActorClass   & actorClass,
		const void           * data,
		const RTObject_class * type,
		RTController         * rts,
		int                    index,
		RTActorFactory		 * factory )
{
	// If no factory is provided in the call, check if one is specified on the capsule part
	RTActorFactoryInterface* theFactory = factory ? factory : _info->factory;
	RTActor * a = incarnate2( &actorClass, rts, index, theFactory );

	if( a == nullptr )
	{
		// incarnate failed
	}
	else if( a->initMe( data, type, context() ) == 0 )
	{
		(void)destroy( a );

		a = nullptr;
	}

	return a;
}

