/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActor.h>
#include <RTActorRef.h>
#include <RTComponentDescriptor.h>
#include <RTDiag.h>

void RTActorRef::initializeAll( void )
{
	RTAssert( _info->kind == RTComponentDescriptor::Fixed );

	int            n = size();
	RTController * c = context();

	for( int i = 0; i < n; ++i )
	{
		RTActor * a = (*this)[ i ];

		if( a != nullptr )
			(void)a->initMe( nullptr, nullptr, c );
	}
}
