/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActorRef.h>
#include <RTActorRefProbe.h>

int RTActorRefProbe::connectProbe( void )
{
    if( _actor != nullptr && _actorRef != nullptr )
	return 0;  // already connected

    RTActorRef * pathActorRef = getRefFromStrPath();

    if( pathActorRef == nullptr )
	return 0;

    _actor           = pathActorRef->getOwner();
    _actorRef        = pathActorRef;
    _actorRef->probe = this;

    evtPresence( -1, -1, -1 ); // -1: any actorIndex,observer,daemon

    return 1;
}
