/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActorRef.h>
#include <RTActorRefProbe.h>
#include <RTDebugger.h>

void RTActorRefProbe::evtPresence( int actorIndex, int obsId, int daemonId )
{
    if( _actorRef == nullptr )
	return;

    int refSize = _actorRef->size();

    if( actorIndex < 0 )
    {
	for( actorIndex = 0; actorIndex < refSize; ++actorIndex )
	{
	    (void)_debugger->evtPresence( _id, actorIndex,
					  (*_actorRef)[ actorIndex ],
					  obsId, daemonId );
	}
    }
    else if( actorIndex < refSize )
    {
	(void)_debugger->evtPresence( _id, actorIndex,
				      (*_actorRef)[ actorIndex ],
				      obsId, daemonId );
    }
}
