/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActor_class.h>
#include <RTFieldDescriptor.h>

const RTFieldDescriptor *
RTActor_class::findAttribute( const char * name ) const
{
    const RTActor_class     * _class = this;
    const RTFieldDescriptor * field;

    while( (field = _class->attributes->lookup( _class->numAttributes, name ))
	       == nullptr &&
	   (_class = _class->super) != nullptr )
    {
	// continue with the base class
    }

    return field;
}
