/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTArray_class.h>

RTArray_class::RTArray_class( int size, const RTObject_class * type )
{ //lint !e1927 !e1928
    _super          = nullptr;
    _super_accessor = nullptr,
    _name           = nullptr;
    _version        = 0 /* RTVersionId */;
    _size           = type->_size * size;
    _init_func      = RTarray_init;
    _copy_func      = RTarray_copy;
#if OBJECT_DECODE
    _decode_func    = RTarray_decode;
#endif
#if OBJECT_ENCODE
    _encode_func    = RTarray_encode;
#endif
    _destroy_func   = RTarray_destroy;
    _num_fields     = size;
    _fields         = &element;

    element.name     = nullptr;
    element.offset   = 0;
    element.type     = type;
    element.modifier = nullptr;
}
