/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTAsciiDecoding.h>
#include <stdint.h>

int RTAsciiDecoding::get_address( void * & address )
{
	uintptr_t value  	 = 0UL;
	int           status = 0;
	char          byte;
	int           digits = 0;

	if( getNonWhite( byte ) == 0 )
		return 0;

	if( byte != '0' )
	{
		ungetByte( byte );
		return 0;
	}

	if( getByte( byte ) == 0 )
		return 0;

	if( byte != 'x' )
	{
		ungetByte( byte );
		ungetByte( '0' );
		return 0;
	}

	while( getByte( byte ) != 0 )
	{
		if( '0' <= byte && byte <= '9' )
			byte -= '0';
		else if( 'a' <= byte && byte <= 'f' )
			byte -= 'a' - 10;
		else if( 'A' <= byte && byte <= 'F' )
			byte -= 'A' - 10;
		else
		{
			ungetByte( byte );
			if( status == 0 )
			{
				ungetByte( 'x' );
				ungetByte( '0' );
			}
			break;
		}

		if( value != 0UL || byte != '\0' )
			digits += 1;

		value <<= 4;
		value += byte;
		status = 1;
	}

	if( digits > 2 * static_cast<int>(sizeof( address )) )
		status = 0;

	else if( status != 0 )
		address = reinterpret_cast<void *>(value);

	return status;
}
