/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTAsciiDecoding.h>
#include <RTFieldDescriptor.h>
#include <RTMemoryUtil.h>

int RTAsciiDecoding::get_enum( int & value,
		int                       numElements,
		const RTFieldDescriptor * element )
{
	char byte;

	if( getNonWhite( byte ) == 0 )
		return 0;

	ungetByte( byte );

	if( ( '0' <= byte && byte <= '9' ) || byte == '-' )
		return get_int( value );

	char name[ 200 ];

	if( getName( name, sizeof( name ) ) != 0 )
	{
		for( ; numElements > 0; --numElements, ++element )
		{
			if( RTMemoryUtil::strcmp( name, element->name ) == 0 )
			{
				value = static_cast<int>(element->offset);

				return 1;
			}
		}
	}

	return 0;
}
