/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTAsciiDecoding.h>

int RTAsciiDecoding::get_opaque( int & value_size, char * & value )
{
	int    size;
	char * data;

	if( get_int( size ) == 0 )
		return 0;

	if( size < 0 )
		return 0;

	if( size == 0 )
		data = nullptr;
	else
	{
		data = new char [ static_cast<unsigned>(size) ];

		if( data == nullptr )
			return 0;

		char * cursor = data;

		for( int required = size; --required >= 0; )
		{
			int ch;

			if( get_int( ch ) != 0 && 0 <= ch && ch <= 0xFF )
				*cursor++ = static_cast<char>(ch);
			else
			{
				delete [] data;
				return 0;
			}
		}
	}

	value_size = size;
	value      = data;

	return 1;
}
