/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTAsciiDecoding.h>
#include <RTFieldDescriptor.h>
#include <RTObject_class.h>

int RTAsciiDecoding::get_struct( void * target,
		const RTObject_class * record )
{
	if( getFieldListStart() == 0 )
		return 0;

	int  status = 1;
	char name[ 200 ];

	while( getFieldName( name, static_cast<int>(sizeof( name )) ) != 0 )
	{
		void                    * value = target;
		const RTObject_class    * type  = record;
		const RTFieldDescriptor * field;

		for(;;)
		{
			field = type->_fields->lookup( type->_num_fields, name );

			if( field != nullptr )
			{
				status = field->decode( value, this );
				break;
			}

			const RTObject_class * super = type->_super;

			if( super == nullptr )
			{
				status = 0;
				break;
			}

			value = (*type->_super_accessor)( value );
			type  = super;
		}

		if( status == 0 )
			break;

		if( getFieldSeparator() == 0 )
			break;

		status = 0;
	}

	return getFieldListFinish() != 0 && status != 0;
}
