/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTAsciiEncoding.h>
#include <RTMemoryUtil.h>
#include <RTObject_class.h>
#include <RTUnknownObject.h>

int RTAsciiEncoding::put( const void * data, const RTObject_class * type )
{
    if( type == nullptr )
    	return put_address( data );

#if OBJECT_DECODE
    if( type == &RTType_RTUnknownObject )
    {
    	const RTUnknownObject * unknown = static_cast<const RTUnknownObject *>(data);

		if( RTMemoryUtil::strcmp( unknown->signature, "RTAsciiDecoding" ) == 0 )
			return putCode( unknown->code, unknown->length, SpaceAround );
    }
#endif

    if( type->_name == nullptr )
    {
    	// anonymous type
    }
    else if( putType( type ) == 0 )
    {
    	return 0;
    }

    return type->encode( data, this );
}
