/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTAsciiEncoding.h>
#include <RTFieldDescriptor.h>
#include <RTObject_class.h>

int RTAsciiEncoding::putFields( const void           * value,
				const RTObject_class * record,
				int                  & first )
{
    if( record->_super == nullptr )
    {
	// we have no base type
    }
    else
    {
	if( putFields( (*record->_super_accessor)( RTConstCast( void, value ) ),
		       record->_super,
		       first ) == 0 )
	    return 0; // failure encoding the base type
    }

    int                       count = record->_num_fields;
    const RTFieldDescriptor * field = record->_fields;

    for( ; --count >= 0; ++field )
    {
	if( field->type == nullptr )
	    continue; // skip fields of unknown types

	if( first != 0 )
	    first = 0;
	else if( putFieldSeparator() == 0 )
	    return 0;

	if( putName( field->name ) == 0 )
	    return 0;

	if( field->encode( value, this ) == 0 )
	    return 0;
    }

    return 1;
}
