/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTAsciiEncoding.h>
#include <RTObject_class.h>

int RTAsciiEncoding::put_indirect( const void * pointer,
		const RTObject_class * target )
{
	int          status = 0;
	const void * value  = * static_cast<const void * const *>(pointer);

	if( value == nullptr )
	{
		status = put_int( 0 );
	}
	else if( putFieldListStart() != 0 )
	{
		status = target->encode( value, this );

		if( putFieldListFinish() == 0 )
			status = 0;
	}

	return status;
}
