/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTAsciiEncoding.h>

int RTAsciiEncoding::put_string( const char * value )
{
	if( putCode( "\"", 1, SpaceNone ) == 0 )
		return 0;

	if( value != nullptr )
	{
		for( const char * cursor = value; ; ++cursor )
		{
			if( *cursor == '\0' || *cursor == '\\' || *cursor == '"' )
			{
				int size = static_cast<int>(cursor - value);

				if( size != 0 && putCode( value, size, SpaceNone ) == 0 )
					return 0;

				if( *cursor == '\0' )
					break;

				value = cursor;

				if( putCode( "\\", 1, SpaceNone ) == 0 )
					return 0;
			}
		}
	}

	return putCode( "\"", 1, SpaceNone );
}
