/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTBoolean.h>
#include <RTDecoding.h>
#include <RTEncoding.h>
#include <RTFieldDescriptor.h>
#include <RTObject_class.h>
#include <RTnew.h>

static RTInteger * _access( RTBoolean * target )
{
	return target;
}

static void _init( const RTObject_class *, void * target )
{
	(void)new( target ) RTBoolean;
}

static void _copy( const RTObject_class *,
		void                 * target,
		const void           * source )
{
	(void)new( target ) RTBoolean( * static_cast<const RTBoolean *>(source) );
}

#if OBJECT_DECODE || OBJECT_ENCODE
static const RTFieldDescriptor _values[] =
{
		{
				"False",
				0, nullptr, nullptr
		},
		{
				"True",
				1, nullptr, nullptr
		}
};
#endif // OBJECT_DECODE || OBJECT_ENCODE

#if OBJECT_DECODE
static int _decode( const RTObject_class *,
		void                 * target,
		RTDecoding           * coding )
{
	return coding->get_enum( (static_cast<RTBoolean *>(target))->value, 2, _values );
}
#endif

#if OBJECT_ENCODE
static int _encode( const RTObject_class *,
		const void           * source,
		RTEncoding           * coding )
{
	return coding->put_enum( (static_cast<const RTBoolean *>(source))->value, 2, _values );
}
#endif

static const RTFieldDescriptor _fields[] =
{
		{
				"RTBoolean",
				0,
				&RTBoolean::classData, nullptr
		}
};

const RTObject_class RTBoolean::classData =
{
		&RTType_RTInteger,
		reinterpret_cast<RTSuperAccessFunction>(_access),
		"RTBoolean",
		0 /* RTVersionId */,
		sizeof( RTBoolean ),
		_init,
		_copy,
		nullptr, // Not movable
#if OBJECT_DECODE
		_decode,
#endif
#if OBJECT_ENCODE
		_encode,
#endif
		RTDataObject_destroy,
		1, _fields
};

#if OBJECT_DECODE
RTTypeInstaller RTBoolean_installer( RTType_RTBoolean );
#endif

const RTObject_class * RTBoolean::getClassData( void ) const
{
	return &RTBoolean::classData;
}
