/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTByteBlock.h>
#include <RTMemoryUtil.h>

RTByteBlock & RTByteBlock::operator=( const RTByteBlock & rhs )
{
	if( this != &rhs )
	{
		delete [] Contents;

		length   = rhs.length;
		Contents = nullptr;

		if( length != 0 && rhs.Contents != nullptr )
			Contents = static_cast<char *>(RTMemoryUtil::memdup( rhs.Contents, length ));
	}

	return *this;
}
