/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTByteBlock.h>
#include <RTMemoryUtil.h>

RTByteBlock::RTByteBlock( void )
: RTDataObject()
, length  ( 0 )
, Contents( nullptr )
{
}

RTByteBlock::RTByteBlock( int          _length,
		const void * _Contents )
: RTDataObject()
, length  ( _length )
, Contents( nullptr )
{
	if( length != 0 && _Contents != nullptr )
		Contents = static_cast<char *>(RTMemoryUtil::memdup( _Contents, length ));
}

RTByteBlock::RTByteBlock( const RTByteBlock & other )
: RTDataObject( other )
, length  ( other.length )
, Contents( nullptr )
{
	if( length != 0 && other.Contents != nullptr )
		Contents = static_cast<char *>(RTMemoryUtil::memdup( other.Contents, length ));
}
