/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTCachedString.h>

void RTCachedString::unlink( Entry * entry )
{
	entry->use_count -= 1U;

	if( entry->use_count == 0U )
	{
		delete [] entry->value;

		if( --_used != 0U )
			entry->value = reinterpret_cast<char *>(entry);
		else
		{
			for(;;)
			{
				Block * block = _blocks;

				if( block == nullptr )
					break;

				_blocks = block->next;

				delete block;
			}

			delete [] _contents;

			_contents = nullptr;
		}
	}
}
