/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */


#include <RTCmdLineObserver.h>
#include <RTDaemon.h>
#include <RTMemoryUtil.h>
#include <RTVersion.h>

//lint -save -e786
static const char * const banner[] =
{
    "RT C++ Target Run Time System - ", RT_VERSION_STRING, "\r\n",
    "\r\n",
    "*****************************************************\r\n",
    "* Please note: The output from any command you type *\r\n",
    "*   here will be sent to the executable's STDOUT.   *\r\n",
    "*****************************************************\r\n",
	nullptr
};
//lint -restore

RTCmdLineObserver::RTCmdLineObserver( RTDebugger  * theDebugger,
				      RTTcpSocket * theSocket,
				      int           theObsId,
				      const char  * initBuf,
				      int           initLen )
    : RTObserver( theDebugger, theSocket, theObsId, initBuf, initLen )
{
    for( const char * const * line = banner; *line != nullptr; ++line )
	(void)sendData( *line, RTMemoryUtil::strlen( *line ) );

    cmdCreateDaemon( 0 );
    (void)setDaemon( 0 );
    daemon->updateSettings( "type=Command;" );
}
