/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTCmdLineObserver.h>
#include <RTEventInfo.h>
#include <RTFormat.h>
#include <RTMemoryUtil.h>

int RTCmdLineObserver::evtRtsStatus( int,             // daemonId
		const RTEventInfo & info )
{
	char buf[ 64 ];

	(void)RTFormat::_long( info.timestamp.tv_sec, buf, sizeof( buf ) );
	(void)sendData( buf, RTMemoryUtil::strlen( buf ) );

	RTMemoryUtil::memset( &buf[ 1 ], '0', 9 );

	int offset = RTFormat::_long( info.timestamp.tv_nsec, &buf[ 10 ], sizeof( buf ) - 10 );
	buf[ offset ] = '.';
	(void)sendData( &buf[ offset ], RTMemoryUtil::strlen( &buf[ offset ] ) );

	(void)sendData( ": Target is ", RTMemoryUtil::strlen( ": Target is " ) );

	const char * s;

	switch( info.targetMode )
	{
	case RTEventInfo::Halted:   s = "stopped\r\n";  break;
	case RTEventInfo::Stepping: s = "stepping\r\n"; break;
	case RTEventInfo::Running:  s = "running\r\n";  break;
	default:                    s = "?\r\n";        break;
	}

	(void)sendData( s, RTMemoryUtil::strlen( s ) );

	return 0;
}
