/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTController.h>
#include <RTMutex.h>

void RTController::acceptIncoming( void )
{
	short bits;
	short priority;

	_mutex->enter();

	if( (bits = incomingBits) != 0 )
	{
		internalBits |= bits;
		incomingBits  = 0;

		do
		{
			priority = topPriority[ bits ];
			bits ^= static_cast<short>( 1 << priority );
#if RTS_COUNT
			counts.messagesAllocated += static_cast<unsigned>(incomingQ[ priority ].size());
#endif
			internalQ[ priority ].appendFrom( incomingQ[ priority ] );
		}
		while( bits != 0 );
	}

	_mutex->leave();
}
