/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActor.h>
#include <RTController.h>
#include <RTDebugger.h>
#include <RTEventInfo.h>

void RTController::breakPoint( RTActor * actor, RTEventInfo * eventInfo )
{
    // Save the active message. The actor might be the target of
    // a RTFieldSignal message if it stops at this break point.

    const RTMessage * msg = actor->msg;

    actor->msg = nullptr;

    eventInfo->actor = actor;
    eventInfo->info  = actor->getActorData();

    int shouldHalt = debugger()->breakPoint( this, eventInfo );

    if( shouldHalt > 0 )
	while( debugger()->step_begin( this ) == 0 )
	    awaitResponse();

    actor->msg = msg; // restore the message
}
