/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTController.h>
#include <RTDiag.h>
#include <RTMessage.h>
#include <RTSpecialSignals.h>

void RTController::countMessageTransfer( RTMessage * msg )
{
	if( msg->sap() == nullptr && msg->getSignal() == RTTimeoutSignal )
	{
		// don't count timeout messages:
		// they were allocated from this controller
	}
	else
	{
		RTAssert( counts.messagesAllocated != 0U );
		counts.messagesAllocated -= 1U;
	}
}
