/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTController.h>
#include <RTDebugger.h>
#include <RTPriority.h>

//lint -save -esym(1926,RTController::internalQ,RTController::incomingQ)

RTController::RTController( RTDebugger * debug,
			    const char * rtsname )
    : RTJob()
    , _name            (                   rtsname )
#if OTRTSDEBUG != DEBUG_NONE
    , _debugger        (                     debug )
    , _prev            ( nullptr )
    , _next            ( nullptr )
    , _state           (                execSystem )
#endif
    , errorNumber      (                        ok )
#if USE_THREADS
    , _sync            ( nullptr )
#endif
    , internalBits     (                         0 )
#if USE_THREADS
    , incomingBits     (                         0 )
#endif
    , freeList         ( nullptr )
    , freeListSize     ( 0                         )
    , freeTimerList    ( nullptr )
    , freeTimerListSize( 0                         )
    , replyBuffer      ( nullptr )
#if ! DEFER_IN_ACTOR
    , deferredQ        (                           )
#endif
#if RTS_COUNT
    , counts           (                           )
#endif
{
#if OTRTSDEBUG == DEBUG_NONE
    (void)debug;
#else
    _prev = this;
    _next = this;

    if( debug != nullptr )
	debug->registerRTS( this );
#endif
}

//lint -restore
