/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTController.h>
#include <RTDiag.h>
#include <RTMessage.h>
#include <RTSpecialSignals.h>

void RTController::kill( void )
{
    RTMessage * msg = nullptr;

#if PURIFY
    msg = new RTMessage;
#else
    (void)resourceMgr.msgAlloc( msg, 1U );
#endif

    if( msg == nullptr )
    	RTDiag::panic( "no memory for shutdown" );
    else
    {
		msg->setData( nullptr, nullptr );
		msg->setSignal( RTDestroySignal );
		msg->setPriority( Synchronous );
		msg->setDestination( nullptr, nullptr, 0 );

#if USE_THREADS
		peer_receive( msg );
#else
		receive( msg, nullptr );
#endif
    }
}
