/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTController.h>
#include <RTMessage.h>
#include <RTMutex.h>

void RTController::peer_receive( RTMessage * msg )
{
	int          priority = msg->priority;
	RTMessageQ * queue    = &incomingQ[ priority ];

	_mutex->enter();

	queue->nqTail( msg );

	short old_bits = incomingBits;

	incomingBits = static_cast<short>( old_bits | ( 1 << priority ) );

	_mutex->leave();

	if( old_bits == 0 && phase() == RTJob::running )
		wakeup();
}
