/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTController.h>
#include <RTMessage.h>

// requeue to the appropriate priority queue a message to be delivered
// to a local actor that was previously deferred

void RTController::requeueMsg( RTMessage * message, int front )
{
	int          priority = message->priority;
	RTMessageQ & queue    = internalQ[ priority ];

	if( front != 0 )
		queue.nqHead( message );
	else
		queue.nqTail( message );

	internalBits |= static_cast<short>( 1 << priority );
}
