/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTController.h>
#include <RTDiag.h>

//lint -save -e1738 -esym(1926,RTController::internalQ,RTController::incomingQ)

RTController::RTController( const RTController & )
    : RTJob()
    , _name            ( nullptr                   )
#if OTRTSDEBUG != DEBUG_NONE
    , _debugger        ( nullptr                   )
    , _prev            ( nullptr                   )
    , _next            ( nullptr                   )
    , _state           (                execSystem )
#endif
    , errorNumber      (                        ok )
#if USE_THREADS
    , _sync            ( nullptr                   )
#endif
    , internalBits     (                         0 )
#if USE_THREADS
    , incomingBits     (                         0 )
#endif
    , freeList         ( nullptr                   )
    , freeListSize     (                         0 )
    , freeTimerList    ( nullptr                   )
    , freeTimerListSize(                         0 )
    , replyBuffer      ( nullptr                   )
#if ! DEFER_IN_ACTOR
    , deferredQ        (                           )
#endif
#if RTS_COUNT
    , counts           (                           )
#endif
{
    RTDiag::panic( "Unavailable method called:\n"
		   "    'RTController( const RTController & )'" );
}

//lint -restore

RTController & RTController::operator=( const RTController & )
{
    RTDiag::panic( "Unavailable method called:\n"
		   "    'RTController::operator=( const RTController & )'" );

    //lint -unreachable
    return *this;
} //lint !e1529
