/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDaemon.h>
#include <RTDaemonInfo.h>
#include <RTDebugger.h>
#include <RTElasticArray.h>

int RTDaemon::addInfo( RTDaemonInfo * daemonInfo )
{
	int foundPos = posInfo( daemonInfo );

	if( foundPos >= 0 ) // already exists
		return -1;

	lock.enter();

	foundPos = actorInfo.unusedIndex();

	actorInfo[ foundPos ] = daemonInfo;

	lock.leave();

	int probeNr = debugger->addProbe( daemonInfo );

	daemonInfo->probeNr = probeNr;

	return probeNr;
}
