/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDaemon.h>
#include <RTDaemonInfo.h>
#include <RTDebugger.h>
#include <RTElasticArray.h>

int RTDaemon::delInfo( RTDaemonInfo * newInfo )
{
	int foundPos = posInfo( newInfo );

	if( foundPos < 0 ) // does not exist
		return -1;

	lock.enter();

	RTDaemonInfo * oldInfo = static_cast<RTDaemonInfo *>(actorInfo[ foundPos ]);
	int            probeNr = oldInfo->probeNr;

	delete oldInfo;
	actorInfo[ foundPos ] = nullptr;

	lock.leave();

	if( newInfo )
		newInfo->probeNr = probeNr;

	return debugger->deleteProbe( probeNr );
}
