/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDaemon.h>
#include <RTDaemonInfo.h>
#include <RTDebugger.h>
#include <RTMemoryUtil.h>

void RTDaemon::fieldValue( const char * variable, const char * value )
{
	for( int iActor = 0; iActor < actorInfo.size(); ++iActor )
	{
		const RTDaemonInfo * info = static_cast<const RTDaemonInfo *>(actorInfo[ iActor ]);

		if( info == nullptr )
			continue;

		if( info->daemonKind == RTDaemonInfo::InfoVariable &&
				RTMemoryUtil::strcmp( info->variableName, variable ) == 0 )
		{
			debugger->addFieldValue( variable, value, info->probeNr );
		}
	}
}
