/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDaemon.h>
#include <RTDaemonInfo.h>
#include <RTDebugger.h>

int RTDaemon::inject( int                    inwards,
		const char           * signal,
		int                    prio,
		const void           * data,
		const RTObject_class * type )
{
	int result = 0;

	for( int iActor = 0; iActor < actorInfo.size(); ++iActor )
	{
		const RTDaemonInfo * info = static_cast<const RTDaemonInfo *>(actorInfo[ iActor ]);

		if( info == nullptr )
			continue;

		if( info->daemonKind != RTDaemonInfo::InfoPort )
			continue;

		if( debugger->inject( inwards, signal, prio, data, type, *info ) != 0 )
			result = 1;
	}

	return result;
}
