/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2019, 2020.All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDaemon.h>

#include <RTDaemonInfo.h>
#include <RTDebugger.h>
#include <RTMemoryUtil.h>

int RTDaemon::monitorField( RTDaemonInfo * daemonInfo, bool enable )
{
    lock.enter();

    int foundPos = posInfo_( daemonInfo );

    if( foundPos < 0 ) {
        lock.leave();
        return -1;
    }

    RTDaemonInfo * foundInfo = static_cast<RTDaemonInfo *>(actorInfo[ foundPos ]);
    int probeNr = foundInfo->probeNr;

    lock.leave();

    if( enable )
        debugger->addFieldMonitor( probeNr, foundInfo->variableName );
    else
        debugger->delFieldMonitor( probeNr, foundInfo->variableName );

    return 0;
}
