/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDaemonInfo.h>
#include <RTMemoryUtil.h>

void RTDaemonInfo::setInfo( const char * theActor )
{
    int actorLen = RTMemoryUtil::strlen( theActor );
    actorPath    = RTMemoryUtil::strdup( theActor, actorLen );

    if( actorLen == 1 && actorPath[ 0 ] == '/' )
    {
	actorIndex = 0;
	actorDepth = 0;
    }
    else
    {
	while( actorLen > 0 )
	{
	    if( actorPath[ actorLen ] == '/' )
		break;
	    if( actorPath[ actorLen ] == ':' )
	    {
		actorPath[ actorLen ] = '\0';
		actorIndex = RTMemoryUtil::atoi( &actorPath[ actorLen + 1 ] );
		break;
	    }
	    --actorLen;
	}

	char * p = actorPath;
	for( ; *p != '\0'; ++p )
	    if( *p == '/' )
		++actorDepth;
    }
}
