/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDaemonInfo.h>
#include <RTMemoryUtil.h>

void RTDaemonInfo::setInfoPort( const char * theActor, const char * thePort )
{
    daemonKind = InfoPort;

    setInfo( theActor );

    int portLen = RTMemoryUtil::strlen( thePort );
    portName    = RTMemoryUtil::strdup( thePort, portLen );

    while( portLen > 0 )
    {
	if( portName[ portLen ] == ':' )
	{
	    portName[ portLen ] = '\0';
	    portIndex = RTMemoryUtil::atoi( &portName[ portLen + 1 ] );
	    break;
	}
	--portLen;
    }
}
