/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDaemonInfo.h>
#include <RTMemoryUtil.h>

void RTDaemonInfo::setInfoState( const char * theActor, const char * theState )
{
    daemonKind     = InfoState;
    stateStrTarget = RTMemoryUtil::strdup( theState );

    setInfo( theActor );

    if( theState != nullptr && theState[ 0 ] == ':' )
    {
	stateDepth = 0;

	if( theState[ 1 ] != '\0' ) // ':' - 0, ':S1' - 1, ':S1:S11' - 2
	{
	    const char * p = theState;
	    for( ; *p != '\0'; ++p )
		if( *p == ':' )
		    ++stateDepth;
	}
    }
}
