/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDaemonInfo.h>
#include <RTDiag.h>

//lint -save -e1738
RTDaemonInfo::RTDaemonInfo( const RTDaemonInfo & )
    : daemonKind    (                       -1 )
    , probeNr       (                       -1 )
    , actorPath     (                nullptr   )
    , actorIndex    (                       -1 )
    , info          (                nullptr   )
    , actorDepth    (                        0 )
    , allRecurs     (                        0 )
    , portName      (                nullptr   )
    , portId        (                       -1 )
    , portIndex     (                       -1 )
    , stateStrTarget(                nullptr   )
    , stateTarget   (                       -1 )
    , stateDepth    (                       -1 )
    , chainStrOrigin(                nullptr   )
    , chainStrTrans (                nullptr   )
    , chainOrigin   (                       -1 )
    , chainTrans    (                       -1 )
    , chainPosition (                       -1 )
    , variableName  (                nullptr   )
{
    RTDiag::panic( "Unavailable method called:\n"
		   "    'RTDaemonInfo( const RTDaemonInfo & )'" );
}
//lint -restore

RTDaemonInfo & RTDaemonInfo::operator=( const RTDaemonInfo & )
{
    RTDiag::panic( "Unavailable method called:\n"
	    "    'RTDaemonInfo::operator=( const RTDaemonInfo & )'" );

    //lint -unreachable
    return *this;
} //lint !e1529
