/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDataObject.h>
#include <RTDecoding.h>
#include <RTEncoding.h>
#include <RTObject_class.h>
#include <RTnew.h>

static void _init( const RTObject_class *, void * target )
{
    (void)new( target ) RTDataObject;
}

static void _copy( const RTObject_class *,
		   void                 * target,
		   const void           * source )
{
    (void)new( target ) RTDataObject( * static_cast<const RTDataObject *>(source) );
}

#if OBJECT_DECODE
static int _decode( const RTObject_class *, void *, RTDecoding * )
{
    return 1; // this must be a null object
}
#endif

#if OBJECT_ENCODE
static int _encode( const RTObject_class *, const void *, RTEncoding * )
{
    return 1;
}
#endif

const RTObject_class RTDataObject::classData =
{
	nullptr,
    nullptr,
    "Null",
    0 /* RTVersionId */,
    sizeof( RTDataObject ),
    _init,
    _copy,
	nullptr, // Not movable
#if OBJECT_DECODE
    _decode,
#endif
#if OBJECT_ENCODE
    _encode,
#endif
    RTDataObject_destroy,
    0, nullptr
};

#if OBJECT_DECODE
RTTypeInstaller RTDataObject_installer( RTType_RTDataObject );
#endif

const RTObject_class * RTDataObject::getClassData( void ) const
{
    return &RTDataObject::classData;
}
