/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTAsciiEncoding.h>
#include <RTDataObject.h>
#include <RTMemoryUtil.h>
#include <RTMemoryOutBuffer.h>

int RTDataObject::printString( char * target, int size ) const
{
    RTMemoryOutBuffer buffer( target, size );
    RTAsciiEncoding   coding( &buffer );

    if( put( coding ) == 0 )
	return 0;

    if( buffer.write( "", 1 ) != 1 )
	return 0;

    return RTMemoryUtil::strlen( target );
}
