/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActor.h>
#include <RTActorRef.h>
#include <RTActorRefProbe.h>
#include <RTDebugger.h>
#if USE_THREADS
#include <RTMutex.h>
#endif
#include <RTProbe.h>

void RTDebugger::actorIncarnated( RTActor * actor )
{
#if USE_THREADS
	_mutex->enter();
#endif

	RTProbe * probe;

	for( int i = 0; i < parkedProbes.size(); ++i )
	{
		if( (probe = static_cast<RTProbe *>(parkedProbes[ i ])) != nullptr &&
				probe->connectProbe() != 0 )
		{
			parkedProbes[ i ] = nullptr;
			--nrParkedProbes;
		}
	}

	RTActorRef * homeRef = actor->getReference();

	if( homeRef != nullptr && homeRef->probe != nullptr )
		homeRef->probe->evtPresence( actor->getIndex(), -1, -1 );

#if USE_THREADS
	_mutex->leave();
#endif
}
