/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActor.h>
#include <RTActorProbe.h>
#include <RTDebugger.h>

#if USE_THREADS
#include <RTMutex.h>
#endif

void RTDebugger::addFieldValue( const char * variable, // ESV name
		const char * value,    // value or 0 if read
		int          probeNr )
{
#if USE_THREADS
	_mutex->enter();
#endif

	RTActorProbe * probe = static_cast<RTActorProbe *>(probes[ probeNr ]);

	if( probe != nullptr )
	{
		RTActor * actor = probe->actor();

		if( actor != nullptr )
		{
			probe->addFieldValue( variable, value );
			sendProbeSignal( actor, Synchronous );
		}
	}

#if USE_THREADS
	_mutex->leave();
#endif
}
