/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTController.h>
#include <RTDebugger.h>
#if USE_THREADS
#include <RTMutex.h>
#endif

void RTDebugger::attach( RTController * task )
{
#if USE_THREADS
    _mutex->enter();
#endif

    if( task->_state == RTController::detached )
	task->_state  = RTController::execSystem;

#if USE_THREADS
    _mutex->leave();
#endif
}
