/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTController.h>
#include <RTDebugger.h>
#if USE_THREADS
#include <RTMutex.h>
#endif
#include <RTProbe.h>

int RTDebugger::breakPoint( RTController * task, RTEventInfo * eventInfo )
{
#if USE_THREADS
    _mutex->enter();
#endif

    int shouldHalt = addEvent( eventInfo );

    if( phase() == RTJob::finished )
    {
	// do not wait
    }
    else if( shouldHalt > 0 )
    {
	task->_state = RTController::waitContinue;
	mode = Halted;
	evtRtsStatus();
    }

#if USE_THREADS
    _mutex->leave();
#endif

    return shouldHalt;
}
