/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDebugger.h>
#include <RTIOMonitor.h>
#include <RTObserver.h>

void RTDebugger::closeObservability( void )
{
#if USE_THREADS
	shutdownUdp();
#endif

	listener.close();

	for( int i = observers.size(); --i >= 0; )
	{
		delete static_cast<RTObserver *>(observers[ i ]);
		observers[ i ] = nullptr;
	}

	delete ioMonitor;
	ioMonitor = nullptr;
}
