/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDebugger.h>
#include <RTTimerActor.h>
#include <RTinet.h>

//lint -save -esym(1927,RTDebugger::traceLevel)

RTDebugger::RTDebugger( void )
: RTJob()
, mode          (            Halted )
, tasks         ( nullptr           )
, input         (                   )
, step_count    (                0U )
, freeList      ( nullptr           )
, freeListSize  (                0U )
#if OBSERVABLE
, probes        (                   )
, parkedProbes  (                   )
, nrParkedProbes(                 0 )
, lastTimestamp (            0L, 0L )
, zeroTimeBase  (            0L, 0L )
, listener      (                   )
, ioMonitor     ( nullptr           )
#if USE_THREADS
, _udp          (    INET_NO_SOCKET )
, _udp_port     (                 0 )
#ifdef TARGET_PSOS
, _trigger      ( nullptr           )
#endif
#endif
, eventHead     ( nullptr           )
, eventTail     ( nullptr           )
, sockets       (                   )
, observers     (                   )
#endif // OBSERVABLE
{
	for( int i = 0; i < TraceAll; ++i )
		traceLevel[ i ] = DEBUG_TERSE;

#if OBSERVABLE
	RTTimerActor::getRelativeClock( zeroTimeBase );
	lastTimestamp = zeroTimeBase;
#endif // OBSERVABLE
}

//lint -restore
