/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTController.h>
#include <RTDebugger.h>
#if USE_THREADS
#include <RTMutex.h>
#endif

void RTDebugger::deregisterRTS( RTController * task )
{
#if USE_THREADS
    _mutex->enter();
#endif

    if( tasks == task )
	tasks = ( task->_next != task ) ? task->_next
					: nullptr;

    task->_next->_prev = task->_prev;
    task->_prev->_next = task->_next;

    task->_next  = task;
    task->_prev  = task;
    task->_state = RTController::detached;

#if USE_THREADS
    _mutex->leave();
#endif
}
