/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDebugger.h>
#include <RTEventInfo.h>
#include <RTObserver.h>

void RTDebugger::dispatchEvent( RTEventInfo * eventInfo )
{
	for( int iObs = 0; iObs < observers.size(); ++iObs )
	{
		if( eventInfo->observerId < 0 || eventInfo->observerId == iObs )
		{
			RTObserver * observer = static_cast<RTObserver *>(observers[ iObs ]);

			if( observer != nullptr )
				observer->dispatchEvent( *eventInfo );
		}
	}
}
