/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTController.h>
#include <RTDebugger.h>
#include <RTDiag.h>
#include <RTDiagStream.h>
#if USE_THREADS
#include <RTMutex.h>
#endif

void RTDebugger::doCmdQuit( void )
{
#if USE_THREADS
    _mutex->enter();
#endif

    RTController * task  = tasks;
    int            index = 0;

    if( task != nullptr )
    {
	do
	{
	    if( task->_state != RTController::detached )
	    {
		RTDiag::out() << "  Task " << index << " detached\n";
		task->_state = RTController::detached;
#if USE_THREADS
		wakeup( task );
#endif
	    }
	}
	while( ++index, (task = task->_next) != tasks );
    }

#if USE_THREADS
    _mutex->leave();
#endif

    proceed();
    enter( RTJob::finished );
}
