/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActor.h>
#include <RTDebugger.h>
#include <RTEventInfo.h>

int RTDebugger::evtHistory( int             probeNr,
			    int             actorIndex,
			    const RTActor * actor,
			    int             stateTarget,
			    int             histHist,
			    int             histCurr )
{
    RTEventInfo * eventInfo = new RTEventInfo( RTEventInfo::EventHistory,
					       probeNr,
					       actorIndex );

    eventInfo->stateTarget = stateTarget;
    eventInfo->histHist    = histHist;
    eventInfo->histCurr    = histCurr;
    eventInfo->actor       = actor;
    eventInfo->info        = actor != nullptr
			     ? actor->getActorData()
			     :nullptr;

    return addEvent( eventInfo );
}
