/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActor.h>
#include <RTDebugger.h>
#include <RTEventInfo.h>

int RTDebugger::evtPresence( int             probeNr,
			     int             actorIndex,
			     const RTActor * actor,
			     int             observerId,
			     int             daemonId )
{
    RTEventInfo * eventInfo = new RTEventInfo( RTEventInfo::EventPresence,
					       probeNr,
					       actorIndex );

    if( observerId < 0 )
	getTimestamp( eventInfo->timestamp );

    eventInfo->actor      = actor;
    eventInfo->info       = actor != nullptr
			    ? actor->getActorData()
			    :nullptr;
    eventInfo->observerId = observerId;
    eventInfo->daemonId   = daemonId;

    return addEvent( eventInfo );
}
