/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActor.h>
#include <RTDebugger.h>
#include <RTEventInfo.h>

int RTDebugger::evtReference( int             probeNr,
			      const RTActor * actor,
			      int             compIndex,
			      int             nrIncarns,
			      int             observerId )
{
    RTEventInfo * eventInfo = new RTEventInfo( RTEventInfo::EventReference,
					       probeNr,
					       -1 );

    if( observerId < 0 ) // invalid observer Id: event (otherwise request)
	getTimestamp( eventInfo->timestamp );

    eventInfo->compIndex  = compIndex;
    eventInfo->nrIncarns  = nrIncarns;
    eventInfo->observerId = observerId;
    eventInfo->actor      = actor;
    eventInfo->info       = actor->getActorData();

    return addEvent( eventInfo );
}
