/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActor.h>
#include <RTDebugger.h>
#include <RTEventInfo.h>
#include <RTMemoryUtil.h>

int RTDebugger::evtVariable( int             probeNr,
			     int             actorIndex,
			     const RTActor * actor,
			     const char    * varName,
			     const char    * varValue )
{
    RTEventInfo * eventInfo = new RTEventInfo( RTEventInfo::EventVariable,
					       probeNr,
					       actorIndex );

    getTimestamp( eventInfo->timestamp );
    eventInfo->varName  = RTMemoryUtil::strdup( varName  );
    eventInfo->varValue = RTMemoryUtil::strdup( varValue );
    eventInfo->actor    = actor;
    eventInfo->info     = actor->getActorData();

    return addEvent( eventInfo );
}
