/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2019, 2020.All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDebugger.h>

#include <RTActorProbe.h>
#include <RTMutex.h>

void RTDebugger::addFieldMonitor( int probeNr,
                                  const char * variable )
{
#if USE_THREADS
    _mutex->enter();
#endif

    RTActorProbe * probe = static_cast<RTActorProbe *>(probes[ probeNr ]);

    if( probe != nullptr )
    {
        probe->addFieldMonitor( variable );
    }

#if USE_THREADS
    _mutex->leave();
#endif
}

void RTDebugger::delFieldMonitor( int probeNr,
                                  const char * variable )
{
#if USE_THREADS
    _mutex->enter();
#endif

    RTActorProbe * probe = static_cast<RTActorProbe *>(probes[ probeNr ]);

    if( probe != nullptr )
    {
        probe->delFieldMonitor( variable );
    }

#if USE_THREADS
    _mutex->leave();
#endif
}
