/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDebugger.h>
#include <RTMessage.h>
#include <RTResourceMgr.h>

void RTDebugger::freeMsg( RTMessage * msg )
{
#if PURIFY
    delete msg;
#else
    const unsigned maxFreeListSize = 100U;
    const unsigned minFreeListSize =  20U;

    msg->clear();

    msg->next = freeList;
    freeList = msg;
    if( ++freeListSize > maxFreeListSize )
    {
	RTController::resourceMgr.msgFree( freeList,
					   freeListSize - minFreeListSize );
	freeListSize = minFreeListSize;
    }
#endif
}
