/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActorProbe.h>
#include <RTDaemonInfo.h>
#include <RTDebugger.h>

#if USE_THREADS
#include <RTMutex.h>
#endif

int RTDebugger::inject( int                    inwards,
			const char           * signal,
			int                    prio,
			const void           * data,
			const RTObject_class * type,
			const RTDaemonInfo   & daemonInfo )
{
#if USE_THREADS
    _mutex->enter();
#endif

    RTActorProbe * probe  = static_cast<RTActorProbe *>(probes[ daemonInfo.probeNr ]);
    int            result = ( probe != nullptr )
				? probe->inject( inwards, signal, prio, data, type, daemonInfo )
				: 0;

#if USE_THREADS
    _mutex->leave();
#endif

    return result;
}
