/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDebugger.h>
#include <RTMessage.h>
#include <RTResourceMgr.h>

RTMessage * RTDebugger::newMsg( void )
{
#if PURIFY
	return new RTMessage;
#else
	RTMessage * msg = freeList;

	if( msg == nullptr )
	{
		freeListSize += RTController::resourceMgr.msgAlloc( freeList );
		msg = freeList;
	}

	if( msg != nullptr )
	{
		freeList = msg->next;
		--freeListSize;
	}

	return msg;
#endif
}
