/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActor.h>
#include <RTDebugger.h>
#include <RTDiag.h>
#include <RTDiagStream.h>

void RTDebugger::printActor( const RTActor * actor )
{
    const char * aname;
    const char * tname;
    const char * state;

    if( actor != nullptr )
    {
	aname = actor->getName();
	tname = actor->getTypeName();
	state = actor->getCurrentStateString();
    }
    else
    {
	aname = "<no-name>";
	tname = "System Actor";
	state = "<no-state>";
    }

    RTDiag::out() << aname << "(" << tname << ")<" << state << ">";
}
