/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDebugger.h>
#if USE_THREADS
#include <RTMutex.h>
#endif
#include <RTProbe.h>

void RTDebugger::probeCreated( int probeId, RTProbe * probe )
{
#if USE_THREADS
	_mutex->enter();
#endif

	probes[ probeId ] = probe;
	if( probe->connectProbe() == 0 )
	{
		parkedProbes[ parkedProbes.unusedIndex() ] = probe;
		++nrParkedProbes;
	}

#if USE_THREADS
	_mutex->leave();
#endif
}
