/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActor.h>
#include <RTController.h>
#include <RTDebugger.h>
#include <RTMessage.h>
#include <RTSpecialSignals.h>

void RTDebugger::sendProbeSignal( RTActor * actor, int priority )
{
	if( actor == nullptr )
		return;

	RTController * receiver = actor->context();
	RTMessage    * destMsg  = newMsg();

	if( destMsg == nullptr )
	{
		receiver->setError( RTController::noMem,
				RTController::SystemService, nullptr, nullptr );
	}
	else
	{
		destMsg->setData( nullptr, nullptr );
		destMsg->setSignal( RTProbeSignal );
		destMsg->setPriority( priority );
		destMsg->setDestination( actor, nullptr, 0 );

#if USE_THREADS
		receiver->peer_receive( destMsg );
#else
		receiver->receive( destMsg, nullptr );
#endif
	}
}
