/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDebugger.h>
#include <RTDiag.h>
#include <RTIOMonitor.h>
#include <RTinet.h>

void RTDebugger::startupUdp( void )
{
    RTinet_address address;

    if( (_udp = RTinet_UDP_create()) == INET_NO_SOCKET )
	RTDiag::panic( "UDP_create(dbg)" );

    else
    {
	if( RTinet_bind( _udp, nullptr, 0 ) == 0 )
	    RTDiag::panic( "bind(dbg)" );

	else if( RTinet_getname( _udp, &address, &_udp_port ) == 0 )
	    RTDiag::panic( "getsockname(dbg)" );

	else
	{
	    ioMonitor->add( _udp, RTIOMonitor::CanRead );
	    return;
	}

	//lint -unreachable
	RTinet_close( _udp );
	_udp = INET_NO_SOCKET;
    }
}
