/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDebugger.h>
#include <RTEventInfo.h>
#include <RTObserver.h>
#if USE_THREADS
#include <RTMutex.h>
#endif

int RTDebugger::useEvent( void )
{
    int result = 0;

#if USE_THREADS
    _mutex->enter();
#endif

    RTEventInfo * eventInfo;

    if( (eventInfo = eventTail) != nullptr ) // get last in list
    {
	result = 1;

	if( eventTail->prev != nullptr )     // > 1 event in list
	    eventTail->prev->next = nullptr;
	else
	    eventHead = nullptr;

	eventTail       = eventTail->prev;
	eventInfo->prev = nullptr;

	dispatchEvent( eventInfo );
	delete eventInfo;
    }

#if USE_THREADS
    _mutex->leave();
#endif

    return result;
}
