/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTController.h>
#include <RTDebugger.h>
#include <RTMessage.h>
#include <RTSpecialSignals.h>

void RTDebugger::wakeup( RTController * controller )
{
    RTMessage * msg = newMsg();

    if( msg == nullptr )
    {
	controller->setError( RTController::noMem,
			      RTController::SystemService, nullptr, nullptr );
    }
    else
    {
	msg->setSignal( RTWakeupSignal );
	msg->setPriority( Synchronous );
	msg->setDestination( nullptr, nullptr, 0 );

	controller->peer_receive( msg );
    }
}
