/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDebuggerInput.h>
#include <RTDiag.h>
#include <RTDiagStream.h>

int RTDebuggerInput::getChar( void )
{
	int c;

	if( unget_size > 0 )
		c = unget_buffer[ --unget_size ];
	else if( input != nullptr )
	{
		if( *input == '\0' )
		{
			input = nullptr;
			c = '\n';
		}
		else
			c = *input++;
	}
	else
	{
		if( need_prompt != 0 && prompt != nullptr )
		{
			RTDiagStream & out = RTDiag::out();

			out << prompt;
			out.flush();
		}
		need_prompt = 0;

		c = nextChar();

		if( c == '\n' )
			need_prompt = 1;
	}

	return c;
}
