/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDebuggerInput.h>

int RTDebuggerInput::getString( char * buf, int buf_size )
{
	int c;

	do
	{
		c = getChar();

		if( isEol( c ) != 0 )
		{
			ungetChar( static_cast<char>(c) );
			*buf = '\0';
			return 0;
		}
	}
	while( c == ' ' || c == '\t' );

	do
	{
		if( --buf_size == 0 )
			buf_size = 1;
		else
			*buf++ = static_cast<char>(c);
		c = getChar();
	}
	while( ! ( isEol( c ) != 0 || c == ' ' || c == '\t' ) );

	ungetChar( static_cast<char>(c) );

	*buf = '\0';

	return 1;
}
