/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDebuggerInput.h>
#include <RTstdio.h>
#include <errno.h>

int RTDebuggerInput::nextChar( void )
{
    FILE * f = stdin;
    int    c;

    for(;;)
    {
	c = fgetc( f );

	if( feof( f ) != 0 )
	{
	    // skip other tests
	}
	else if( ferror( f ) == 0 )
	{
	    break;
	}
#if defined( EINTR )
	else if( errno == EINTR )
	{
	    clearerr( f );
	    continue;
	}
#endif
	else
	{
	    perror( "fgetc" );
	}

	c = EOF;
	break;
    }

    return c;
}
