/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDiag.h>
#include <RTDiagStream.h>

void RTDiag::failed_assertion( const char * expr, const char * file, int line )
{
    RTDiagStream & s = out();

    s.lock() << "Assertion: " << expr
	     << "\nfailed at line " << line << " of " << file << "\n";
    s.unlock();
    panic( "assertion failure" );
}
