/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDictionary.h>

RTDictionary & RTDictionary::operator=( const RTDictionary & other )
{
	if( this != &other )
	{
		unsigned i;

		for( i = _size; i-- > 0U; )
		{
			RTAssociation * assoc = &_contents[ i ];

			if( assoc->key == nullptr || assoc->key == reinterpret_cast<char *>(assoc) )
				continue;

			delete [] assoc->key;
			assoc->key = reinterpret_cast<char *>(assoc);
		}

		for( i = other._size; i-- > 0U; )
		{
			const RTAssociation * assoc = &other._contents[ i ];

			if( assoc->key == nullptr || assoc->key == reinterpret_cast<const char *>(assoc) )
				continue;

			(void)atPut( assoc->key, assoc->value );
		}

	}
	return *this;
}
