/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDictionary.h>

RTDictionary::RTDictionary( unsigned initialSize )
    : _size( initialSize > 0U ? initialSize : 32U )
    , _used( 0U )
    , _contents( new RTAssociation [ _size ] )
{
    for( unsigned i = 0U; i < _size; ++i )
	_contents[i].key = nullptr;
}

RTDictionary::RTDictionary( const RTDictionary & other )
    : _size( other._size )
    , _used( 0U )
    , _contents( new RTAssociation [ _size ] )
{
    for( unsigned i = 0U; i < _size; ++i )
	_contents[i].key = nullptr;

    *this = other;
}
