/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDictionary.h>
#include <RTMemoryUtil.h>

RTAssociation * RTDictionary::find( const char * key ) const
{
	if( key ==nullptr )
		return nullptr; // keys are never nil

	if( _used == 0U )
		return nullptr; // this dictionary is empty

	unsigned        index = hash( key, _size );
	RTAssociation * assoc = &_contents[ index ];
	unsigned        tests = 0U;

	for(;;)
	{
		if( assoc->key != nullptr   &&
				assoc->key != reinterpret_cast<char *>(assoc) &&
				RTMemoryUtil::strcmp( assoc->key, key ) == 0 )
		{
			return assoc;
		}

		if( assoc->key == nullptr )
			break;

		if( ++tests == _size )
			break; // we looked everywhere

		if( ++index == _size )
		{
			index = 0U;
			assoc = _contents;
		}
		else
			++assoc;
	}

	return nullptr; // key not found
}
