/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTElasticArray.h>

RTElasticArray::RTElasticArray( int initial_size )
: _size    ( initial_size )
, _contents( nullptr   )
{
	if( _size <= 0 )
		_size = 0;
	else
	{
		_contents = new void * [ static_cast<unsigned>(_size) ];

		for( int i = 0; i < _size; ++i )
			_contents[i] = nullptr;
	}
}

RTElasticArray::RTElasticArray( const RTElasticArray & other )
: _size    ( other._size )
, _contents( nullptr  )
{
	if( _size <= 0 )
		_size = 0;
	else
	{
		_contents = new void * [ static_cast<unsigned>(_size) ];

		for( int i = 0; i < _size; ++i )
			_contents[i] = other._contents[i];
	}
}
