/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTElasticArray.h>

void RTElasticArray::resize( int min_size )
{
	if( min_size < 0 )
		min_size = 0;

	if( _size == min_size )
		return;

	int new_size;

	if( _size < min_size )
		new_size = min_size;
	else
	{
		for( new_size = _size; new_size > min_size; --new_size )
			if( _contents[ new_size - 1 ] != nullptr )
				break;

		if( _size == new_size )
			return;

		_size = new_size;
	}

	if( new_size == 0 )
	{
		delete [] _contents;
		_size     = 0;
		_contents = nullptr;
	}
	else
	{
		void ** old_contents = _contents;
		int     i;

		_contents = new void * [ static_cast<unsigned>(new_size)];

		for( i = 0; i < _size; ++i )
			_contents[i] = old_contents[i];

		_size = new_size;

		for( ; i < _size; ++i )
			_contents[i] = nullptr;

		delete [] old_contents;
	}
}
