/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDiag.h>
#include <RTEnumerated.h>
#include <RTObject_class.h>

static RTDataObject * _access( RTEnumerated * target )
{
    return target;
}

static void RTEnumerated_init( const RTObject_class *, void * )
{
    // We cannot do this: RTEnumerated is an abstract class!
    RTDiag::panic( "RTEnumerated_init" );
}

static void RTEnumerated_copy( const RTObject_class *, void *, const void * )
{
    // We cannot do this: RTEnumerated is an abstract class!
    RTDiag::panic( "RTEnumerated_copy" );
}

static void RTEnumerated_move( const RTObject_class *, void *, void * )
{
    // We cannot do this: RTEnumerated is an abstract class!
    RTDiag::panic( "RTEnumerated_move" );
}

const RTObject_class RTEnumerated::classData =
{
    &RTType_RTDataObject,
    reinterpret_cast<RTSuperAccessFunction>(_access),
    "Null",
    0 /* RTVersionId */,
    sizeof( RTEnumerated ),
    RTEnumerated_init,
    RTEnumerated_copy,
	RTEnumerated_move,
#if OBJECT_DECODE
    RTEnumerated_decode,
#endif
#if OBJECT_ENCODE
    RTEnumerated_encode,
#endif
    RTDataObject_destroy,
    0,nullptr
};
