/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTEventInfo.h>

RTEventInfo::RTEventInfo( EventType theEventKind,
			  int       theProbeNr,
			  int       theActorIndex )
    : eventKind     (             theEventKind )
    , probeNr       (               theProbeNr )
    , actorIndex    (            theActorIndex )
    , observerId    (                       -1 )
    , daemonId      (                       -1 )
    , timestamp     (                   0L, 0L )
    , chainStrOrigin( nullptr                  )
    , chainStrTrans ( nullptr                  )
    , chainOrigin   (                       -1 )
    , chainPosition (                       -1 )
    , chainParent   (                       -1 )
    , stateStrTarget( nullptr                  )
    , stateTarget   (                       -1 )
    , portName      ( nullptr                  )
    , message       ( nullptr                  )
    , sendMethod    (               SendNormal )
    , signalName    ( nullptr                  )
    , actor         ( nullptr                  )
    , info          ( nullptr                  )
    , compIndex     (                       -1 )
    , nrIncarns     (                        0 )
    , varName       ( nullptr                  )
    , varValue      ( nullptr                  )
    , histStrHist   ( nullptr                  )
    , histStrCurr   ( nullptr                  )
    , histHist      (                       -1 )
    , histCurr      (                       -1 )
    , targetMode    (                   Halted )
    , prev          ( nullptr                  )
    , next          ( nullptr                  )
{
}
