/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDiag.h>
#include <RTEventInfo.h>

//lint -save -e1738
RTEventInfo::RTEventInfo( const RTEventInfo & )
    : eventKind     (            EventPresence )
    , probeNr       (                       -1 )
    , actorIndex    (                       -1 )
    , observerId    (                       -1 )
    , daemonId      (                       -1 )
    , timestamp     (                   0L, 0L )
    , chainStrOrigin( nullptr                  )
    , chainStrTrans ( nullptr                  )
    , chainOrigin   (                       -1 )
    , chainPosition (                       -1 )
    , chainParent   (                       -1 )
    , stateStrTarget( nullptr                  )
    , stateTarget   (                       -1 )
    , portName      ( nullptr                  )
    , message       ( nullptr                  )
    , sendMethod    (               SendNormal )
    , signalName    ( nullptr                  )
    , actor         ( nullptr                  )
    , info          ( nullptr                  )
    , compIndex     (                       -1 )
    , nrIncarns     (                        0 )
    , varName       ( nullptr                  )
    , varValue      ( nullptr                  )
    , histStrHist   ( nullptr                  )
    , histStrCurr   ( nullptr                  )
    , histHist      (                       -1 )
    , histCurr      (                       -1 )
    , targetMode    (                   Halted )
    , prev          ( nullptr                  )
    , next          ( nullptr                  )
{
    RTDiag::panic( "Unavailable method called:\n"
		   "    'RTEventInfo( const RTEventInfo & )'" );
}
//lint -restore

RTEventInfo & RTEventInfo::operator=( const RTEventInfo & )
{
    RTDiag::panic( "Unavailable method called:\n"
	    "    'RTEventInfo::operator=( const RTEventInfo & )'" );

    //lint -unreachable
    return *this;
} //lint !e1529
