/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTException.h>
#include <RTSignalDescriptor.h>

static const RTSignalDescriptor Exception_Signals[] =
{
		{
				"arithmeticError", nullptr,
				Exception::Base::rti_arithmeticError
		},
		{
				"error", nullptr,
				Exception::Base::rti_error
		},
		{
				"notFoundError", nullptr,
				Exception::Base::rti_notFoundError
		},
		{
				"notUnderstoodError", nullptr,
				Exception::Base::rti_notUnderstoodError
		},
		{
				"serviceAccessError", nullptr,
				Exception::Base::rti_serviceAccessError
		},
		{
				"streamError", nullptr,
				Exception::Base::rti_streamError
		},
		{
				"subclassResponsibilityError", nullptr,
				Exception::Base::rti_subclassResponsibilityError
		},
		{
				"timeSliceError", nullptr,
				Exception::Base::rti_timeSliceError
		},
		{
				"userError", nullptr,
				Exception::Base::rti_userError
		}
};

const RTProtocolDescriptor Exception::Base::rt_class =
{
		nullptr,
		&rt_class,
		"Exception",
		0 /* RTVersionId */,
		sizeof( Exception_Signals ) / sizeof( Exception_Signals[ 0 ] ),
		Exception_Signals
};
