/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTExternal.h>
#include <RTMutex.h>

// This mutex prevents a race condition between calls to disable and raise.
// More efficient implementations may be available in some configurations.
static RTMutex critical;

RTMessage * External::Base::unload( void )
{
    critical.enter();

    RTMessage * oldMsg = msg;

    msg = nullptr;

    critical.leave();

    return oldMsg;
}
