/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTArray_class.h>
#include <RTDecoding.h>
#include <RTFieldDescriptor.h>
#include <RTObject_class.h>
#include <RTTypeModifier.h>

static int array_decode( RTDecoding           * coding,
			 void                 * target,
			 int                    size,
			 const RTObject_class * element )
{
    RTArray_class array( size, element );

    return coding->get_indirect( target, &array );
}

int RTFieldDescriptor::decode( void * target, RTDecoding * coding ) const
{
    void * field = RTObjectOf( void, offset, target );

    if( type == nullptr )
	return 0;
    else if( modifier == nullptr )
	return type->decode( field, coding );
    else
    {
	int size = (*modifier->_num_elements_func)( modifier, target );

	if( modifier->_indirect != 0 )
	    return array_decode( coding, field, size, type );
	else
	    return coding->get_array( field, size, type );
    }
}
