/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTArray_class.h>
#include <RTEncoding.h>
#include <RTFieldDescriptor.h>
#include <RTObject_class.h>
#include <RTTypeModifier.h>

static int vector_encode( RTEncoding           * coding,
			  const void           * source,
			  int                    size,
			  const RTObject_class * element )
{
    RTArray_class array( size, element );

    return coding->put_indirect( source, &array );
}

int RTFieldDescriptor::encode( const void * source, RTEncoding * coding ) const
{
    const void * field = RTConstObjectOf( void, offset, source );

    if( type == nullptr )
	return 0;
    else if( modifier == nullptr )
	return type->encode( field, coding );
    else
    {
	int size = (*modifier->_num_elements_func)( modifier, source );

	if( modifier->_indirect != 0 )
	    return vector_encode( coding, field, size, type );
	else
	    return coding->put_array( field, size, type );
    }
}
