/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTArray_class.h>
#include <RTFieldDescriptor.h>
#include <RTObject_class.h>
#include <RTTypeModifier.h>

static void array_init( void                 * target,
		const RTObject_class * element,
		int                    size,
		int                    indirect )
{
	RTArray_class array( size, element );

	if( indirect == 0 )
		array.init( target );
	else
	{
		void * target_array = array.allocate();

		* static_cast<void **>(target) = target_array;

		if( target_array != nullptr )
			array.init( target_array );
	}
}

void RTFieldDescriptor::init( void * target ) const
{
	void * field = RTObjectOf( void, offset, target );

	if( modifier == nullptr )
		type->init( field );
	else
		array_init( field, type,
				(*modifier->_num_elements_func)( modifier, target ),
				modifier->_indirect );
}
