/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTFloat.h>

int RTFloat::div10( void )
{
	int   nonZero = 0;
	dword carry   = 0UL;
	dword quotient;

	for( int i = 0; i < mantissa_words; ++i )
	{
		quotient   = carry;
		quotient <<= bits_per_word;
		quotient  += static_cast<dword>(mantissa[ i ]);

		carry          = quotient % 10UL;
		quotient      /= 10UL;
		mantissa[ i ]  = static_cast<word>( word_mask & static_cast<word>(quotient) );

		if( quotient != 0UL )
			nonZero = 1;
	}

	return nonZero;
}
