/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDiag.h>
#include <RTFloat.h>

void RTFloat::mul10( int add )
{
	RTAssert( 0 <= add && add <= 9 );

	if( mantissa[ 0 ] >= word_scale / 10 )
		++exp10;
	else
	{
		dword carry = add;

		for( int i = mantissa_words; --i >= 0; )
		{
			carry          += 10UL * static_cast<dword>(mantissa[ i ]);
			mantissa[ i ]   = static_cast<word>( word_mask & static_cast<word>(carry) );
			carry         >>= bits_per_word;
		}
	}
}
