/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifdef PRAGMA
#pragma implementation "RTFormat.h"
#endif

#include <RTFormat.h>

int RTFormat::_unsigned( unsigned long   value,
		char          * buffer,
		int             bufferSize )
{
	char   reversed[ 40 ];
	char * cursor = reversed;

	do
		*cursor++ = static_cast<char>( '0' + static_cast<int>( value % 10UL ) );
	while( (value /= 10UL) > 0UL );

	int size = static_cast<int>(cursor - reversed);

	if( size + 1 > bufferSize )
		return 0;

	while( cursor != reversed )
		*buffer++ = *--cursor;

	*buffer = '\0';

	return size;
}
