/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTFormat.h>
#include <stdint.h>

static const char hex[] = "0123456789abcdef";

int RTFormat::_void( const void * address,
		char * buffer,
		int bufferSize )
{
	uintptr_t value  = reinterpret_cast<uintptr_t>(address);
	char            reversed[ 2 * sizeof( void * ) + 3 ];
	char          * cursor = reversed;

	do
		*cursor++ = hex[ value & 0xFUL ];
	while( (value >>= 4) > 0UL );

	*cursor++ = 'x';
	*cursor++ = '0';

	int size = static_cast<int>(cursor - reversed);

	if( size + 1 > bufferSize )
		return 0;

	while( cursor != reversed )
		*buffer++ = *--cursor;

	*buffer = '\0';

	return size;
}
