/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActorRef.h>
#include <RTController.h>
#include <RTFrame.h>

int Frame::Base::destroy( RTActorRef & reference )
{
	RTController * controller = context();

	controller->trace( RTController::FrameDestroy, &reference, nullptr );

#if RTFRAME_CHECKING != RTFRAME_CHECK_NONE
	if( permissionCheck( RTController::FrameDestroy, &reference, 0 ) == 0 )
		return 0; // not allowed
#endif

	if( reference.isOptional() == 0 )
	{
		controller->setError( RTController::notOptional,
				RTController::FrameDestroy, &reference, nullptr );
		return 0;
	}

	return reference.destroy();
}
