/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActorId.h>
#include <RTActorRef.h>
#include <RTController.h>
#include <RTFrame.h>

int Frame::Base::import( const RTActorId & actorid,
		RTActorRef      & dest,
		int               index )
{
#if RTFRAME_CHECKING != RTFRAME_CHECK_NONE
	if( permissionCheck( RTController::FrameImport, &dest, 1 ) == 0 )
		return 0; // not allowed
#endif

	return dest.import( actorid.getRTActor(), index );
}
