/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActorId.h>
#include <RTActorRef.h>
#include <RTFrame.h>

RTActorId ** Frame::Base::incarnationsOf( const RTActorRef & reference )
{
    int          i           = reference.size() + 2;
    RTActorId ** returnValue = new RTActorId * [ static_cast<unsigned>(i) ];

    returnValue[--i] = nullptr;
    while( --i > 0 )
    	returnValue[i] = new RTActorId( reference.at( i ) );

    returnValue[0] = nullptr;

    return returnValue;
}
