/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActor.h>
#include <RTActorRef.h>
#include <RTController.h>
#include <RTFrame.h>

int Frame::Base::permissionCheck( RTController::Primitive   primitive,
		RTActorRef              * reference,
		int                       trace )
{
#if RTFRAME_CHECKING == RTFRAME_CHECK_LOOSE

	RTController * controller = context();

	if( reference->context() != controller )
	{
		if( trace != 0 )
			controller->trace( primitive, reference, nullptr );

		controller->setError( RTController::notOwner, primitive, reference, nullptr );
		return 0;
	}

#elif RTFRAME_CHECKING == RTFRAME_CHECK_STRICT

	RTActor * owner = getOwner();

	if( owner != reference->getOwner() )
	{
		RTController * controller = owner->context();

		if( trace != 0 )
			controller->trace( primitive, reference, nullptr );

		controller->setError( RTController::notOwner,
				primitive, reference, nullptr );
		return 0;
	}

#endif

	return 1;
}
