/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTIOMonitor.h>

void RTIOMonitor::remove( int fd, int bits )
{
	if( fd < 0 || (bits &= RequestMask) == 0 )
		return;

	unsigned lo;
	unsigned hi;

	// Entries are sorted: do binary search.
	for( lo = 0U, hi = _used; lo < hi; )
	{
		unsigned   mid   = ( lo + hi ) >> 1;
		Entry    * entry = &_entries[ mid ];

		if( entry->fd == static_cast<unsigned>(fd) )
		{
			entry->bits &= bits ^ RequestMask;

			if( entry->bits == 0 ) // remove useless entries
				for( --_used; mid < _used; ++entry, ++mid )
					entry[ 0 ] = entry[ 1 ];

			return;
		}

		if( entry->fd > static_cast<unsigned>(fd) )
			hi = mid;
		else
			lo = mid + 1U;
	}
}
