/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTIOMonitor.h>
#include <RTTimespec.h>

int RTIOMonitor::status( int fd )
{
	if( fd < 0 )
		return 0;

	unsigned lo = 0U;
	unsigned hi = _used;

	if( hi == 0U )
		return 0;

	(void)wait( &RTTimespec::zero );

	// Entries are sorted: do binary search.

	while( lo < hi )
	{
		unsigned   mid   = ( lo + hi ) >> 1;
		Entry    * entry = &_entries[ mid ];

		if( entry->fd == static_cast<unsigned>(fd) )
			return entry->bits >> ResultShift; //lint !e702

		if( entry->fd > static_cast<unsigned>(fd) )
			hi = mid;
		else
			lo = mid + 1U;
	}

	return 0;
}
