/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTInjector.h>
#if USE_THREADS
#include <RTMutex.h>
#endif

std::function<RTActor* (RTController *, RTActorRef *, int)> RTInjector::getCreateFunction(const std::string& id) {
#if USE_THREADS
	_mutex->enter();
#endif

	auto createFunc = createFuncRegistry.find(id);

#if USE_THREADS
	_mutex->leave();
#endif

	if (createFunc == createFuncRegistry.end())
		return {};
	return createFunc->second;
}
