/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTInjector.h>
#if USE_THREADS
#include <RTMutex.h>
#endif

void RTInjector::registerCreateFunction(const std::string& id,
										std::function<RTActor* (RTController *, RTActorRef *, int)> createFunc) {
#if USE_THREADS
	_mutex->enter();
#endif

	createFuncRegistry[id] = createFunc;

#if USE_THREADS
	_mutex->leave();
#endif
}
