/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTInterval.h>

RTInterval & RTInterval::operator-=( const RTInterval & rhs )
{
    usec -= rhs.usec;

    if( usec >= 1000000L )
    {
	sec  += 1L;
	usec -= 1000000L;
    }
    else if( usec <= -1000000L )
    {
	sec  -= 1L;
	usec += 1000000L;
    }

    sec -= rhs.sec;

    if( sec > 0L )
    {
	if( usec < 0L )
	{
	    sec  -= 1L;
	    usec += 1000000L;
	}
    }
    else if( sec < 0L )
    {
	if( usec > 0L )
	{
	    sec  += 1L;
	    usec -= 1000000L;
	}
    }

    return *this;
}
