/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTFieldDescriptor.h>
#include <RTInterval.h>
#include <RTnew.h>

static void _init( const RTObject_class *, void * target )
{
	(void)new( target ) RTInterval;
}

static void _copy( const RTObject_class *,
		void                 * target,
		const void           * source )
{
	(void)new( target ) RTInterval( * static_cast<const RTInterval *>(source) );
}

static void _destroy( const RTObject_class *, void * target )
{
	(static_cast<RTInterval *>(target))->~RTInterval();
}

const RTFieldDescriptor RTInterval::fieldData[] =
{
		{
				"sec",
				RTOffsetOf( RTInterval, sec ),
				&RTType_long, nullptr
		},
		{
				"usec",
				RTOffsetOf( RTInterval, usec ),
				&RTType_long, nullptr
		}
};

const RTObject_class RTInterval::classData =
{
		nullptr,
		nullptr,
		"RTInterval",
		0 /* RTVersionId */,
		sizeof( RTInterval ),
		_init,
		_copy,
		nullptr, // Not movable
#if OBJECT_DECODE
		RTstruct_decode,
#endif
#if OBJECT_ENCODE
		RTstruct_encode,
#endif
		_destroy,
		2, RTInterval::fieldData
};

#if OBJECT_DECODE
RTTypeInstaller RTInterval_installer( RTType_RTInterval );
#endif
