/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTInterval.h>

RTInterval::RTInterval( void )
    : sec ( 0L )
    , usec( 0L )
{
}

RTInterval::RTInterval( unsigned long centiseconds )
    : sec ( static_cast<long>( centiseconds / 100UL )          )
    , usec( static_cast<long>( centiseconds % 100UL ) * 10000L )
{
}

RTInterval::RTInterval( long s, long us )
    : sec ( s  )
    , usec( us )
{
}

RTInterval::RTInterval( const RTInterval & other )
    : sec ( other.sec  )
    , usec( other.usec )
{
}
