/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTInterval.h>

int operator<( const RTInterval & lhs, const RTInterval & rhs )
{
    long lhs_s = lhs.seconds();
    long rhs_s = rhs.seconds();

    if( lhs_s < rhs_s )
	return 1;

    if( lhs_s > rhs_s )
	return 0;

    long lhs_u = lhs.micros();
    long rhs_u = rhs.micros();

    return lhs_u < rhs_u;
}
