/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTJsonEncoding.h>
#include <RTFieldOffset.h>
#include <RTObject_class.h>

int RTJsonEncoding::put_array( const void * array, int size, const RTObject_class * element )
{
    if (putCode( "[", 1, SpaceNone ) == 0)
    	return 0;

    if( size > 0 )
    {
		const RTFieldOffset stride = element->_size;

		for(;;)
		{
			if( element->encode( array, this ) == 0 )
				return 0;

			if( --size == 0 )
				break;

			if( putFieldSeparator() == 0 )
				return 0;

			array = RTConstObjectOf( void, stride, array );
		}
    }

    if (putCode( "]", 1, SpaceNone ) == 0)
        return 0;

    return 1;
}
