/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTJsonEncoding.h>
#include <RTMessage.h>

int RTJsonEncoding::put_msg( const RTMessage * msg )
{
    if( putFieldListStart() == 0 )
    	return 0;

    const RTObject_class * type = msg->getType();
    const void* data = msg->getData();

    if (put_string("event") == 0)
    	return 0;

    if (putCode( " : ", 3, SpaceNone ) == 0)
    	return 0;

    if (put_string( msg->getSignalName()) == 0)
        return 0;

    if (type) {
    	if (putFieldSeparator() == 0)
    		return 0;

    	if (put_string("type") == 0)
			return 0;

		if (putCode( " : \"", 4, SpaceNone ) == 0)
		    return 0;

		if (putType(type) == 0)
			return 0;

		if (putCode( "\"", 1, SpaceNone ) == 0)
			return 0;

		if (type != &RTType_void) {
			if( putFieldSeparator() == 0 )
				return 0;

			if (put_string("data") == 0)
				return 0;

			if (putCode( " : ", 3, SpaceNone ) == 0)
				return 0;

			if (type->encode( data, this ) == 0)
				return 0;
		}
	}

	if( putFieldListFinish() == 0 )
		return 0;

    return 1;
}
