/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTLayerConnector.h>
#include <RTMemoryUtil.h>

RTLayerConnector::NameBuffer &
RTLayerConnector::NameBuffer
::operator=( const RTLayerConnector::NameBuffer & rhs )
{
	if( this != &rhs )
	{
		if( (value = rhs.value) != nullptr )
		{
			int length = RTMemoryUtil::strlen( value );

			if( length < static_cast<int>(sizeof( small_buffer )) )
			{
				RTMemoryUtil::strcpy( small_buffer, value, length );
				value = small_buffer;
			}
			else
			{
				delete [] large_buffer;

				large_buffer = new char [ static_cast<unsigned>(length) + 1U ];
				RTMemoryUtil::strcpy( large_buffer, value, length );
				value = large_buffer;
			}
		}
	}

	return *this;
}
