/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTLayerConnector.h>
#include <RTMemoryUtil.h>

//lint -save -esym(1927,NameBuffer::small_buffer)

RTLayerConnector::
NameBuffer::NameBuffer( const RTLayerConnector::NameBuffer & other )
: value( nullptr )
, large_buffer( nullptr )
{
#ifdef _lint
	small_buffer[ 0 ] = '\0';
#endif

	if( other.value !=nullptr )
	{
		int length = RTMemoryUtil::strlen( other.value );

		if( length < static_cast<int>(sizeof( small_buffer )) )
		{
			RTMemoryUtil::strcpy( small_buffer, other.value, length );
			value = small_buffer;
		}
		else
		{
			large_buffer = new char [ static_cast<unsigned>(length) + 1U ];
			RTMemoryUtil::strcpy( large_buffer, other.value, length );
			value = large_buffer;
		}
	}
}

//lint -restore
