/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTAssociation.h>
#include <RTDictionary.h>
#include <RTLayerConnector.h>
#include <RTQueue.h>

void RTLayerConnector::cleanup( void )
{
	RTDictionary::Iterator   i;
	const RTAssociation    * assoc;

	lock();

	while( (assoc = pendingSAPs.iterate( i )) != nullptr )
		delete static_cast<RTQueue *>(assoc->value);

	i.reset();

	while( (assoc = pendingSPPs.iterate( i )) != nullptr )
		delete static_cast<RTQueue *>(assoc->value);

	unlock();
}
