/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTLayerConnector.h>
#include <RTMemoryUtil.h>

void RTLayerConnector::parseService( const char * name, NameBuffer & buffer )
{
	const char * colon = RTMemoryUtil::strchr( name, ':' );
	int          length;

	if( colon == nullptr )
	{
		buffer.value = defaultService;
	}
	else if ( (length = static_cast<int>(colon - name)) < static_cast<int>(sizeof( buffer.small_buffer )) )
	{
		RTMemoryUtil::strcpy( buffer.small_buffer, name, length );
		buffer.value = buffer.small_buffer;
	}
	else
	{
		delete [] buffer.large_buffer;

		buffer.large_buffer = new char [ static_cast<unsigned>(length) + 1U ];
		RTMemoryUtil::strcpy( buffer.large_buffer, name, length );
		buffer.value = buffer.large_buffer;
	}
}
