/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTLayerConnector.h>
#include <RTQueue.h>

RTLayerData * RTLayerConnector::registerSPP( RTController * context,
		RTProtocol   * spp,
		const char   * name )
{
	NameBuffer service;

	parseService( name, service );

	RTLayerConnector * connector = static_cast<RTLayerConnector *>(connectors[ service.value ]);
	RTLayerData      * info;

	if( connector == nullptr )
	{
		// add SPP to pending list
		RTQueue * queue = static_cast<RTQueue *>(pendingSPPs[ service.value ]);

		if( queue == nullptr )
		{
			queue = new RTQueue;
			(void)pendingSPPs.atPut( service.value, queue );
		}

		info = new Pending( queue, spp, name );
	}
	else
		info = connector->_registerSPP( context, spp, name );

	return info;
}
