/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTLayerConnector.h>
#include <RTProtocol.h>
#include <RTQueue.h>

int RTLayerConnector::total_replication( const RTQueue * queue )
{
	int result = 0;

	if( queue != nullptr )
	{
		RTQueue::Iterator   iterator( *queue );
		void              * entry;

		while( (entry = iterator.next()) != nullptr )
			result += (static_cast<Pending *>(entry))->size();
	}

	return result;
}
