/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTLocalConnector.h>

RTLayerData * RTLocalConnector::_registerSPP( RTController * context,
		RTProtocol   * spp,
		const char   * serviceName )
{
	const char * name = parseName( serviceName );
	SppNode    * node = static_cast<SppNode *>(db[ name ]);

	if( node == nullptr )
	{
		node = new SppNode( this );
		(void)db.atPut( name, node );
	}

	return node->publish( context, spp, serviceName );
}
