/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTLocalConnector.h>
#include <RTProtocol.h>

void RTLocalConnector::SapNode::deregister( RTController * context )
{
    RTLocalConnector::unbind( context, *initial.sap );

    Request * request = &initial;
    Request * chain;

    do
    {
	request->start = 0;
	request->limit = 0;
    }
    while( (request = request->chain) != nullptr );

    // remove any following requests
    for( request = initial.chain; request != nullptr; request = chain )
    {
	node->remove( context, request );

	chain = request->chain;

	delete request;
    }

    node->remove( context, &initial );
    node->remove( context, this );

    delete this;
}
