/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTLocalConnector.h>
#include <RTProtocol.h>

void RTLocalConnector::SppNode::deregister( RTController * context )
{
    RTLocalConnector::unbind( context, *spp );

    SapNode * entry = saps;

    if( entry == nullptr )
    {
		(void)connector->db.remove( parseName( name ) );
		delete this;
    }
    else
    {
		spp = nullptr;

		do
		{
			Request * request = &entry->initial;
			int       start   = 0;

			do
			{
			request->start = start;
			start = request->limit;
			}
			while( (request = request->chain) != nullptr );
		}
		while( (entry = entry->next) != saps );

	    pending = requests;
    }

}
