/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTLocalConnector.h>

RTLayerData * RTLocalConnector::SppNode::publish( RTController * context,
						  RTProtocol   * _spp,
						  const char   * _name )
{
    if( spp != nullptr )
    {
	// for backward compatibility: only one SPP per name
	return nullptr;
    }
    else
    {
	spp      = _spp;
	spp_next = 0;
	name     = _name;

	if( pending != nullptr )
	    connectAll( context );

	return this;
    }
}
