/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTLocalConnector.h>

void RTLocalConnector::SppNode::remove( RTController * context,
					SapNode      * entry )
{
    if( saps == entry )
    {
	saps = entry->next;

	if( saps == entry )
	{
	    saps = nullptr;

	    if( spp == nullptr )
	    {
		// Use the registered name of the SAP as
		// the SPP may never have been published.
		const char * sap_name = parseName( entry->getRegisteredName() );

		(void)connector->db.remove( sap_name );
		return;
	    }
	}
    }

    entry->prev->next = entry->next;
    entry->next->prev = entry->prev;

    if( pending != nullptr && spp != nullptr )
	connectAll( context );
}
