/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTMemoryUtil.h>

int RTMemoryUtil::atoi( const char * s )
{
	int  result   = 0;
	bool positive = true;

	while( *s == ' ' )
		++s;

	if( *s == '-' )
	{
		positive = false;
		++s;
	}

	for(;;)
	{
		int digit = static_cast<int>(*s++) - static_cast<int>('0');

		if( digit < 0 || digit > 9 )
			break;

		result *= 10;
		result -= digit;
	}

	return positive ? - result
			:   result;
}
