/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTMemoryUtil.h>

#ifdef NO_BUILTIN_MEM

int RTMemoryUtil::memcmp( const void * m1, const void * m2, int len )
{
	const unsigned char * c1 = static_cast<const unsigned char *>(m1);
	const unsigned char * c2 = static_cast<const unsigned char *>(m2);

	while( len-- )
	{
		if( *c1 != *c2 )
			return *c1 > *c2 ? 1 : -1;
		++c1;
		++c2;
	}

	return 0;
}

#else

#include <RTstdio.h>

int RTMemoryUtil::memcmp( const void * m1, const void * m2, int len )
{
	return ::memcmp( m1, m2, static_cast<size_t>(len) );
}

#endif
