/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTMemoryUtil.h>

#ifdef NO_BUILTIN_MEM

void RTMemoryUtil::memcpy( void * dst, const void * src, int len )
{
	char       * d = static_cast<char *>(dst);
	const char * s = static_cast<const char *>(src);

	while( len-- )
		*d++ = *s++;
}

#else

#include <RTstdio.h>

void RTMemoryUtil::memcpy( void * dst, const void * src, int len )
{
	(void)::memcpy( dst, src, static_cast<size_t>(len) );
}

#endif
