/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTMemoryUtil.h>

#ifdef NO_BUILTIN_MEM

void RTMemoryUtil::memset( void * dst, int val, int len )
{
	unsigned char * d = static_cast<unsigned char *>(dst);

	while( len-- )
		*d++ = static_cast<unsigned char>(val);
}
#else

#include <RTstdio.h>

void RTMemoryUtil::memset( void * dst, int val, int len )
{
	(void)::memset( dst, val, static_cast<size_t>(len) );
}

#endif
