/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifdef PRAGMA
#pragma implementation "RTMemoryUtil.h"
#endif

#include <RTMemoryUtil.h>

int RTMemoryUtil::strcmp( const char * c1, const char * c2, int len )
{
    if( len < 0 )
	for(;;)
	{
	    if( *c1 != *c2 )
		return *c1 > *c2 ? 1 : -1;
	    if( *c1 == 0 )
		break;
	    ++c1;
	    ++c2;
	}
    else
	while( len-- != 0 )
	{
	    if( *c1 != *c2 )
		return *c1 > *c2 ? 1 : -1;
	    ++c1;
	    ++c2;
	}

    return 0;
}
