/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTMessage.h>

RTMessage & RTMessage::operator=( const RTMessage & m )
{
	if( this != &m )
	{
		clear();

#if OTRTSDEBUG != DEBUG_NONE
		_sendProbeId   = m._sendProbeId;
		_sendPortId    = m._sendPortId;
		_sendPortIndex = m._sendPortIndex;
		_sendTime      = m._sendTime;
#endif

		data       = m.data;
		signal     = m.signal;
		priority   = m.priority;
		_flags     = static_cast<unsigned char>( m._flags & ~MaskDataOwned );
		// we don't own the data yet
		_receiver  = m._receiver;
		_port      = m._port;
		_portIndex = m._portIndex;
		_type      = m._type;

		internData();
	}

	return *this;
}
