/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActor.h>
#include <RTMessage.h>

int RTMessage::defer( void ) const
{
    RTController * controller = context();

    controller->trace( RTController::CommDefer, this, nullptr );

    // Ensure that the message has not already been deferred
    if( isDeferred() != 0 )
    {
		controller->setError( RTController::alreadyDeferred,
					  RTController::CommDefer, this, nullptr );
		return 0;
    }

    // Ensure that the message was not invoked.
    if( controller->getReplyBuffer() != nullptr )
    {
		controller->setError( RTController::deferInvoke,
					  RTController::CommDefer, this, nullptr );
		return 0;
    }

    RTConstCast( RTMessage, this )->setDeferred();

    return 1;
}
