/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTMessage.h>
#include <RTPortDescriptor.h>
#include <RTProtocol.h>
#include <RTProtocolDescriptor.h>
#include <RTSignalDescriptor.h>
#include <RTSpecialSignals.h>

const char * RTMessage::getSignalName( void ) const
{
    const RTProtocolDescriptor * protocol = ( _port != nullptr )
						? _port->getInfo()->protocol
						: &RTControl_Protocol_Class;

    return ( protocol != nullptr )
		? protocol->inSignalName( signal )
		:nullptr;
}
