/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTFieldOffset.h>
#include <RTMessage.h>
#include <RTObject_class.h>

void RTMessage::_internData( bool moveData )
{
	if( ( _flags & MaskDataOwned ) == 0 )
	{
		void * old_location = data;

#if RTMESSAGE_PAYLOAD_SIZE != 0
		if( _type->_size <= sizeof( _data_area ) )
			data = _data_area;
		else
#endif
			data = _type->allocate();

		if (!moveData) {
			_type->copy( data, old_location );
		}
		else {
			_type->move( data, old_location );
		}
		// Regardless if the data is copied or moved we own the data object and must remember to destroy it
		// when the message has been handled by the receiver.
		_flags |= MaskDataOwned;
	}
}
