/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTMessage.h>
#include <RTMessageQ.h>
#include <RTQFilter.h>

int RTMessageQ::filterAll( RTQFilter & filter )
{
    RTMessage ** _link    = &head;
    RTMessage  * new_tail = nullptr;
    RTMessage  * node;
    int          count    = 0;

    while( (node = *_link) != nullptr )
    {
	if( filter.select( *node ) != 0 )
	{
	    *_link = node->next;
	    node->next = nullptr;
	    filter.accept( *node );
	    ++count;
	}
	else
	{
	    new_tail = node;
	    _link = &node->next;
	}
    }
    tail = new_tail;

    return count;
}
