/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTMessage.h>
#include <RTMessageQ.h>
#include <RTQFilter.h>

int RTMessageQ::filterOne( RTQFilter & filter )
{
    RTMessage ** _link = &head;
    RTMessage  * prev  = nullptr;
    RTMessage  * node;

    while( (node = *_link) != nullptr )
    {
	if( filter.select( *node ) != 0 )
	{
	    if( (*_link = node->next) == nullptr )
		tail = prev;

	    node->next = nullptr;
	    filter.accept( *node );
	    return 1;
	}

	prev  = node;
	_link = &node->next;
    }

    return 0;
}
