/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDiag.h>
#include <RTFieldDescriptor.h>
#include <RTFieldOffset.h>
#include <RTObject_class.h>

void RTarray_destroy( const RTObject_class * type, void * target )
{
	RTAssert( type->_fields->modifier == nullptr );

	int                    count   = type->_num_fields;
	const RTObject_class * element = type->_fields->type;
	RTFieldOffset          stride  = element->_size;

	target = RTObjectOf( void, stride * count, target );

	while( --count >= 0 )
	{
		target = RTObjectOf( void, - static_cast<long>(stride), target );

		(*element->_destroy_func)( element, target );
	}
}
