/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDecoding.h>
#include <RTObject_class.h>

int RTenum_decode( const RTObject_class * type,
		void                 * target,
		RTDecoding           * coding )
{
	int value;

	if( coding->get_enum( value, type->_num_fields, type->_fields ) == 0 )
		return 0;

	if( type->_size == sizeof( int ) )
		* static_cast<int *>(target) = value;

	else if( type->_size == sizeof( short ) )
		* static_cast<short *>(target) = static_cast<short>(value);

	else if( type->_size == sizeof( char ) )
		* static_cast<char *>(target) = static_cast<char>(value);

	else
		return 0;

	return 1;
}
