/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTEncoding.h>
#include <RTObject_class.h>

int RTenum_encode( const RTObject_class * type,
		const void           * source,
		RTEncoding           * coding )
{
	int value;

	if( type->_size == sizeof( int ) )
		value = * static_cast<const int *>(source);

	else if( type->_size == sizeof( short ) )
		value = * static_cast<const short *>(source);

	else if( type->_size == sizeof( char ) )
		value = * static_cast<const char *>(source);

	else
		return 0;

	return coding->put_enum( value, type->_num_fields, type->_fields );
}
