/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTEncoding.h>
#include <RTObject_class.h>

int RTinherit_encode( const RTObject_class * type,
		      const void           * value,
		      RTEncoding           * coding )
{
    RTEncodeFunction func;

    do
    {
	value = (*type->_super_accessor)( RTConstCast( void, value ) );
	type  = type->_super;
	func  = type->_encode_func;
    }
    while( func == RTinherit_encode );

    return (*func)( type, value, coding );
}
