/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDictionary.h>
#include <RTObject_class.h>
#include <RTDiag.h>
#include <RTDiagStream.h>

#if OBJECT_DECODE
static RTDictionary classes( 32U );
#endif

void RTObject_class::install( bool warnForDuplicates ) const
{
#if OBJECT_DECODE
    if (classes.atPut( _name, RTConstCast( RTObject_class, this )) == 0) {
    	if (warnForDuplicates) {
			RTDiagStream & out = RTDiag::out();
			out.lock();
			out << "WARNING: A type \"" << _name << "\" was already installed\n";
			out.flush();
			out.unlock();
    	}
    }
#endif
}

#if OBJECT_DECODE
const RTObject_class * RTObject_class::lookup( const char * className )
{
    return static_cast<const RTObject_class *>(classes[ className ]);
}
#endif
