/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTFieldDescriptor.h>
#include <RTObject_class.h>

void RTstruct_destroy( const RTObject_class * type, void * value )
{
    int                       count = type->_num_fields;
    const RTFieldDescriptor * field = &type->_fields[ count ];

    while( --field, --count >= 0 )
	field->destroy( value );

    const RTObject_class * super = type->_super;

    if( super != nullptr )
	(*super->_destroy_func)( type, (*type->_super_accessor)( value ) );
}
