/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTFieldDescriptor.h>
#include <RTObject_class.h>

void RTstruct_init( const RTObject_class * type,
		    void                 * target )
{
    const RTObject_class * super = type->_super;

    if( super != nullptr )
	super->init( (*type->_super_accessor)( target ) );

    int                       count = type->_num_fields;
    const RTFieldDescriptor * field = type->_fields;

    for( ; --count >= 0; ++field )
	field->init( target );
}
