/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDaemon.h>
#include <RTMemoryUtil.h>
#include <RTObserver.h>
#include <RTTcpSocket.h>

RTObserver::RTObserver( RTDebugger  * theDebugger,
		RTTcpSocket * theSocket,
		int           theObsId,
		const char  * initBuf,
		int           initLen )
: debugger   (                    theDebugger )
, socket     (                      theSocket )
, observerId (                       theObsId )
, daemon     (                  nullptr       )
, daemons    (                                )
, superDaemon(                  nullptr       )
, bufSize    (                           2048 )
, bufUsed    (                              0 )
, inBuffer   ( new char [ static_cast<unsigned>(bufSize) ] )
, haltByProbe(                              0 )
, resumeToRun(                              0 )
, lastFlowCmd(                       FlowNone )
{
	if( inBuffer != nullptr && initBuf != nullptr )
	{
		if( (bufUsed = initLen) < 0 )
			bufUsed = RTMemoryUtil::strlen( initBuf );

		if( bufUsed > bufSize )
			bufUsed = bufSize;

		RTMemoryUtil::memcpy( inBuffer, initBuf, bufUsed );
	}

	cmdCreateDaemon( -1 ); // super daemon
	(void)setDaemon( -1 );
	daemon->updateSettings( "report=True" );
}
