/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTObserver.h>
#include <RTTcpSocket.h>

int RTObserver::sendData( const char * buffer, int length )
{
    int totalSent = 0;

    do
    {
		int sent = socket->write( buffer, length );

		if( sent <= 0 )
			break;

		buffer    += sent;
		length    -= sent;
		totalSent += sent;
    }
    while( length > 0 );

    if( totalSent > 0 && length == 0 )
    {
		// we sent all we wanted to: cancel notification of room to write
		(void)socket->write( buffer, 0 );
    }

    return totalSent;
}
