/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDaemon.h>
#include <RTDebugger.h>
#include <RTDiag.h>
#include <RTObserver.h>
#include <RTTcpSocket.h>

//lint -save -e1738
RTObserver::RTObserver( const RTObserver & )
    : debugger   (  nullptr )
    , socket     ( nullptr )
    , observerId (                0 )
    , daemon     (    nullptr )
    , daemons    (                  )
    , superDaemon(    nullptr )
    , bufSize    (                0 )
    , bufUsed    (                0 )
    , inBuffer   (        nullptr )
    , haltByProbe(                0 )
    , resumeToRun(                0 )
    , lastFlowCmd(         FlowNone )
{
    RTDiag::panic( "Unavailable method called:\n"
		   "    'RTObserver( const RTObserver & )'" );
}
//lint -restore

RTObserver & RTObserver::operator=( const RTObserver & )
{
    RTDiag::panic( "Unavailable method called:\n"
	    "    'RTObserver::operator=( const RTObserver & )'" );

    //lint -unreachable
    return *this;
} //lint !e1529
