/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTFieldDescriptor.h>
#include <RTObject_class.h>
#include <RTPriority.h>
#include <RTnew.h>

static RTInteger * _access( RTPriority * target )
{
	return target;
}

static void _init( const RTObject_class *, void * target )
{
	(void)new( target ) RTPriority;
}

static void _copy( const RTObject_class *,
		void                 * target,
		const void           * source )
{
	(void)new( target ) RTPriority( * static_cast<const RTPriority *>(source) );
}

static const RTFieldDescriptor _fields[] =
{
		{
				"RTPriority",
				0,
				&RTPriority::classData, nullptr
		}
};

const RTObject_class RTPriority::classData =
{
		&RTType_RTInteger,
		reinterpret_cast<RTSuperAccessFunction>(_access),
		"RTPriority",
		0 /* RTVersionId */,
		sizeof( RTPriority ),
		_init,
		_copy,
		nullptr, // Not movable
#if OBJECT_DECODE
		RTinherit_decode,
#endif
#if OBJECT_ENCODE
		RTinherit_encode,
#endif
		RTDataObject_destroy,
		1, _fields
};

#if OBJECT_DECODE
RTTypeInstaller RTPriority_installer( RTType_RTPriority );
#endif

const RTObject_class * RTPriority::getClassData( void ) const
{
	return &RTPriority::classData;
}
