/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTMemoryUtil.h>
#include <RTProbe.h>

RTProbe::RTProbe( RTDebugger * debugger,
		  int          id,
		  const char * strPath,
		  int          actorIndex )
    : _debugger  (                        debugger )
    , _id        (                              id )
    , _owner     (                               0 )
    , _actor     (                    nullptr )
    , _doReport  (                               1 )
    , _refCount  (                               1 )
    , _stringPath( RTMemoryUtil::strdup( strPath ) )
    , _actorIndex(                      actorIndex )
    , _destroyMe (                               0 )
{
}
