/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTController.h>
#include <RTDiag.h>
#include <RTPortDescriptor.h>
#include <RTProtocol.h>

void RTProtocol::init( const RTPortDescriptor * info )
{
	RTAssert( _info == nullptr ); // this can only be called once

	_info = info;

	int replication = info->replication;

	if( replication != 0 )
	{
		if( ( info->properties & RTPortDescriptor::MaskKind )
				!= RTPortDescriptor::KindSpecial )
		{
			_ends = new End [ static_cast<unsigned>(replication) ];

			End * end = _ends;

			for( int i = replication; --i >= 0; ++end )
			{
				end->state       = End::Unbound;
				end->remote      = nullptr;
				end->remoteIndex = 0;
				end->signalMap   = nullptr;
			}
		}

		context()->countPortIncarnate( replication );
	}
}
