/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActor.h>
#include <RTController.h>
#include <RTMessage.h>
#include <RTRootProtocol.h>

void RTProtocol::notifyBoundAt( int index, RTController * initiator )
{
    RTMessage * msg;

    if( (msg = initiator->newMsg()) == nullptr )
    {
	// out of memory
	initiator->setError( RTController::noMem,
			     RTController::SystemService, nullptr, nullptr );
    }
    else
    {
	RTActor * owner = getOwner();

	msg->setSignal( RTRootProtocol::rti_rtBound );
	msg->setPriority( System );
	msg->setDestination( owner, this, index );

	owner->context()->receive( msg, initiator );
    }
}
