/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTLayerConnector.h>
#include <RTPortDescriptor.h>
#include <RTProtocol.h>

void RTProtocol::notifyInit( RTController * initiator )
{
    if( ( getInfo()->properties & RTPortDescriptor::MaskNotification )
			       != RTPortDescriptor::NotificationDisabled )
    {
	RTLayerConnector::lock();

	setFlag( BindingNotification );

	for( int index = 0, count = size(); index < count; ++index )
	    if( _ends[ index ].state != End::Unbound )
		notifyBoundAt( index, initiator );

	RTLayerConnector::unlock();
    }
}
