/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTBindingEnd.h>
#include <RTPortDescriptor.h>
#include <RTProtocol.h>

int RTProtocol::peerAt( int index, RTBindingEnd & peer )
{
    if( index < 0 || _info->replication <= index )
	return 0; // index out of range

    if( _ends == nullptr )
	return 0; // no peers at all

    End * end = &_ends[ index ];

    if( end->state == End::Unbound )
	return 0; // not bound

    peer.port  = end->remote;
    peer.index = end->remoteIndex;

    return 1;
}
