/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActor.h>
#include <RTController.h>
#include <RTProtocol.h>
#include <RTPurgeFilter.h>

int RTProtocol::purgeAt( int signal, int index )
{
    RTActor      * owner      = getOwner();
    RTController * controller = owner->context();
    int            count;

    controller->trace( RTController::CommPurge, this, &index );

  {
    RTPurgeFilter filter( controller, this, RTPurgeFilter::SignalIndex,
			  signal, index );

#if DEFER_IN_ACTOR
    count = owner     ->deferredQ.filterAll( filter );
#else
    count = controller->deferredQ.filterAll( filter );
#endif
  }

    return count;
}
