/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActor.h>
#include <RTController.h>
#include <RTProtocol.h>
#include <RTRecallFilter.h>

int RTProtocol::recallAt( int index, int front )
{
    RTActor      * owner      = getOwner();
    RTController * controller = owner->context();
    int            count;

    controller->trace( RTController::CommRecall, this, &index );

  {
    RTRecallFilter filter( controller, this,
			   front != 0 ? RTRecallFilter::IndexFront
				      : RTRecallFilter::IndexBack,
			   0, index );

#if DEFER_IN_ACTOR
    count = owner     ->deferredQ.filterOne( filter );
#else
    count = controller->deferredQ.filterOne( filter );
#endif
  }

    return count;
}
