/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTMemoryUtil.h>
#include <RTProtocolDescriptor.h>
#include <RTSignalDescriptor.h>

int RTProtocolDescriptor::inSignalNamed( const char * signalName ) const
{
    int lo = 0;
    int hi = numInSignals;

    // Signals are sorted: do binary search.

    while( lo < hi )
    {
	int mid = ( lo + hi ) / 2;
	int cmp = RTMemoryUtil::strcmp( signalName, inSignals[ mid ].name );

	if( cmp == 0 )
	    return inSignals[ mid ].value;

	if( cmp < 0 )
	    hi = mid;
	else
	    lo = mid + 1;
    }

    return 0; // no such signal
}
