/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTQueue.h>

RTQueue & RTQueue::operator=( const RTQueue & rhs )
{
    if( this != &rhs )
    {
	Iterator   iterator( rhs );
	void     * data  = iterator.next();
	Block    * block = head;
	Block    * prev  = nullptr;

	if( block != nullptr )
	{
	    block->used = 0;

	    for(;;)
	    {
		if( data == nullptr )
		{
		    if( block->used == 0 )
		    {
			if( prev == nullptr )
			    head       = nullptr;
			else
			    prev->next = nullptr;
			tail = prev;

			do
			{
			    prev  = block;
			    block = block->next;

			    delete prev;
			}
			while( block != nullptr );
		    }
		    break;
		}

		if( block->used >= Block::Size )
		{
		    prev = block;
		    if( (block = block->next) == nullptr )
			break;

		    block->used = 0;
		}

		block->data[ block->used++ ] = data;
		data = iterator.next();
	    }
	}

	for( ; data != nullptr; data = iterator.next() )
	    add( data );
    }

    return *this;
}
