/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTQueue.h>

void RTQueue::remove( void * data )
{
    Block * prev;
    Block * block;

    for( prev = nullptr, block  = head;
			    block != nullptr;
	 prev = block,      block  = block->next )
    {
	for( int index = 0; index < block->used; ++index )
	{
	    if( block->data[ index ] == data )
	    {
		block->used -= 1;

		if( block->used != 0 )
		{
		    for( int i2 = index; ++i2 <= block->used; )
			block->data[ i2 - 1 ] = block->data[ i2 ];
		}
		else
		{
		    if( block == head )
			head = block->next;
		    else
			prev->next = block->next;

		    if( block == tail )
			tail = prev;

		    delete block;
		}
		return;
	    }
	}
    }
}
