/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifdef PRAGMA
#pragma implementation "RTMessageBlock.h"
#pragma implementation "RTResourceMgr.h"
#endif

#include <RTMessageBlock.h>
#if USE_THREADS
#include <RTMutex.h>
#endif
#include <RTResourceMgr.h>

RTResourceMgr::~RTResourceMgr( void )
{
    RTMessageBlock * block;

    while( (block = blocks) != nullptr )
    {
	blocks = block->next;

	delete block;
    }

    messages = nullptr;

#if USE_THREADS
    delete access;
#endif
}
