/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTMessageBlock.h>
#if USE_THREADS
#include <RTMutex.h>
#endif
#include <RTResourceMgr.h>

unsigned RTResourceMgr::msgAlloc( RTMessage * & list, unsigned howMany )
{
    unsigned result = howMany;

#if USE_THREADS
    access->enter();
#endif

    for( unsigned msgCount = howMany; msgCount-- > 0U; )
    {
	RTMessage * msg = messages;

	if( msg == nullptr )
	{
	    RTMessageBlock * block = new RTMessageBlock;

	    if( block == nullptr )
	    {
		result = howMany - msgCount - 1U;
		break;
	    }

	    block->next = blocks;
	    blocks = block;

	    msg = &block->messages[ 0 ];

	    for( int i = RTMessageBlock::Size; --i > 0; ++msg )
		msg->next = &msg[ 1 ];

	    msg->next = nullptr;

	    msg = &block->messages[ 0 ];
	}
	messages = msg->next;
	msg->next = list;
	list = msg;
    }

#if USE_THREADS
    access->leave();
#endif

    return result;
}
