/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTMessageBlock.h>
#if USE_THREADS
#include <RTMutex.h>
#endif
#include <RTResourceMgr.h>

void RTResourceMgr::msgFree( RTMessage * & list, unsigned howMany )
{
    RTMessage * msg;

#if USE_THREADS
    access->enter();
#endif

    while( (msg = list) != nullptr )
    {
	list = msg->next;
	msg->clear();
	msg->next = messages;
	messages = msg;
	if( howMany != 0U && --howMany == 0U )
	    break;
    }

#if USE_THREADS
    access->leave();
#endif
}
