/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTFieldDescriptor.h>
#include <RTObject_class.h>
#include <RTTypedValue.h>
#include <RTnew.h>

// sample type descriptor

class Sample1
{
public:
	int     x;
	int     y;

	Sample1( void );
	Sample1( const Sample1 & );
	virtual ~Sample1( void );
};

static void Sample1_init( const RTObject_class *, void * target )
{
	(void)new( target ) Sample1;
}

static void Sample1_copy( const RTObject_class *,
		void                 * target,
		const void           * source )
{
	(void)new( target ) Sample1( * static_cast<const Sample1 *>(source) );
}

static const RTFieldDescriptor Sample1_fields[] =
{
		{
				"x",
				RTOffsetOf( Sample1, x ),
				&RTType_int, nullptr
		},
		{
				"y",
				RTOffsetOf( Sample1, y ),
				&RTType_int, nullptr
		}
};

static void Sample1_destroy( const RTObject_class *, void * target )
{
	(static_cast<Sample1 *>(target))->~Sample1();
}

static const RTObject_class Sample1_descriptor =
{
		nullptr,
		nullptr,
		"Sample1",
		0 /* RTVersionId */,
		sizeof( Sample1 ),
		Sample1_init,
		Sample1_copy,
		nullptr, // no move
#if OBJECT_DECODE
		RTstruct_decode,
#endif
#if OBJECT_ENCODE
		RTstruct_encode,
#endif
		Sample1_destroy,
		2, Sample1_fields
};

RTTypedValue new_RTTypedValue( const Sample1 & value )
{
	return RTTypedValue( &value, &Sample1_descriptor );
}
