/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTFieldDescriptor.h>
#include <RTObject_class.h>
#include <RTTypeModifier.h>
#include <RTTypedValue.h>
#include <RTnew.h>

// sample type descriptor

class Sample3
{
public:
	int     x;
	int     y[ 42 ];

	Sample3( void );
	Sample3( const Sample3 & );
	virtual ~Sample3( void );
};

static const RTTypeModifier int_42 =
{
		RTNumberConstant, 42, 0
};

static void Sample3_init( const RTObject_class *, void * target )
{
	(void)new( target ) Sample3;
}

static void Sample3_copy( const RTObject_class *,
		void                 * target,
		const void           * source )
{
	(void)new( target ) Sample3( * static_cast<const Sample3 *>(source) );
}

static void Sample3_destroy( const RTObject_class *, void * target )
{
	(static_cast<Sample3 *>(target))->~Sample3();
}

static const RTFieldDescriptor Sample3_fields[] =
{
		{
				"x",
				RTOffsetOf( Sample3, x ),
				&RTType_int, nullptr
		},
		{
				"y",
				RTOffsetOf( Sample3, y[ 0 ] ),
				&RTType_int, &int_42
		}
};

static const RTObject_class Sample3_descriptor =
{
		nullptr,
		nullptr,
		"Sample3",
		0 /* RTVersionId */,
		sizeof( Sample3 ),
		Sample3_init,
		Sample3_copy,
		nullptr, // no move
#if OBJECT_DECODE
		RTstruct_decode,
#endif
#if OBJECT_ENCODE
		RTstruct_encode,
#endif
		Sample3_destroy,
		2, Sample3_fields
};

RTTypedValue new_RTTypedValue( const Sample3 & value )
{
	return RTTypedValue( &value, &Sample3_descriptor );
}
