/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTObject_class.h>
#include <RTSequence.h>
#include <RTnew.h>

static RTDataObject * _access( RTSequence * target )
{
	return target;
}

static void _init( const RTObject_class *, void * target )
{
	(void)new( target ) RTSequence;
}

static void _copy( const RTObject_class *,
		void                 * target,
		const void           * source )
{
	(void)new( target ) RTSequence( * static_cast<const RTSequence *>(source) );
}

const RTObject_class RTSequence::classData =
{
		&RTType_RTDataObject,
		reinterpret_cast<RTSuperAccessFunction>(_access),
		"RTSequence",
		0 /* RTVersionId */,
		sizeof( RTSequence ),
		_init,
		_copy,
		nullptr, // Not movable
#if OBJECT_DECODE
		RTstruct_decode,
#endif
#if OBJECT_ENCODE
		RTstruct_encode,
#endif
		RTDataObject_destroy,
		0, nullptr
};

#if OBJECT_DECODE
RTTypeInstaller RTSequence_installer( RTType_RTSequence );
#endif

const RTObject_class * RTSequence::getClassData( void ) const
{
	return &RTSequence::classData;
}
