/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTSequenceOf.h>

RTSequenceOf & RTSequenceOf::operator=( const RTSequenceOf & rhs )
{
	if( this != &rhs )
	{
		spaceClean();

		if( rhs.size > 0 )
		{
			size  = rhs.size;
			array = new RTDataObject * [ static_cast<unsigned>(size) ];

			for( int count = 0; count < size; ++count )
			{
				RTDataObject * element = rhs.array[ count ];

				if( element != nullptr )
					element = element->copy();

				array[ count ] = element;
			}
		}
	}

	return *this;
}
