/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTSequenceOf.h>

RTSequenceOf::RTSequenceOf( const RTSequenceOf & other )
: RTDataObject( other )
, size ( 0 )
, array( nullptr )
{
	if( other.size > 0 )
	{
		size  = other.size;
		array = new RTDataObject * [ static_cast<unsigned>(size) ];

		for( int index = 0; index < size; ++index )
		{
			RTDataObject * element = other.array[ index ];

			if( element != nullptr )
				element = element->copy();

			array[ index ] = element;
		}
	}
}
