/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTSequenceOf.h>

RTSequenceOf::RTSequenceOf( int _size,
		const RTDataObject ** _contents )
: RTDataObject()
, size ( 0 )
, array( nullptr )
{
	if( _size > 0 )
	{
		size  = _size;
		array = new RTDataObject * [ static_cast<unsigned>(size) ];

		for( int index = 0; index < size; ++index )
		{
			if( _contents[ index ] != nullptr )
				array[ index ] = _contents[ index ]->copy();
			else
				array[ index ] = nullptr;
		}
	}
}
