/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTSequenceOf.h>

int RTSequenceOf::operator==( const RTDataObject & _rhs ) const
{
	if( RTDataObject::operator==( _rhs ) == 0 )
		return 0;

	const RTSequenceOf & rhs = * static_cast<const RTSequenceOf *>(&_rhs);

	if( size != rhs.size )
		return 0;

	for( int i = 0; i < size; ++i )
	{
		if( array[i] == nullptr )
		{
			if( rhs.array[i] != nullptr )
				return 0;
		}
		else if( *(array[i]) != *(rhs.array[i]) ) //lint !e909
		{
			return 0;
		}
	}

	return 1;
}
