/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTFieldDescriptor.h>
#include <RTObject_class.h>
#include <RTSequenceOf.h>
#include <RTTypeModifier.h>
#include <RTnew.h>

static RTDataObject * _access( RTSequenceOf * target )
{
	return target;
}

static void _init( const RTObject_class *, void * target )
{
	(void)new( target ) RTSequenceOf;
}

static void _copy( const RTObject_class *,
		void                 * target,
		const void           * source )
{
	(void)new( target ) RTSequenceOf( * static_cast<const RTSequenceOf *>(source) );
}

int RTSequenceOf_size( const RTTypeModifier *, const void * source )
{
	const RTSequenceOf * data = static_cast<const RTSequenceOf *>(source);

	return data->size;
}

static const RTTypeModifier array_modifier =
{
		RTSequenceOf_size, 0, 1
};

static const RTFieldDescriptor _fields[] =
{
		{
				"size",
				RTOffsetOf( RTSequenceOf, size ),
				&RTType_int,
				nullptr
		},
		{
				"array",
				RTOffsetOf( RTSequenceOf, array ),
				&RTType_RTpRTDataObject,
				&array_modifier
		}
};

const RTObject_class RTSequenceOf::classData =
{
		&RTType_RTDataObject,
		reinterpret_cast<RTSuperAccessFunction>(_access),
		"RTSequenceOf",
		0 /* RTVersionId */,
		sizeof( RTSequenceOf ),
		_init,
		_copy,
		nullptr, // Not movable
#if OBJECT_DECODE
		RTstruct_decode,
#endif
#if OBJECT_ENCODE
		RTstruct_encode,
#endif
		RTDataObject_destroy,
		2, _fields
};

#if OBJECT_DECODE
RTTypeInstaller RTSequenceOf_installer( RTType_RTSequenceOf );
#endif

const RTObject_class * RTSequenceOf::getClassData( void ) const
{
	return &RTSequenceOf::classData;
}
