/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDecoding.h>
#include <RTEncoding.h>
#include <RTFieldDescriptor.h>
#include <RTObject_class.h>
#include <RTSignal.h>
#include <RTnew.h>

static RTInteger * _access( RTSignal * target )
{
	return target;
}

static void _init( const RTObject_class *, void * target )
{
	(void)new( target ) RTSignal;
}

static void _copy( const RTObject_class *,
		void                 * target,
		const void           * source )
{
	(void)new( target ) RTSignal( * static_cast<const RTSignal *>(source) );
}

static const RTFieldDescriptor _fields[] =
{
		{
				"RTSignal",
				0,
				&RTSignal::classData,
				nullptr
		}
};

const RTObject_class RTSignal::classData =
{
		&RTType_RTInteger,
		reinterpret_cast<RTSuperAccessFunction>(_access),
		"RTSignal",
		0 /* RTVersionId */,
		sizeof( RTSignal ),
		_init,
		_copy,
		nullptr, // Not movable
#if OBJECT_DECODE
		RTinherit_decode,
#endif
#if OBJECT_ENCODE
		RTinherit_encode,
#endif
		RTDataObject_destroy,
		1, _fields
};

#if OBJECT_DECODE
RTTypeInstaller RTSignal_installer( RTType_RTSignal );
#endif

const RTObject_class * RTSignal::getClassData( void ) const
{
	return &RTSignal::classData;
}
