/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTStreamBuffer.h>
#include <RTMemoryUtil.h>

int RTStreamBuffer::write( const char * data, int data_size )
{
	int written = 0;
	int segment;

	while( (segment = data_size - written) > 0 )
	{
		int room = static_cast<int>(sizeof( buffer )) - 1 - offset;

		if( room == 0 )
		{
			int status = flush();

			if( status <= 0 )
				return ( written != 0 ) ? written : status;

			room = static_cast<int>(sizeof( buffer )) - 1 - offset;
		}

		if( segment > room )
			segment = room;

		RTMemoryUtil::memcpy( &buffer[ offset ], data, segment );

		data    += segment;
		written += segment;
		offset  += segment;
	}

	return written;
}
