/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTMemoryUtil.h>
#include <RTString.h>

RTString::RTString( const char * i )
    : RTDataObject()
    , Contents    ( nullptr )
{
	if( i != nullptr )
		Contents = RTMemoryUtil::strdup( i );
}

RTString::RTString( const RTString & other )
    : RTDataObject( other )
    , Contents    ( nullptr )
{
	if( other.Contents != nullptr )
		Contents = RTMemoryUtil::strdup( other.Contents );
}

RTString::RTString( RTString && other )
    : RTDataObject( other )
    , Contents    ( nullptr )
{
	Contents = other.Contents;
	other.Contents = nullptr;
}
