/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActorClass.h>
#include <RTActor_class.h>
#include <RTComponentDescriptor.h>
#include <RTFieldDescriptor.h>
#include <RTPortDescriptor.h>
#include <RTSuperActor.h>

const RTStateId RTSuperActor::rtg_parent_state[] =
{
		0, 1, 1
};

static const RTActorClass RTSuperActor_ActorClass =
{
		nullptr,
		"RTSuperActor",
		0 /* RTVersionId */,
		0,
		nullptr,
		nullptr
};

static const char * const _names[] =
{
		"top",
		"starting",
		"running",

		// transitions
		"initialize",
		"go"

		// choice points
};

const RTComponentDescriptor RTSuperActor::rtg_capsule_roles[] =
{
		{
				"specials",
				nullptr,
				RTOffsetOf( RTSuperActor, specials ),
				1, // id
				RTComponentDescriptor::Optional,
				1, // substitutable
				1, // replication
				0, nullptr,
				0, nullptr
		},
		{
				"application",
				nullptr,
				RTOffsetOf( RTSuperActor, application ),
				2, // id
				RTComponentDescriptor::Optional,
				1, // substitutable
				1, // replication
				0, nullptr,
				0, nullptr
		}
};

const RTPortDescriptor RTSuperActor::rtg_ports[] =
{
		{
				"frame",
				nullptr,
				&Frame::Base::rt_class,
				RTOffsetOf( RTSuperActor, frame ),
				1, // replication
				rtid_frame, // id
				RTPortDescriptor::KindSpecial
				+ RTPortDescriptor::NotificationDisabled
				+ RTPortDescriptor::RegisterNotPermitted
				+ RTPortDescriptor::VisibilityProtected
		},
		{
				"timer",
				nullptr,
				&Timing::Base::rt_class,
				RTOffsetOf( RTSuperActor, timer ),
				1, // replication
				rtid_timer, // id
				RTPortDescriptor::KindSpecial
				+ RTPortDescriptor::NotificationDisabled
				+ RTPortDescriptor::RegisterNotPermitted
				+ RTPortDescriptor::VisibilityProtected
		}
};

#if USE_THREADS
const RTFieldDescriptor RTSuperActor::rtg_fields[] =
{
		{
				"timerController",
				RTOffsetOf( RTSuperActor, timerController ), nullptr, nullptr
		},
		{
				"timerThread",
				RTOffsetOf( RTSuperActor, timerThread ), nullptr, nullptr
		}
};
#endif

const RTActor_class RTSuperActor::rtg_class =
{
		nullptr,

		_names,

		// states
		3, rtg_parent_state,

		&RTSuperActor_ActorClass,

		// components
		2, rtg_capsule_roles,

		// ports
		2, rtg_ports,

		// bindings
		0, nullptr,

		// ESVs
#if USE_THREADS
		sizeof( RTSuperActor::rtg_fields ) / sizeof( RTSuperActor::rtg_fields[0] ),
		RTSuperActor::rtg_fields
#else
		0, nullptr
#endif
};

const RTActor_class * RTSuperActor::getActorData( void ) const
{
	return &RTSuperActor::rtg_class;
}
