/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActorRef.h>
#include <RTDiag.h>
#include <RTSuperActor.h>

//lint -save -e1738
RTSuperActor::RTSuperActor( const RTSuperActor & other )
    : RTActor( other.context(), other.getReference() )
    , specials       (                   )
    , application    (                   )
    , frame          (                   )
    , timer          (                   )
#if USE_THREADS
    , timerController( nullptr )
    , timerThread    ( nullptr )
#endif
{
    RTDiag::panic( "Unavailable method called:\n"
		   "    'RTSuperActor( const RTSuperActor & )'" );
}
//lint -restore

RTSuperActor & RTSuperActor::operator=( const RTSuperActor & )
{
    RTDiag::panic( "Unavailable method called:\n"
		   "    'RTSuperActor::operator=( const RTSuperActor & )'" );

    //lint -unreachable
    return *this;
} //lint !e1529
