/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTTcpInBuffer.h>
#include <RTTcpSocket.h>

int RTTcpInBuffer::get( char & ch )
{
	if( get_offset >= put_offset )
	{
		// replenish buffer
		if( socket->hasData() == 0 )
			return 0;

		int count = socket->read( buffer, static_cast<int>(sizeof( buffer )) );

		if( count <= 0 )
			return -1;

		get_offset = 0;
		put_offset = count;
	}

	ch = buffer[ get_offset++ ];

	return 1;
}
