/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTTcpSocket.h>
#include <RTinet.h>
#include <RTtcp.h>

int RTTcpSocket::getLocalPort( void ) const
{
	if( _sd == INET_NO_SOCKET )
		return 0;

	RTinet_address address;
	RTinet_port    port;

	if( RTinet_getname( _sd, &address, &port ) == 0 )
		return 0;

	return static_cast<int>(port);
}
