/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTMemoryUtil.h>
#include <RTTcpSocket.h>
#include <RTinet.h>
#include <RTtcp.h>

int RTTcpSocket::getPrimary( char * address ) const
{
	if( _sd == INET_NO_SOCKET )
		return 0;

	RTinet_address primary;

	if( RTinet_primary( _sd, &primary ) == 0 )
		return 0;

	RTMemoryUtil::memcpy( address, &primary, static_cast<int>(sizeof( primary )) );

	return 1;
}
