/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTIOMonitor.h>
#include <RTMemoryUtil.h>
#include <RTTcpSocket.h>
#include <RTinet.h>
#include <RTtcp.h>

int RTTcpSocket::listen( int port )
{
	if( _sd == INET_NO_SOCKET )
		return 0;

	if( RTinet_bind( _sd, nullptr, static_cast<RTinet_port>(port) ) == 0 )
		return 0;

	if( RTinet_listen( _sd ) == 0 )
		return 0;

	_state = Listen;

	if( _monitor != nullptr )
		// incoming connections can be accepted when this socket is readable
		_monitor->add( _sd, RTIOMonitor::CanRead );

	return 1;
}
