/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTMemoryUtil.h>
#include <RTTcpSocket.h>
#include <RTinet.h>

int RTTcpSocket::lookup( const char * host, char * ip_address )
{
	if( lookup_numeric( host, ip_address ) == 0 )
	{
		RTinet_address address;

		if( RTinet_lookup( host, &address ) == 0 )
			return 0;

		RTMemoryUtil::memcpy( ip_address, &address, static_cast<int>(sizeof( address )) );
	}

	return 1;
}
