/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTTcpSocket.h>

int RTTcpSocket::lookup_numeric( const char * host, char * ip_address )
{
	int index = 0;
	int value = 0;

	for( const char * cursor = host; ; ++cursor )
	{
		if( ( '0' <= *cursor ) && ( *cursor <= '9' ) )
		{
			value *= 10;
			value += *cursor - '0';
			if( value > 255 )
				break;
		}
		else if( *cursor == '.' )
		{
			if( index >= IpAddressSize )
				break;
			ip_address[ index++ ] = static_cast<char>(value);
			value = 0;
		}
		else if( *cursor == '\0' )
		{
			if( index != IpAddressSize - 1 )
				break;
			ip_address[ index ] = static_cast<char>(value);
			return 1;
		}
		else
			break;
	}

	return 0;
}
