/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTIOMonitor.h>
#include <RTTcpSocket.h>

RTTcpSocket::State RTTcpSocket::state( void )
{
    if( _state == SynSent )
    {
	if( _monitor != nullptr )
	{
	    if( _monitor->status( _sd ) != 0 )
	    {
		if( try_connect() == 0 )
		    close(); // failed

		else if( _state == Established )
		    _monitor->remove( _sd, RTIOMonitor::CanWrite |
					   RTIOMonitor::Exception );
	    }
	}
	else
	{
	    RTIOMonitor monitor;

	    monitor.add( _sd, RTIOMonitor::CanWrite |
			      RTIOMonitor::Exception );

	    _monitor = &monitor;

	    if( monitor.status( _sd ) != 0 )
	    {
		if( try_connect() == 0 )
		    close(); // failed
	    }

	    _monitor = nullptr;
	}
    }

    return _state;
}
