/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTIOMonitor.h>
#include <RTMemoryUtil.h>
#include <RTTcpSocket.h>
#include <RTinet.h>

int RTTcpSocket::try_connect( void )
{
	RTinet_address address;

	RTMemoryUtil::memcpy( &address, _peer_ip, static_cast<int>(sizeof( address )) );

	switch( RTinet_connect( _sd, &address, static_cast<RTinet_port>(_peer_port) ) )
	{
	case 0:
		// in progress
		_state = SynSent;
		return 1;

	case 1:
		// possibly complete
		if( ( _monitor->status( _sd ) & ( RTIOMonitor::CanRead |
				RTIOMonitor::CanWrite ) ) != 0 )
		{
			_state = Established;
			return 1;
		}
		else
			return 0;

	default:
		return 0;
	}
}
