/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDiag.h>
#include <RTTcpSocket.h>
#include <RTinet.h>

//lint -save -esym(1927,RTTcpSocket::_peer_ip)

RTTcpSocket::RTTcpSocket( const RTTcpSocket & )
    : _sd       (   INET_NO_SOCKET )
    , _state    (           Closed )
    , _monitor  ( nullptr )
    , _peer_port(                0 )
{
#ifdef _lint
    for( int i = 0; i < IpAddressSize; ++i )
	_peer_ip[ i ] = 0;
#endif

    RTDiag::panic( "Unavailable method called:\n"
		   "    'RTTcpSocket( const RTTcpSocket & )'" );
}

//lint -restore

RTTcpSocket & RTTcpSocket::operator=( const RTTcpSocket & )
{
    RTDiag::panic( "Unavailable method called:\n"
		   "    'RTTcpSocket::operator=( const RTTcpSocket & )'" );

    //lint -unreachable
    return *this;
} //lint !e1529
