/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTFieldDescriptor.h>
#include <RTObject_class.h>
#include <RTTime.h>
#include <RTnew.h>

static RTSequence * _access( RTTime * target )
{
	return target;
}

static void _init( const RTObject_class *, void * target )
{
	(void)new( target ) RTTime;
}

static void _copy( const RTObject_class *,
		void                 * target,
		const void           * source )
{
	(void)new( target ) RTTime( * static_cast<const RTTime *>(source) );
}

const RTFieldDescriptor RTTime::fieldData[] =
{
		{
				"hours",
				RTOffsetOf( RTTime, hours ),
				&RTType_RTInteger, nullptr
		},
		{
				"minutes",
				RTOffsetOf( RTTime, minutes ),
				&RTType_RTInteger, nullptr
		},
		{
				"seconds",
				RTOffsetOf( RTTime, seconds ),
				&RTType_RTInteger, nullptr
		}
};

const RTObject_class RTTime::classData =
{
		&RTType_RTSequence,
		reinterpret_cast<RTSuperAccessFunction>(_access),
		"RTTime",
		0 /* RTVersionId */,
		sizeof( RTTime ),
		_init,
		_copy,
		nullptr, // Not movable
#if OBJECT_DECODE
		RTstruct_decode,
#endif
#if OBJECT_ENCODE
		RTstruct_encode,
#endif
		RTDataObject_destroy,
		3, RTTime::fieldData
};

#if OBJECT_DECODE
RTTypeInstaller RTTime_installer( RTType_RTTime );
#endif

const RTObject_class * RTTime::getClassData( void ) const
{
	return &RTTime::classData;
}
