/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTSpecialSignals.h>
#include <RTTimerActor.h>
#include <RTTimerNode.h>

void RTTimerActor::adjustTimeEnd( const RTTimespec & delta,
				  RTController     * originator )
{
    currentOffset += delta;

#if USE_THREADS
    RTTimerNode::critical.leave();
#endif

    if( delta > RTTimespec::zero ) //lint !e909
	(void)originator->send( this, RTWakeupSignal, nullptr, nullptr, System );
}
