/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTTimerActor.h>
#include <RTTimerNode.h>

void RTTimerActor::cancelAll( Timing::Base * sap )
{
    RTController * controller = sap->context();
    RTTimerNode  * node;

#if USE_THREADS
    RTTimerNode::critical.enter();
#endif

    while( (node = sap->outstanding) != nullptr )
	node->next->_cancel( controller );

#if USE_THREADS
    RTTimerNode::critical.leave();
#endif
}
