/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifdef PRAGMA
#pragma implementation "RTTimerActor.h"
#pragma implementation "RTTimerActor.inl"
#endif

#include <RTTimerActor.h>
#include <RTTimerNode.h>

RTTimerActor::~RTTimerActor( void )
{
    _soleInstance = nullptr;

    stop();

#if USE_THREADS
    RTTimerNode::critical.enter();
#endif

    pendingAbsolute.cancelAll( context() );
    pendingRelative.cancelAll( context() );

#if USE_THREADS
    RTTimerNode::critical.leave();
#endif
}
