/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActorClass.h>
#include <RTActor_class.h>
#include <RTPortDescriptor.h>
#include <RTTimerActor.h>

static RTActor * new_RTTimerActor( RTController * _rts, RTActorRef * _ref )
{
    return new RTTimerActor( _rts, _ref );
}

const RTActorClass RTTimerActor::classData =
{
	nullptr,
	"RTTimerActor",
	0 /* RTVersionId */,
    0,
	nullptr,
    new_RTTimerActor
};

static const char * const _names[] =
{
    "top"
};

const RTStateId RTTimerActor::rtg_parent_state[] =
{
    0
};

const RTActor_class RTTimerActor::rtg_class =
{
	nullptr,

    _names,

    // states
    1, rtg_parent_state,

    // RTActorClass
    &RTTimerActor::classData,

    // components
    0, nullptr,

    // ports
    0, nullptr,

    // bindings
    0, nullptr,

    // ESVs
    0, nullptr
};

const RTActor_class * RTTimerActor::getActorData( void ) const
{
    return &RTTimerActor::rtg_class;
}
