/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTController.h>
#include <RTSpecialSignals.h>
#include <RTTimerActor.h>
#include <RTTimerNode.h>

void RTTimerActor::informIn( RTTimerNode * node )
{
#if USE_THREADS
    RTTimerNode::critical.enter();
#endif

    context()->countTimerStart();

    RTTimespec now;

    RTTimespec::getclock( now );
    now -= currentOffset;
    node->expireTime += now;

    int atHead = pendingRelative.insert( node );

#if USE_THREADS
    RTTimerNode::critical.leave();

    if( atHead != 0 )
	(void)node->owner->send( this, RTWakeupSignal, nullptr, nullptr, System );
#else
    (void)atHead;
#endif
}
