/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTTimerActor.h>
#include <RTTimerNode.h>
#include <RTTimespec.h>

void RTTimerActor::sendTimeouts( void )
{
#if USE_THREADS
    RTTimerNode::critical.enter();
#endif

    RTController * controller = context();
    RTTimespec     now;

    RTTimespec::getclock( now );

    pendingAbsolute.expire( now, controller );

    // expireTime for relative time is adjusted by currentOffset

    now -= currentOffset;

    pendingRelative.expire( now, controller );

#if USE_THREADS
    RTTimerNode::critical.leave();
#endif
}
