/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTTimerActor.h>

#if ! USE_THREADS
#include <RTDiag.h>
#include <RT_time.h>
#endif

void RTTimerActor::stop( void )
{
#if ! USE_THREADS
	struct itimerval value;

	value.it_value.tv_sec  = 0L;
	value.it_value.tv_usec = 0L;

	value.it_interval = value.it_value;

	if( setitimer( ITIMER_REAL, &value, nullptr ) != 0 )
		RTDiag::panic( "setitimer(stop)" );
#endif
}
