/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTSpecialPorts.h>
#include <RTSpecialSignals.h>
#include <RTTimerActor.h>
#include <RTTimerController.h>

void RTTimerController::mainLoop( void )
{
    startup();

    enter( RTJob::running );

    while( phase() != RTJob::finished )
    {
	// process clock ticks;
	RTActor * agent = RTTimerActor::soleInstance();

	if( agent != nullptr )
	    agent->rtsBehavior( RTInterruptSignal, RTControlPort );

	if( dispatch( Background ) != OneDelivered )
	    waitForEvents();
    }

    shutdown();
}
