/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTSyncObject.h>
#include <RTTimerActor.h>
#include <RTTimerController.h>
#include <RTTimespec.h>

void RTTimerController::waitForEvents( void )
{
    RTTimerActor * timerActor = RTTimerActor::soleInstance();
    RTTimespec     timeout;

    if( timerActor == nullptr )
	_sync->wait();
    else if( timerActor->nextTimeout( timeout ) == 0 )
	_sync->wait();
    else
	_sync->timedwait( timeout );
}
