/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTTimerId.h>
#include <RTnew.h>

static void _init( const RTObject_class *, void * target )
{
	(void)new( target ) RTTimerId;
}

static void _copy( const RTObject_class *, void * target, const void * source )
{
	(void)new( target ) RTTimerId( * static_cast<const RTTimerId *>(source) );
}

const RTFieldDescriptor RTTimerId::fieldData[] =
{
		{
				"node",
				RTOffsetOf( RTTimerId, node ),
				&RTType_RTpvoid, nullptr
		}
};

#if OBJECT_DECODE
static int _decode( const RTObject_class *, void *, RTDecoding * )
{
	return 0;
}
#endif

static void _destroy( const RTObject_class *, void * target )
{
	(static_cast<RTTimerId *>(target))->~RTTimerId();
}

const RTObject_class RTTimerId::classData =
{
		nullptr,
		nullptr,
		"RTTimerId",
		0 /* RTVersionId */,
		sizeof( RTTimerId ),
		_init,
		_copy,
		nullptr, // Not movable
#if OBJECT_DECODE
		_decode,
#endif
#if OBJECT_ENCODE
		RTstruct_encode,
#endif
		_destroy,
		1, RTTimerId::fieldData
};

#if OBJECT_DECODE
RTTypeInstaller RTTimerId_installer( RTType_RTTimerId );
#endif
