/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTTimerId.h>
#include <RTTimerNode.h>

int RTTimerId::timeouts( void ) const
{
    int result = -1;

#if USE_THREADS
    RTTimerNode::critical.enter();
#endif

    if( node != nullptr && ( node->repeatInterval.tv_sec  |
				      node->repeatInterval.tv_nsec ) != 0L )
	result = node->missedIntervals;

#if USE_THREADS
    RTTimerNode::critical.leave();
#endif

    return result;
}
