/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTTimerList.h>
#include <RTTimerNode.h>

void RTTimerList::expire( const RTTimespec & now, RTController * controller )
{
    while( used != 0U )
    {
	RTTimerNode * node = nodes[ 0U ];

	if( node->expireTime > now ) //lint !e909
	    break;

	node->_timeout( controller );

	remove( node );
    }
}
