/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTMessage.h>
#include <RTTimerId.h>
#include <RTSpecialSignals.h>
#include <RTTimerNode.h>

static const RTTimerId empty;

void RTTimerNode::buildMsg( RTMessage * message,
			    RTActor   * receiver,
			    int         priority )
{
    message->setDestination( receiver, nullptr, 0 );
    message->setSignal( RTPendingTimeoutSignal );
    message->setPriority( priority );
    message->setData( &empty, &RTType_RTTimerId );
    message->internData();

    // Modify the timer id directly because the mutex is locked.
    _connect( static_cast<RTTimerId *>(message->data) );
}
