/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTController.h>
#include <RTDiag.h>
#include <RTTimerNode.h>

void RTTimerNode::_disconnect( RTTimerId * id )
{
	RTTimerNode * node = id->node;

	if( node != nullptr )
	{
		id->node = nullptr;

		id->ring.prev->next = id->ring.next;
		id->ring.next->prev = id->ring.prev;

		id->ring.prev = &id->ring;
		id->ring.next = &id->ring;

		if( node->active == 0 && node->id_ring.next == &node->id_ring )
			node->owner->freeTimerNode( node );
	}
}
