/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTFieldOffset.h>
#include <RTTimerNode.h>
#include <RTTiming.h>

void RTTimerNode::_disconnectAll( void )
{
	// remove this from the chain of node created by sap
	if( sap != nullptr)
	{
		if( sap->outstanding == this )
			sap->outstanding = ( next != this ) ? next : nullptr;

		prev->next = next;
		next->prev = prev;

		prev = this;
		next = this;
	}

	// invalidate all RTTimerId objects that refer to this node
	const RTFieldOffset offset = RTOffsetOf( RTTimerId, ring );

	while( id_ring.next != &id_ring )
	{
		RTTimerId * id = RTObjectOf( RTTimerId, - static_cast<long>(offset), id_ring.next );

		id->node = nullptr;

		id->ring.prev->next = id->ring.next;
		id->ring.next->prev = id->ring.prev;

		id->ring.prev = &id->ring;
		id->ring.next = &id->ring;
	}
}
