/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDiag.h>
#include <RTTimerNode.h>

RTTimerNode::RTTimerNode( const RTTimerNode & )
    : sap            ( nullptr                   )
    , prev           ( nullptr                   )
    , next           ( nullptr                   )
    , link           (                           )
    , owner          ( nullptr                   )
    , msg            ( nullptr                   )
    , expireTime     (                           )
    , repeatInterval (                           )
    , missedIntervals(                         0 )
    , data           ( nullptr                   )
    , type           ( nullptr                   )
    , id_ring        (                           )
    , active         (                         0 )
{
    RTDiag::panic( "Unavailable method called:\n"
		   "    'RTTimerNode( const RTTimerNode & )'" );
}

RTTimerNode & RTTimerNode::operator=( const RTTimerNode & )
{
    RTDiag::panic( "Unavailable method called:\n"
		   "    'RTTimerNode::operator=( const RTTimerNode & )'" );

    //lint -unreachable
    return *this;
} //lint !e1529
