/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTFieldDescriptor.h>
#include <RTTimespec.h>
#include <RTnew.h>

static void _init( const RTObject_class *, void * target )
{
	(void)new( target ) RTTimespec;
}

static void _copy( const RTObject_class *,
		void                 * target,
		const void           * source )
{
	(void)new( target ) RTTimespec( * static_cast<const RTTimespec *>(source) );
}

static const RTFieldDescriptor fieldData[] =
{
		{
				"tv_sec",
				RTOffsetOf( RTTimespec, tv_sec ),
				&RTType_long, nullptr
		},
		{
				"tv_nsec",
				RTOffsetOf( RTTimespec, tv_nsec ),
				&RTType_long, nullptr
		}
};

const RTObject_class RTTimespec::classData =
{
		nullptr,
		nullptr,
		"RTTimespec",
		0 /* RTVersionId */,
		sizeof( RTTimespec ),
		_init,
		_copy,
		nullptr, // Not movable
#if OBJECT_DECODE
		RTstruct_decode,
#endif
#if OBJECT_ENCODE
		RTstruct_encode,
#endif
		RTnop_destroy,
		2, fieldData
};

#if OBJECT_DECODE
RTTypeInstaller RTTimespec_installer( RTType_RTTimespec );
#endif
