/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTController.h>
#include <RTTimerActor.h>
#include <RTTiming.h>

void Timing::Base::adjustTimeEnd( const RTTimespec & delta )
{
    RTController * controller = context();
    RTTimerActor * timerActor = RTTimerActor::soleInstance();

    if( timerActor == nullptr )
    {
	controller->setError( RTController::noConnect,
			      RTController::TimerInform,
			      this, nullptr );
    }
    else
    {
	timerActor->adjustTimeEnd( delta, controller );
    }
}
