/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTActor.h>
#include <RTTimerNode.h>
#include <RTTiming.h>

int Timing::Base::cancelTimer( RTTimerId & id )
{
    RTController * controller = context();

    controller->trace( RTController::TimerCancel, this,nullptr );

    if( RTTimerNode::cancel( controller, id ) == 0 )
    {
	controller->setError( RTController::badId,
			      RTController::TimerCancel,
			      this,nullptr );
	return 0;
    }

    return 1;
}
