/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTInterval.h>
#include <RTTimespec.h>
#include <RTTiming.h>
#include <RTTypedValue.h>

RTTimerNode * Timing::Base::informIn( unsigned long        ticks,
				      const RTTypedValue & info,
				      int                  prio )
{
    RTInterval interval( ticks );
    RTTimespec delta( interval );

    return informIn( delta, info, prio );
}

RTTimerNode * Timing::Base::informIn( unsigned long ticks, int prio )
{
    RTTypedValue info( nullptr, nullptr );

    return informIn( ticks, info, prio );
}

RTTimerNode * Timing::Base::informIn( unsigned long        ticks,
				      const RTDataObject & data,
				      int                  prio )
{
    RTTypedValue info( &data, data.getClassData() );

    return informIn( ticks, info, prio );
}
