/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTToolsetObserver.h>

//lint -save
//lint -esym(1927,RTToolsetObserver::rxBuffer)
//lint -esym(1927,RTToolsetObserver::structInfo)
//lint -esym(1927,RTToolsetObserver::txBuffer)
//lint -esym(1927,RTToolsetObserver::txTempBuffer)

RTToolsetObserver::RTToolsetObserver( RTDebugger  * theDebugger,
		RTTcpSocket * theSocket,
		int           theObsId,
		const char  * initBuf,
		int           initLen )
: RTObserver( theDebugger, theSocket, theObsId, initBuf, initLen )
{
	enum
	{
		lengthSize = 4
		, dataSize   = 9999
		, bufferSize = lengthSize + dataSize
	};

	rxBuffer.size = 0;
	rxBuffer.data = nullptr;

	txBuffer.size      = dataSize;
	txBuffer.used      = 0;
	txBuffer.start     = new char [ bufferSize ];
	txBuffer.data      = &txBuffer.start[ lengthSize ];

	txTempBuffer.size  = dataSize;
	txTempBuffer.used  = 0;
	txTempBuffer.start = new char [ bufferSize ];
	txTempBuffer.data  = &txBuffer.start[ lengthSize ];

	structInfo.func            =         0;
	structInfo.ptr             = nullptr;
	structInfo.daemon.number   =         0;
	structInfo.daemon.invokeID = nullptr;
}

//lint -restore
