/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDaemonInfo.h>
#include <RTDebugger.h>
#include <RTToolsetObserver.h>

void RTToolsetObserver::handlePort( void )
{
	TO_portInfo  * myPortInfo = static_cast<TO_portInfo *>(structInfo.ptr);
	RTDaemonInfo * daemonInfo = new RTDaemonInfo;

	daemonInfo->setInfoPort( myPortInfo->actor, myPortInfo->port );

	if( structInfo.func == CMD_ADD_PORT )
	{
		int probeNr = addInfo( daemonInfo );
		if( probeNr >= 0 )
		{
			sendResultCode( RES_OK );
			debugger->getPresence( probeNr,
					observerId,
					structInfo.daemon.number );
		}
		else
		{
			sendResultCode( RES_BAD_PORT );
			delete daemonInfo;
		}
	}
	else // structInfo.func == CMD_DEL_PORT
	{
		if( delInfo( daemonInfo ) <= 0 ) // number of actors deleted
			sendResultCode( RES_BAD_PORT );
		else
			sendResultCode( RES_OK );

		delete daemonInfo;
	}
}
