/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDiag.h>
#include <RTToolsetObserver.h>

//lint -save -e1738
//lint -esym(1927,RTToolsetObserver::rxBuffer)
//lint -esym(1927,RTToolsetObserver::structInfo)
//lint -esym(1927,RTToolsetObserver::txBuffer)
//lint -esym(1927,RTToolsetObserver::txTempBuffer)

RTToolsetObserver::RTToolsetObserver( const RTToolsetObserver & )
    : RTObserver( nullptr, nullptr, 0 )
{
    rxBuffer.size = 0;
    rxBuffer.data = nullptr;

    txBuffer.size = 0;
    txBuffer.data = nullptr;

    txTempBuffer.size = 0;
    txTempBuffer.data = nullptr;

    structInfo.func            =         0;
    structInfo.ptr             = nullptr;
    structInfo.daemon.number   =         0;
    structInfo.daemon.invokeID = nullptr;

    RTDiag::panic( "Unavailable method called:\n"
		   "    'RTToolsetObserver( const RTToolsetObserver & )'" );
}

//lint -restore

RTToolsetObserver & RTToolsetObserver::operator=( const RTToolsetObserver & )
{
    RTDiag::panic( "Unavailable method called:\n"
	    "    'RTToolsetObserver::operator=( const RTToolsetObserver & )'" );

    //lint -unreachable
    return *this;
} //lint !e1529
