/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDiag.h>
#include <RTMemoryUtil.h>
#include <RTTruncatingBuffer.h>

static const char trailer[] = "...";

RTTruncatingBuffer::RTTruncatingBuffer( char * _memory, int _size )
    : RTMemoryOutBuffer( _memory, _size - sizeof( trailer ) )
{
    RTAssert( _size >= static_cast<int>(sizeof( trailer )) );

    RTMemoryUtil::memcpy( &_memory[ _size - sizeof( trailer ) ], trailer, sizeof( trailer ) );
}
