/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTMain.h>
#include <RTObject_class.h>
#include <RTWrapper.h>

RTWrapper & RTWrapper::operator=( const RTWrapper & rhs )
{
    if( this != &rhs )
    {
	RTMain::lock();

	Handle * old_handle = handle;
	int      old_count  = old_handle->ref_count -= 1;

	handle = rhs.handle;

	handle->ref_count += 1;

	RTMain::unlock();

	if( old_count == 0 )
	{
	    old_handle->type->destroy( old_handle->data,
				       RTObject_class::DestroyOnly );
	    delete [] old_handle;
	}
    }

    return *this;
}
