/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTMain.h>
#include <RTObject_class.h>
#include <RTWrapper.h>

RTWrapper::RTWrapper( const void * _data, const RTObject_class * _type )
    : handle( nullptr )
{
    RTFieldOffset allocSize;

    allocSize  = RTOffsetOf( Handle, data[ 0 ] );
    allocSize += sizeof( Handle );
    allocSize -= 1;
    allocSize += _type->_size;

    handle = new Handle [ allocSize / sizeof( Handle ) ];

    handle->ref_count = 1;
    handle->type      = _type;

    _type->copy( handle->data, _data );
}

RTWrapper::RTWrapper( const RTWrapper & other )
#ifdef _lint
    : handle( nullptr )
#endif
{
    RTMain::lock();

    handle = other.handle;

    handle->ref_count += 1;

    RTMain::unlock();
}
