/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifdef PRAGMA
#pragma implementation "RTWrapper.h"
#pragma implementation "RTWrapper.inl"
#endif

#include <RTMain.h>
#include <RTObject_class.h>
#include <RTWrapper.h>

// We release the memory only when the reference count reaches zero.
//lint -esym(1540,RTWrapper::handle)
//lint -esym(1740,RTWrapper::handle)

RTWrapper::~RTWrapper( void )
{
	RTMain::lock();

	int new_count = handle->ref_count -= 1;

	RTMain::unlock();

	if( new_count == 0 )
	{
		handle->type->destroy( handle->data, RTObject_class::DestroyOnly );
		delete [] handle;
	}
}
