/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTMemoryUtil.h>
#include <RTinet.h>
#include <RTtcp.h>

extern "C" int RTinet_bind( int                    sock,
		const RTinet_address * address,
		RTinet_port            port )
{
	sockaddr_in addr;

	RTMemoryUtil::memset( &addr, 0, static_cast<int>(sizeof( addr )) );

	addr.sin_family = AF_INET;
	addr.sin_port   = htons( port );

	if( address != nullptr )
		RTMemoryUtil::memcpy( &addr.sin_addr, address, static_cast<int>(sizeof( *address ) ));

	//lint -save -e740
	while( INET_bind( sock,
			(SocketAddress *)&addr,
			static_cast<int>(sizeof( addr )) ) != 0 )
		//lint -restore
	{
#ifdef INET_EINTR
		if( INET_error( sock ) == INET_EINTR )
			continue;
#endif

		return 0;
	}

	return 1;
}
