/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTMemoryUtil.h>
#include <RTinet.h>
#include <RTtcp.h>

extern "C" int RTinet_getname( int              sock,
		RTinet_address * address,
		RTinet_port    * port )
{
	sockaddr_in       addr;
	SocketAddressSize addr_len = sizeof( addr );

	//lint -save -e740
	while( INET_getsockname( sock,
			(SocketAddress *)&addr,
			&addr_len ) != 0 )
		//lint -restore
	{
#ifdef INET_EINTR
		if( INET_error( sock ) == INET_EINTR )
			continue;
#endif

		return 0;
	}

	RTMemoryUtil::memcpy( address, &addr.sin_addr, static_cast<int>(sizeof( *address )) );
	*port = ntohs( addr.sin_port );

	return 1;
}
