/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTMemoryUtil.h>
#include <RTinet.h>
#include <RTtcp.h>

extern "C" int RTinet_lookup( const char * host, RTinet_address * address )
{
	struct hostent * hp = INET_lookup( host );

	if( hp == nullptr )
		return 0;

	if( hp->h_length != static_cast<int>(sizeof( *address )) )
		return 0;

	RTMemoryUtil::memcpy( address, hp->h_addr, static_cast<int>(sizeof( *address )) );

	return 1;
}
