/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTinet.h>
#include <RTtcp.h>

extern "C" int RTinet_nonblocking( int sock )
{
	int flag = 1;

	//lint -save -e740 -e569 -e912 -e917
	while( INET_ioctl( sock, FIONBIO, &flag ) != 0 )
		//lint -restore
	{
#ifdef INET_EINTR
		if( INET_error( sock ) == INET_EINTR )
			continue;
#endif

		return 0;
	}

	return 1;

}
