/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTinet.h>
#include <RTtcp.h>

extern "C" int RTinet_reuseaddr( int sock )
{
	int flag = 1;

	while( INET_setsockopt( sock, SOL_SOCKET, SO_REUSEADDR, reinterpret_cast<char*>(&flag), sizeof( flag ) ) != 0 )
	{
#ifdef INET_EINTR
		if( INET_error( sock ) == INET_EINTR )
			continue;
#endif

		return 0;
	}

	return 1;
}
