/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTinet.h>
#include <RTtcp.h>

extern "C" int RTinet_UDP_create( void )
{
	int sock;

	while( (sock = INET_socket( AF_INET, SOCK_DGRAM, 0 )) == INET_NO_SOCKET )
	{
#ifdef INET_EINTR
		if( INET_error( sock ) == INET_EINTR )
			continue;
#endif

		return INET_NO_SOCKET;
	}

	if( RTinet_async      ( sock ) == 0 ||
			RTinet_nonblocking( sock ) == 0 )
	{
		RTinet_close( sock );
		return INET_NO_SOCKET;
	}

	return sock;
}
