/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTinet.h>
#include <RTtcp.h>

extern "C" int RTinet_write( int sock, const char * data, int size )
{
	int count;

	while( (count = INET_send( sock, data, size, 0 )) < 0 )
	{
		int err = INET_error( sock );

#ifdef INET_EINTR
		if( err == INET_EINTR )
			continue;
#endif

#ifdef INET_EWOULDBLOCK
		if( err == INET_EWOULDBLOCK )
			return 0;
#endif

		return -1;
	}

	return count;
}
