/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTCmdLineObserver_h__
#define __RTCmdLineObserver_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTObserver_h__
#include <RTObserver.h>
#endif

class RTCmdLineObserver : public RTObserver
{
public:
		RTCmdLineObserver( RTDebugger  *,
				   RTTcpSocket *,
				   int           id,
				   const char  * initBuf = nullptr,
				   int           initLen = 0 );

    virtual     ~RTCmdLineObserver( void );

    virtual int evtRtsStatus( int daemonId, const RTEventInfo & ) override;

    virtual int receiveData( void ) override;

private:
    // unavailable methods
    RTCmdLineObserver( const RTCmdLineObserver & );
    RTCmdLineObserver & operator=( const RTCmdLineObserver & );
}; //lint !e1712

#endif // __RTCmdLineObserver_h__
