/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTDiag_h__
#define __RTDiag_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTConfig_h__
#include <RTConfig.h>
#endif

class RTDiagStream;

class RTDiag
{
public:
    static void failed_assertion( const char * expr,
				  const char * file,
				  int          line );
    static void panic( const char * );

    static RTDiagStream & out( void );
};

#ifndef RTAssert
#if OTRTSDEBUG == DEBUG_NONE
#define RTAssert( expr ) ( (void)0 )
#else
#define RTAssert( expr ) \
    if( expr ) { } else RTDiag::failed_assertion( #expr, __FILE__, __LINE__ )
#endif
#endif

#endif // __RTDiag_h__
