/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTDiagBuffer_h__
#define __RTDiagBuffer_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTStreamBuffer_h__
#include <RTStreamBuffer.h>
#endif

class RTDiagStream;

class RTDiagBuffer : public RTStreamBuffer
{
public:
    explicit    RTDiagBuffer( RTDiagStream * );
    virtual     ~RTDiagBuffer( void );

    virtual int flush( void ) override;

private:
    RTDiagStream * out;

private:
    // unavailable methods
    RTDiagBuffer( const RTDiagBuffer & );
    RTDiagBuffer & operator=( const RTDiagBuffer & );
}; //lint !e1712

#endif // __RTDiagBuffer_h__
