/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTLogBuffer_h__
#define __RTLogBuffer_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTLog_h__
#include <RTLog.h>
#endif

#ifndef __RTStreamBuffer_h__
#include <RTStreamBuffer.h>
#endif

class RTLogBuffer : public RTStreamBuffer
{
public:
    explicit    RTLogBuffer( Log::Base * );
    virtual     ~RTLogBuffer( void );

    virtual int flush( void ) override;

private:
    Log::Base * log;

private:
    // unavailable methods
    RTLogBuffer( const RTLogBuffer & );
    RTLogBuffer & operator=( const RTLogBuffer & );
}; //lint !e1712

#endif // __RTLogBuffer_h__
