/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTProbe_inl__
#define __RTProbe_inl__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTProbe_h__
#include <RTProbe.h>
#endif

RTS_INLINE int RTProbe::adjustRefCount( int offset )
{
    return _refCount += offset;
}

RTS_INLINE const char * RTProbe::getStringPath( void ) const
{
    return _stringPath;
}

RTS_INLINE int RTProbe::getActorIndex( void ) const
{
    return _actorIndex;
}

RTS_INLINE int RTProbe::getProbeId( void ) const
{
    return _id;
}

RTS_INLINE int RTProbe::cmdline( void ) const
{
    return _owner == 0;
}

RTS_INLINE int RTProbe::connected( void ) const
{
    return _actor != nullptr;
}

RTS_INLINE RTActor * RTProbe::actor( void ) const
{
    return _actor;
}

#endif // __RTProbe_inl__
