/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTQueue_inl__
#define __RTQueue_inl__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTQueue_h__
#include <RTQueue.h>
#endif

RTS_INLINE RTQueue::RTQueue( void )
    : head( nullptr )
    , tail( nullptr )
{
}

RTS_INLINE int RTQueue::isEmpty( void ) const
{
    return head == nullptr;
}

RTS_INLINE RTQueue::Iterator::Iterator( void )
    : block( nullptr )
    , index( 0 )
{
}

RTS_INLINE RTQueue::Iterator::Iterator( const RTQueue & queue )
    : block( queue.head )
    , index( 0 )
{
}

RTS_INLINE RTQueue::Iterator::~Iterator( void )
{
#ifdef _lint
    block = nullptr;
#endif
}

#endif // __RTQueue_inl__
