/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTRecallFilter_h__
#define __RTRecallFilter_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTQFilter_h__
#include <RTQFilter.h>
#endif

class RTController;
class RTMessage;
class RTProtocol;

class RTRecallFilter : public RTQFilter
{
public:
    enum Options
    {
	      Front,       Back,       IndexFront,       IndexBack,
	SignalFront, SignalBack, SignalIndexFront, SignalIndexBack
    };

		    RTRecallFilter( RTController *,
				    RTProtocol   *,
				    Options        options,
				    int            signal = 0,
				    int            index  = 0 );

    virtual         ~RTRecallFilter( void );

    virtual int     select( RTMessage & ) override;
    virtual void    accept( RTMessage & ) override;

private:
    RTController * context;
    RTMessage    * recallToFront;
    RTProtocol   * port;
    int            options;
    int            signal;
    int            index;

    // unavailable methods
    RTRecallFilter & operator=( const RTRecallFilter & );
    RTRecallFilter( const RTRecallFilter & );
}; //lint !e1712

#endif // __RTRecallFilter_h__
