/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTTcpOutBuffer_h__
#define __RTTcpOutBuffer_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTStreamBuffer_h__
#include <RTStreamBuffer.h>
#endif

class RTTcpSocket;

class RTTcpOutBuffer : public RTStreamBuffer
{
public:
    explicit    RTTcpOutBuffer( RTTcpSocket * );
    virtual     ~RTTcpOutBuffer( void );

    virtual int flush( void ) override;

private:
    RTTcpSocket * socket;

private:
    // unavailable methods
    RTTcpOutBuffer( const RTTcpOutBuffer & );
    RTTcpOutBuffer & operator=( const RTTcpOutBuffer & );
}; //lint !e1712

#endif // __RTTcpOutBuffer_h__
