/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTTimerController_h__
#define __RTTimerController_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTPeerController_h__
#include <RTPeerController.h>
#endif

class RTTimerController : public RTPeerController
{
public:
    explicit        RTTimerController( RTDebugger * );
    virtual         ~RTTimerController( void );

    virtual void    mainLoop( void ) override;
    virtual void    printStats( void ) const override;

protected:
    virtual void    waitForEvents( void ) override;

private:
    // unavailable methods
    RTTimerController( const RTTimerController & );
    RTTimerController & operator=( const RTTimerController & );
}; //lint !e1712

#endif // __RTTimerController_h__
