/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDiag.h>
#include <RTMutex.h>

RTMutex::RTMutex( void )
{
    pthread_mutexattr_t mutexattr;

    if( pthread_mutexattr_init( &mutexattr ) != 0 )
	RTDiag::panic( "pthread_mutexattr_init" );

    if( pthread_mutex_init( &mutex, &mutexattr ) != 0 )
	RTDiag::panic( "pthread_mutex_init" );

    if( pthread_mutexattr_destroy( &mutexattr ) != 0 )
	RTDiag::panic( "pthread_mutexattr_destroy" );
}
