/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDiag.h>
#include <RTSyncObject.h>

RTSyncObject::RTSyncObject( void )
    : RTMutex()
    , signalled( 0 )
{
    pthread_condattr_t condattr;

    if( pthread_condattr_init( &condattr ) != 0 )
	RTDiag::panic( "pthread_condattr_init" );

    if( pthread_cond_init( &cv, &condattr ) != 0 )
	RTDiag::panic( "pthread_cond_init" );

    if( pthread_condattr_destroy( &condattr ) != 0 )
	RTDiag::panic( "pthread_condattr_destroy" );
}
