/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDiag.h>
#include <RTTimespec.h>

#include <sys/time.h>

void RTTimespec::getclock( RTTimespec & ts )
{
    struct timeval  now;
    struct timezone zone;

    if( gettimeofday( &now, &zone ) != 0 )
	RTDiag::panic( "gettimeofday" );

    ts.tv_sec  = now.tv_sec;
    ts.tv_nsec = now.tv_usec * 1000L;
}
