/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTSyncObject.h>
#include <RTThread.h>
#include <RTThreadInfo.h>

RTThread::RTThread( RTJob * job, int stack_size, int prio )
    : _job ( job              )
    , _done( new RTSyncObject )
    , _info( new RTThreadInfo )
{
    // Create a new 'thread'. The new thread should have at least 'stack_size'
    // bytes of stack space. It should execute at priority 'prio'. The thread
    // should execute 'RTThread::run( this )'. Any extra, target-specific
    // information should be held in an instance of RTThreadInfo, if necessary.
}
