/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifdef PRAGMA
#pragma implementation "RTDiag.h"
#endif

#include <RTDiag.h>
#include <RTDiagStream.h>
#include <RTstdio.h>

void RTDiag::panic( const char * message )
{
    static bool suppressed = false;

    if( ! suppressed )
    {
	suppressed = true;

	RTDiagStream & diag = RTDiag::out();

	diag.lock() << "panic: " << message << "\n";
	diag.unlock();

	_exit( 1 );
    }
}
