/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#ifndef __RTSyncObject_h__
#define __RTSyncObject_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTConfig_h__
#include <RTConfig.h>
#endif

struct RTTimespec;

#include <windows.h>

class RTSyncObject
{
protected:
    HANDLE  event;

public:
	    RTSyncObject( void );
	    ~RTSyncObject( void );

    void    signal( void );
    void    wait( void );
    void    timedwait( const RTTimespec & );

private:
    // unavailable methods
    RTSyncObject( const RTSyncObject & );
    RTSyncObject & operator=( const RTSyncObject & );
};

#endif // __RTSyncObject_h__
