/*
 * Licensed Materials - Property of HCL and/or IBM
 * Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
 * Copyright IBM Corporation 1999, 2016. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights -  Use, duplication or 
 * disclosure restricted by GSA ADP Schedule.
 */

#include <RTDiag.h>
#include <RTSyncObject.h>
#include <RTTimespec.h>

void RTSyncObject::timedwait( const RTTimespec & expireTime )
{
	// Units of time are expressed in milliseconds on NT.
	const long clock_period = 1000000L;
	long       delta;

	if( (delta = expireTime.ticksFromNow( clock_period )) <= 0L )
	{
		// timeout is now or in the past
	}
	else if( WaitForSingleObject( event, static_cast<DWORD>(delta) ) == WAIT_FAILED )
	{
		RTDiag::panic( "WaitForSingleObject" );
	}
}
