#! perl -w

# Licensed Materials - Property of HCL and/or IBM
# Copyright HCL Technologies Ltd. 2016, 2021. All Rights Reserved.
# Copyright IBM Corporation 1999, 2016. All Rights Reserved.
#
# U.S. Government Users Restricted Rights -  Use, duplication or 
# disclosure restricted by GSA ADP Schedule.



if( $#ARGV < 0 )
{
    print STDERR "Usage: ${0} [-f] file ...\n";
    exit 1;
}

$force = 0;

if( $ARGV[0] eq '-f' )
{
    $force = 1;
    shift @ARGV;
}

foreach $file ( @ARGV )
{
    if( ! unlink( $file ) && ! $force )
    {
	print STDERR "$file: $!\n";
	exit 1;
    }
}
