/* ;rt-indent: 0;rt-indent-char-sp; */
#ifndef RTJsonDecoding_h
#define RTJsonDecoding_h

#ifdef PRAGMA
#pragma interface "RTJsonDecoding.h"
#endif
#include "UnitName_TCPLib.h"


//{{{USR platform:/resource/LibTcpServer/LibTCPServer.emx#_t7DdAPJaEeiUbIS8Ru5zVw|General|Header
#ifndef __RTJsonDecoding_h__
#define __RTJsonDecoding_h__ included

#ifndef __RTDecoding_h__
#include <RTDecoding.h>
#endif
#include <string>

namespace Poco {
	namespace Dynamic {
		class Var;
	}
}

class RTJsonDecoding : public RTDecoding
{
public:
    explicit RTJsonDecoding(const std::string& data, const std::string& type);
    virtual ~RTJsonDecoding(void);

    // All the get/put functions return an int which is non-zero
    // if the operation was successful. Otherwise, the following
    // function may be called to discover the reason for the
    // failure.
    int         getError( void );

    virtual int get( void **, const RTObject_class ** );

    // basic data types
    virtual int get_address ( void         * & );
    virtual int get_bool    ( bool           & );
    virtual int get_char    ( char           & );
#if RTUseFloatingPoint
    virtual int get_double  ( double         & );
    virtual int get_float   ( float          & );
#endif
    virtual int get_int     ( int            & );
    virtual int get_long    ( long           & );

	virtual int get_unsignedint( unsigned int & );
	virtual int get_unsignedlong( unsigned long & );
	virtual int get_unsignedshort( unsigned short & );
	virtual int get_unsignedchar( unsigned char & );
#if 0
#if _MSC_VER > 1000
    virtual int get_long_long( __int64 &  );
#else
    virtual int get_long_long( long long &  );
#endif
#endif

    virtual int get_short   ( short          & );
    virtual int get_uchar   ( unsigned char  & );
    virtual int get_unsigned( unsigned       & );
    virtual int get_ulong   ( unsigned long  & );
    virtual int get_ushort  ( unsigned short & );

    // a nul-terminated string
    virtual int get_string( char * & );

    // zero or more raw bytes
    virtual int get_opaque( int &, char * & );

    // an enumerated value
    virtual int get_enum( int &, int, const RTFieldDescriptor * );

    // a homogeneous array of objects
    virtual int get_array( void *, int, const RTObject_class * );

    // an indirect object
    virtual int get_indirect( void *, const RTObject_class * );

    // a structure
    virtual int get_struct( void *, const RTObject_class * );

protected:
    int                 getName( char * value, int length );
    RTUnknownObject   * getUnknown( const char * );

private:
    enum              { UngetMax = 3 };

    int                 unget_size;
    char                unget_buffer[ UngetMax ];
    const std::string&  input;
    const std::string&	expectedType;
    Poco::Dynamic::Var*	currentDataObj; // Currently processed data object in the parse tree

    // unavailable methods
    RTJsonDecoding( const RTJsonDecoding & );
    RTJsonDecoding & operator=( const RTJsonDecoding & );
}; //lint !e1712

#endif // __RTJsonDecoding_h__
//}}}USR
#endif
