/* ;rt-indent: 0;rt-indent-char-sp; */
// /*******************************************************************************
//  * (c) Copyright HCL Technologies Ltd. 2018.  MIT Licensed!
//  *******************************************************************************/
#ifndef TCPServer_h
#define TCPServer_h

#ifdef PRAGMA
#pragma interface "TCPServer.h"
#endif
#include <UnitName_TCPLib.h>
#include <TCPServerControl.h>
#include <TCPServer_Config.h>
class ITCPConnection;
//{{{USR platform:/resource/LibTcpServer/LibTCPServer.emx#_5rHTMO5TEeitL-zKjjNp2A|General|headerPreface
#include <string>
using namespace std;
namespace Poco {
	namespace Net {
		class TCPServer;
	}
}

//}}}USR
#define SUPER RTActor
class TCPServer_Actor : public RTActor
{
public:
//{{{USR platform:/resource/LibTcpServer/LibTCPServer.emx#_5rHTMO5TEeitL-zKjjNp2A|General|publicDeclarations
friend class LocalServerConnection;
//}}}USR
    TCPServer_Actor( RTController * rtg_rts, RTActorRef * rtg_ref );
    virtual ~TCPServer_Actor( void );
    TCPServer_Actor( const TCPServer_Actor & ) = delete;
    TCPServer_Actor & operator=( TCPServer_Actor & ) = delete;
protected:
    External::Base external;
    TCPServerControl::Base control;
    TCPServer_Config config;
private:
    Poco::Net::TCPServer* srv;
public:
    virtual void onRequestReceived( const std::string& str );
private:
    void handleReceivedMessageDefault( const std::string& str, ITCPConnection* conn );
protected:
    virtual void handleReceivedMessageCustom( const std::string& str, ITCPConnection* conn );
public:
    virtual void unexpectedMessage( void );
    virtual void init( void );
private:
    void handleResponseForOutMessage( const std::string& response );
public:
    string getPorts( void );
protected:
    INLINE_METHODS void enter2_WaitForRequest( void );
    virtual void enterStateV( void ) override;
    INLINE_METHODS void transition1_Initial( const void * rtdata, RTProtocol * rtport );
    INLINE_METHODS void transition2_requestReceived( const void * rtdata, External::Base * rtport );
private:
    INLINE_CHAINS void chain1_Initial( void );
    INLINE_CHAINS void chain2_requestReceived( void );
    INLINE_CHAINS void chain3_stop( void );
public:
    virtual void rtsBehavior( int signalIndex, int portIndex ) override;
    static const RTStateId rtg_parent_state[];
    virtual const RTActor_class * getActorData( void ) const override;
protected:
    static const RTActor_class rtg_class;
private:
    static const RTPortDescriptor rtg_ports[];
public:
    static const RTFieldDescriptor rtg_TCPServer_Actor_fields[];
    virtual int _followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex ) override;
};
#undef SUPER
extern const RTActorClass TCPServer;
#endif /* TCPServer_h */
