<?xml version="1.0"?>
<!--                                                                        -->
<!-- Licensed Materials - Property of IBM                                   -->
<!-- Copyright IBM Corp. 2003, 2007.  All Rights Reserved.                  -->
<!--                                                                        -->
<!-- US Government Users Restricted Rights - Use, duplication or disclosure -->
<!-- restricted by GSA ADP Schedule Contract with IBM Corp.                 -->
<!--                                                                        -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
>
    <xsl:output method="html"/>
    
    <!-- Load the string table -->
    <xsl:variable name="trace_stringTable" select="document($trace_stringTableFileName)"/>

    <!-- Look up the parameter key in the localized string table (loaded in the variable stringTable 
       based on the passed in parameter stringTableFileName).  If the key cannot be found then the 
       returned string will be !<key>!.
       
       Parameters:
       trace_key - the look up key matched to the key attribute of string elements in the lookup table
   -->
	
    <xsl:template name="trace_getLocalizedString">
        <xsl:param name="trace_key"/>
        <xsl:variable name="lookupString" select="$trace_stringTable/strings/string[@key=$trace_key]"/>
        <xsl:choose>
            <xsl:when test="$lookupString != ''">
                <xsl:value-of select="$lookupString"/>
            </xsl:when>
            <xsl:otherwise>
                <xsl:element name="a">
                    <xsl:attribute name="name">MISSING_L10N_KEY</xsl:attribute>
                    <xsl:text>!!</xsl:text>
                    <xsl:value-of select="$trace_key"/>
                    <xsl:text>!!</xsl:text>
                </xsl:element>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>

</xsl:stylesheet>